unit TTT3D2000;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, MPlayer, ComCtrls, ScktComp;
                                         // Computer - Mensch
 const RWerte:Array[1..8]of Integer=(1,2,3,4,5,6,7,8); // grottenschlecht!!!
       MinInt=-300000;MaxInt=300000;WarteZeit=200;
       Gut:Array[1..64]of Byte=(49,52,61,64, 1, 4,13,16,38,39,42,43,22,23,26,27,
                                 2, 3, 5, 6, 7, 8, 9,10,11,12,14,15,17,18,19,20,
                                21,24,25,28,29,30,31,32,33,34,35,36,37,40,41,44,
                                45,46,47,48,50,51,53,54,55,56,57,58,59,60,62,63);

type
      Inhalt=Record
              Art,Anzahl:Byte;
              wo:Array[1..7]of Byte // maximale Anzahl von Gewinnreihen
             End;
      BInhalt=Record Wert,Anzahl:Byte End;
      Nr=Record FeldNr:Array[1..4]of Byte End;
      SpielFeld=Array[1..64]of Inhalt;
      Bewertung=Array[1..??]of BInhalt;
      SpielZug=Byte;
      SpielZugListe=Array[1..64]of SpielZug;
      Spieler=(Computer,Mensch);

  TTTT3D =class(TForm)
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Start: TMenuItem;
    Staerke: TMenuItem;
    N1Anfaenger: TMenuItem;
    N2Geuebter: TMenuItem;
    N3Erfahrener: TMenuItem;
    N4Fortgeschrittener: TMenuItem;
    N5Koenner: TMenuItem;
    N6Meister: TMenuItem;
    N7Grossmeister: TMenuItem;
    N8Weltmeister: TMenuItem;
    N9Genie: TMenuItem;
    N10Superhirn: TMenuItem;
    N11AlbertEinstein: TMenuItem;
    Einstellungen: TMenuItem;
    Menschbeginnt: TMenuItem;
    Computerbeginnt: TMenuItem;
    MenschgegenMensch: TMenuItem;
    Service: TMenuItem;
    Zugruecknahme: TMenuItem;
    Zugvorschlag: TMenuItem;
    Zugbewertung: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    Regeln: TMenuItem;
    FeldPanel: TPanel;
    Ende: TMenuItem;
    Status: TPanel;
    StatusText: TStaticText;
    TiefeText: TStaticText;
    Panel1: TPanel;
    LabelStatus: TLabel;
    Panel2: TPanel;
    LabelTiefe: TLabel;
    Panel3: TPanel;
    LabelZug: TLabel;
    LabelEnde: TLabel;
    ZugNrText: TStaticText;
    Panel4: TPanel;
    LabelZugNr: TLabel;
    LabelMensch: TLabel;
    LabelComputer: TLabel;
    MediaPlayer: TMediaPlayer;
    Ausgabe: TRichEdit;
    Ton: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    WarnHinweis: TMenuItem;
    SpielFeldAusgabe: TImage;
    ComputerStein: TImage;
    MenschStein: TImage;
    LabelCS: TLabel;
    LabelMS: TLabel;
    LabelW: TLabel;
    CSStein: TImage;
    MSStein: TImage;
    WStein: TImage;
    N12Cray1: TMenuItem;
    N13CrayXMP: TMenuItem;
    N14DeepBlue: TMenuItem;
    N15PacificBlue: TMenuItem;
    N16ASCIWhite: TMenuItem;
    N17HAL: TMenuItem;
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
    Netzwerkspiel: TMenuItem;
    Netzwerkverbindung: TMenuItem;
    Abbruch: TMenuItem;
    procedure StartClick(Sender: TObject);
    procedure LevelWahl(Sender: TObject);
    procedure WerBeginnt(Sender: TObject);
    procedure EndeClick(Sender: TObject);
    procedure ZugbewertungClick(Sender: TObject);
    procedure SpielFeldAusgabeMouseDown(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
    procedure ZugvorschlagClick(Sender: TObject);
    procedure ZugruecknahmeClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure Sound(Datei:String);
    procedure CopyRight;
    procedure CopyRightName(var Name:String);
    procedure FeldAusgabe;
    procedure SpielFeldAnzeige(SF:SpielFeld);
    procedure GenZugListe(var F:SpielFeld;Amzug:Spieler;var N:Byte;
                          var ZL:SpielZugListe);
    function Wert(var B:Bewertung):Integer;
    function Max(X,Y:Integer):Integer;
    function Min(X,Y:Integer):Integer;
    procedure MachZug(var F:SpielFeld;var B:Bewertung;Zug:SpielZug;Amzug:Byte);
    function Remis(var B:Bewertung):Boolean;
    function Schluss(var B:Bewertung):Boolean;
    procedure SucheZug(var BestZug:SpielZug;var AlphaBeta:Integer;B:Bewertung;
                       N:Byte;F:SpielFeld;Amzug:Spieler;Alpha,Beta:Integer);
    procedure SpielEnde;
    procedure SchreibZugNummer(Nr:Integer);
    procedure ComputerZug;
    procedure SuchZug(var Zug:SpielZug;SF:SpielFeld;SB:Bewertung);
    procedure Init;
    procedure NameErmitteln(Name:String;var SpielerName:String);
    procedure TonClick(Sender: TObject);
    procedure Spielverlauf;
    function TimeSekunden:Extended;
    procedure Delay(Zeit:DWord);// Pausenzeit in Millisekunden
    procedure FormCreate(Sender: TObject);
    procedure WarnHinweisClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure UpdateCaption;
    procedure ClientSocketConnect(Sender: TObject;Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;Socket: TCustomWinSocket);
    procedure SocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure NetzwerkverbindungClick(Sender: TObject);
    procedure ServerSocketClientConnect(Sender: TObject;
                                        Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
                                           Socket: TCustomWinSocket);
    procedure AbbruchClick(Sender: TObject);
    procedure DisConnect;
    procedure Hinweis(T:String);
    procedure ZugAuswertung(Meldung:String);
  private
    { Private-Deklarationen }
     Reihe:Array[1..??]of Nr;
     wo:Array[1..64]of TPoint;
     F,FAlt:SpielFeld;
     B:Bewertung;
     SpielListe:Array[0..64]of SpielFeld;
     Werte:Array[0..64]of Bewertung;
     WerZieht:Spieler;
     Level,Tiefe,ZugNummer:Byte;
     Cont,MaxX,MaxY,NetzWarteZeit:Integer;
     Geheim,SpielerName,Spieler1,Spieler2,Servername:String;
     Warnung,SoundAn,DarfSpielen,Anzeigen,ZweiSpielerModus,
     Connected,IsServer,ShallMove,VerbindungVorhanden,Dran,NetzSpiel:Boolean;
     Rot,Gruen,Leer,Bild,GruenSieg,GruenGesetzt,RotGesetzt,RotSieg,Warn:TBitMap;
  public
    { Public-Deklarationen }
  End;

var TTT3D: TTTT3D;

implementation

uses Passwort, Info, Regeln;

{$R *.DFM}
{$R+,Q+} // die Bereichsberprfung und die berlaufprfung ist aktiviert
         //         Arrays                   Wertebereich

 function TTTT3D.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  Begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  End;

 procedure TTTT3D.Delay(Zeit:DWord);// Pausenzeit in Millisekunden
  var AltZeit:DWord;
  begin
   AltZeit:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-AltZeit>Zeit
  end;

 procedure TTTT3D.Hinweis(T:String);
  begin
   Application.MessageBox(PChar(T),'Hinweis',64); // String in PChar umwandeln
  end;
{****************************************************************************}
{*                         Geheimzahl berechnen                             *}
{****************************************************************************}
 procedure TTTT3D.CopyRight;
  var Name:String;
      K,LA:Byte;
  Begin
   RandSeed:=3062;Name:='D_';Geheim:='';LA:=223;
   for K:=1 to 6 do
    Geheim:=Geheim+char(32+(ord(Name[K])-Random(LA)+LA-32) mod LA);
  End;

 procedure TTTT3D.CopyRightName(var Name:String);
  var I:Byte; Code:String;
  begin
   RandSeed:=13;Code:='zы';Name:='';
   for I:=1 to Length(Code) do
    Name:=Name+char((ord(Code[I])-random(128)) and 255);
  end;
{****************************************************************************}
{*                         Ausgabe des Spielfeldes                          *}
{****************************************************************************}
 procedure TTTT3D.FeldAusgabe;
  var E,Z,S:Byte;
      XStart,XAnfang,DY,DX,EDX,Y,YAnfang:Integer;
      Rect:TRect;
  Begin
   SpielFeldAusgabe.Canvas.Brush.Color:=clYellow;
   Rect.Left:=0;Rect.Top:=0;Rect.Right:=MaxX;Rect.Bottom:=MaxY;
   SpielFeldAusgabe.Canvas.FillRect(Rect);// Feld lschen
   DX:=15;DY:=26;EDX:=44;XAnfang:=22;YAnfang:=MaxY-40;
   for E:=0 to 3 do
    for Z:=0 to 3 do
     Begin
      XStart:=XAnfang+Z*DX;Y:=YAnfang-Z*DY-E*114;
      for S:=0 to 3 do
       Begin
        wo[4*Z+S+1+16*E].X:=XStart+S*EDX;
        wo[4*Z+S+1+16*E].Y:=Y
       End;
     End;
  End;
{****************************************************************************}
{*                         nderungen des Spielfeldes                       *}
{****************************************************************************}
 procedure TTTT3D.SpielFeldAnzeige(SF:SpielFeld);
  var K:Byte;
  Begin
   with SpielFeldAusgabe.Canvas do
    Begin
     for K:=1 to 64 do
      Begin
       if SF[K].Art=1 then Bild:=Rot; // Computer
       if SF[K].Art=2 then Bild:=Gruen; // Mensch
       if SF[K].Art=3 then Bild:=RotSieg; // Computersieg
       if SF[K].Art=4 then Bild:=GruenSieg; // Menschsieg
       if SF[K].Art=11 then Bild:=RotGesetzt; // ComputerMarkierung
       if SF[K].Art=12 then Bild:=GruenGesetzt; // MenschMarkierung
       if SF[K].Art=0 then Bild:=Leer; // Leer
       Draw(wo[K].X,wo[K].Y,Bild);
      End;
    End
  End;
{****************************************************************************}
{*                         Spiel - Prozeduren                               *}
{****************************************************************************}
 procedure TTTT3D.GenZugListe(var F:SpielFeld;Amzug:Spieler;var N:Byte;
                              var ZL:SpielZugListe);
  var K:Byte;
  Begin
   N:=0;
   // hier fehlt was!!!
  End;

 function TTTT3D.Wert(var B:Bewertung):Integer;
  var T:Byte;
      SP,Com:Integer;
  Begin
   SP:=0;Com:=0;
   for T:=1 to ?? do
    if B[T].Wert=1 then Com:=Com+RWerte[B[T].Anzahl]
    else
     if B[T].Wert=2 then SP:=SP+RWerte[B[T].Anzahl+4];
   Wert:=Com-SP;inc(Cont)
  End;

 function TTTT3D.Max(X,Y:Integer):Integer;
  Begin if X<Y then Max:=Y else Max:=X End;

 function TTTT3D.Min(X,Y:Integer):Integer;
  Begin if X<Y then Min:=X else Min:=Y End;

 procedure TTTT3D.MachZug(var F:SpielFeld;var B:Bewertung;Zug:SpielZug;Amzug:Byte);
  var L:Byte;
  Begin
   F[Zug].Art:=Amzug;
   for L:=1 to F[Zug].Anzahl do
    with B[F[Zug].wo[L]] do
     Begin Wert:=Wert or Amzug;inc(Anzahl) End
  End;

 function TTTT3D.Remis(var B:Bewertung):Boolean;
  var K:Byte;
  Begin
   Remis:=False;
   for K:=1 to ?? do
    if B[K].Wert<3 then Exit;
   Remis:=True
  End;

 function TTTT3D.Schluss(var B:Bewertung):Boolean;
  var K:Byte;
  Begin
   for K:=1 to ?? do
    if B[K].Wert<3 then
     if B[K].Anzahl=4 then Begin Schluss:=True;Exit End;
   Schluss:=False
  End;

 procedure TTTT3D.SucheZug(var BestZug:SpielZug;var AlphaBeta:Integer;
               B:Bewertung;N:Byte;F:SpielFeld;Amzug:Spieler;Alpha,Beta:Integer);
  var VirFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirBewertung:Bewertung;
      M:Integer;
      Ebene,Spalte,Zeile,I,Anzahl:Byte;
      AbZeile:String;
  Begin
   if (N=0) or Schluss(B) or Remis(B) then AlphaBeta:=Wert(B)
   else
    Begin
     GenZugListe(F,Amzug,Anzahl,ZugListe);
     if Amzug=Computer then
      Begin
       M:=Alpha;I:=0;
       while (I<Anzahl) and (M<Beta) do
        Begin
         VirFeld:=F;VirBewertung:=B;inc(I);Zug:=ZugListe[I];
         MachZug(VirFeld,VirBewertung,Zug,1);
         SucheZug(BestZug,AlphaBeta,VirBewertung,N-1,VirFeld,Mensch,M,Beta);
         if (N=Tiefe) and Anzeigen then
          Begin
           Ebene:=Zug div 16+1;if Zug mod 16=0 then dec(Ebene);
           Spalte:=Zug mod 4;Zeile:=(Zug-(Ebene-1)*16) div 4+1;
           if Spalte=0 then Begin Spalte:=4;dec(Zeile) End;
           AbZeile:='Wert von E'+IntToStr(5-Ebene)+' S'+IntToStr(Spalte)+' Z'
                                       +IntToStr(5-Zeile);
           AbZeile:=AbZeile+'='+IntToStr(AlphaBeta);
           Ausgabe.Lines.Add(AbZeile);
           AbZeile:=IntToStr(Cont)+' analysierte Stellungen';
           Ausgabe.SelAttributes.Color:=clBlue;
           Ausgabe.Lines.Add(AbZeile);
           Ausgabe.SelAttributes.Color:=clBlack
          End;
         if M<AlphaBeta then
          Begin
           M:=AlphaBeta;
           if N=Tiefe then
            Begin
             BestZug:=Zug;
             if Anzeigen then
              Begin
               Ebene:=BestZug div 16+1;if BestZug mod 16=0 then dec(Ebene);
               Spalte:=BestZug mod 4;Zeile:=(BestZug-(Ebene-1)*16) div 4+1;
               if Spalte=0 then Begin Spalte:=4;dec(Zeile) End;
               AbZeile:='bisher bester ComputerZug :E'+IntToStr(5-Ebene)+' S'
                                      +IntToStr(Spalte)+' Z'+IntToStr(5-Zeile);
               AbZeile:=AbZeile+'='+IntToStr(AlphaBeta);
               Ausgabe.SelAttributes.Color:=clRed;
               Ausgabe.Lines.Add(AbZeile);
               Ausgabe.SelAttributes.Color:=clBlack;
              End
            End
          End
        End
      End
     else
      Begin
       M:=Beta;I:=0;
       while (I<Anzahl) and (M>Alpha) do
        Begin
         VirFeld:=F;VirBewertung:=B;inc(I);Zug:=ZugListe[I];
         MachZug(VirFeld,VirBewertung,Zug,2); // Simulation des Gegners
         SucheZug(BestZug,AlphaBeta,VirBewertung,N-1,VirFeld,Computer,Alpha,M);
         if M>AlphaBeta then M:=AlphaBeta
        End
      End;
     AlphaBeta:=M
    End
  End;

{****************************************************************************}
{*       Endabrechnung, Computer- und Menschzug, Utilities                  *}
{****************************************************************************}
 procedure TTTT3D.Sound(Datei:String);
  Begin
   Screen.Cursor:=crHourglass;
   try
    MediaPlayer.DeviceType:=dtAutoSelect; // dtWaveAudio;
    MediaPlayer.FileName:=Datei;
    MediaPlayer.Open;
    MediaPlayer.wait:=True;
    MediaPlayer.Play;
    MediaPlayer.Close;
   except
    on EMCIDeviceError do
     MessageDlg('Die Datei '+Datei+' wurde NICHT gefunden!',mtError,[mbRetry],0)
    End;
   Screen.Cursor:=crHandPoint
  End;

 procedure TTTT3D.Spielverlauf;
  var K:Byte;
      Feld:SpielFeld;
  Begin
   if ZugNummer>1 then
    Begin
     if MessageDlg('Soll ich den ganzen Spielverlauf Zeigen?',
                    mtConfirmation,[mbYes,mbNo],0)=mrYes then
      Begin
       LabelStatus.Caption:='Spielverlauf';
       LabelZug.Caption:='';
       for K:=1 to ZugNummer do
        Begin
         SchreibZugNummer(K);
         Feld:=SpielListe[K];
         SpielFeldAnzeige(Feld);
         if MessageDlgPos('Weiter?',mtConfirmation,[mbYes,mbNo],0,
          TTT3D.Left+Status.Left,TTT3D.Top+Status.Height+50)=mrNo then Exit
        End;
       SpielEnde
      End;
    End;
   End;

 procedure TTTT3D.SpielEnde;
  var K,Sieg,SiegerReihe:Byte;
      Anzeige:String;
  Begin
   Sieg:=0;SiegerReihe:=0;
   for K:=1 to ?? do
    if B[K].Wert=1 then
     Begin if B[K].Anzahl=4 then Begin SiegerReihe:=K;Sieg:=1 End End
    else
     if B[K].Wert=2 then
      Begin if B[K].Anzahl=4 then Begin SiegerReihe:=K;Sieg:=2 End End;
   if Sieg=1 then
    Begin
     LabelEnde.Font.Color:=clRed;
     if not ZweiSpielerModus and not NetzSpiel then
      Begin
       Anzeige:='SuperPC hat gewonnen!';
       if SoundAn then Sound('Computersieg.wav')
      End
     else Anzeige:=Spieler2+' gewinnt!';
     for K:=1 to 4 do
      F[Reihe[SiegerReihe].FeldNr[K]].Art:=3;
    End;
   if Sieg=2 then
    Begin
     LabelEnde.Font.Color:=clGreen;
     if not ZweiSpielerModus and not NetzSpiel then
      Begin
       Anzeige:='Du hast mich besiegt!';
       if SoundAn then Sound('Menschsieg.wav')
      End
     else Anzeige:=Spieler1+' gewinnt!';
     for K:=1 to 4 do
      F[Reihe[SiegerReihe].FeldNr[K]].Art:=4;
    End;
   if Remis(B) then Anzeige:='Remis!!!'
   else SpielFeldAnzeige(F);
   LabelEnde.Caption:=Anzeige;
   LabelStatus.Caption:='Das Spiel ist zu Ende';
   if NetzSpiel then
    begin
     DisConnect;
     Caption:='3D Tic Tac Toe  Verbindung beendet!';
    end
  End;

 procedure TTTT3D.SchreibZugNummer(Nr:Integer);
  Begin LabelZugNr.Caption:=IntToStr(Nr) End;
{****************************************************************************}
{*                          Zugberechnungen                                 *}
{****************************************************************************}
 procedure TTTT3D.ComputerZug;
  var AlphaBeta:Integer;
      BestZug:SpielZug;
      Ebene,Zeile,Spalte,K,L,Anzahl:Byte;
      VirFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirBewertung:Bewertung;
      TSek:Extended;
      Meldung:String;
  Begin
   Ausgabe.Clear;
   Screen.Cursor:=crHourglass;Service.Enabled:=False;
   if NetzSpiel then LabelStatus.Caption:=Spieler1+' denkt nach!'
   else LabelStatus.Caption:='PC denkt nach!';
   Delay(500);Cont:=0;BestZug:=70;
   if ZugNummer=0 then BestZug:=Gut[Random(8)+1];
   for K:=1 to ?? do
    Begin
     if (B[K].Wert=1) and (B[K].Anzahl=3) then
      Begin
       for L:=1 to 4 do
        if F[Reihe[K].FeldNr[L]].Art=0 then
         Begin BestZug:=Reihe[K].FeldNr[L];Break End
      End;
     if BestZug<70 then Break
    End;
   if BestZug=70 then
    Begin
     for K:=1 to ?? do
      Begin
       if (B[K].Wert=2) and (B[K].Anzahl=3) then
        Begin
         for L:=1 to 4 do
          if F[Reihe[K].FeldNr[L]].Art=0 then
           Begin BestZug:=Reihe[K].FeldNr[L];Break End
        End;
       if BestZug<70 then Break
      End;
    End;
   if BestZug=70 then Level:=Tiefe else Level:=1;
   LabelTiefe.Caption:=IntToStr(Level);
   if (BestZug=70) and (ZugNummer>0) then
    Begin
     TSek:=TimeSekunden;
     SucheZug(BestZug,AlphaBeta,B,Tiefe,F,Computer,MinInt,MaxInt);
     TSek:=TimeSekunden-TSek;
     Ausgabe.SelAttributes.Color:=clGreen;
     Ausgabe.Lines.Add('Rechenzeit : '+Format('%0.2f',[TSek])+' Sek.');
     Ausgabe.SelAttributes.Color:=clBlack;
     if AlphaBeta>300 then // willkrlich festgelegt
      Begin
       LabelEnde.Font.Color:=clFuchsia;
       LabelEnde.Caption:='Du wirst verlieren!'
      End
     else
      if AlphaBeta<-300 then // willkrlich festgelegt
       Begin
        LabelEnde.Font.Color:=clBlue;
        LabelEnde.Caption:='Der PC hat keine Chance!'
       End
      else LabelEnde.Caption:='';
    End;
   Screen.Cursor:=crHandPoint;
   Ebene:=BestZug div 16+1;if BestZug mod 16=0 then dec(Ebene);
   Spalte:=BestZug mod 4;Zeile:=(BestZug-(Ebene-1)*16) div 4+1;
   if Spalte=0 then Begin Spalte:=4;dec(Zeile) End;
   LabelZug.Caption:='Mein Zug : E'+IntToStr(5-Ebene)+' S'+IntToStr(Spalte)
                          +' Z'+IntToStr(5-Zeile);
   MachZug(F,B,BestZug,1);
   inc(F[BestZug].Art,10); // gesetzte Spalte markieren
   SpielFeldAnzeige(F);Delay(1000);
   dec(F[BestZug].Art,10); // Markierung lschen
   if NetzSpiel then
    begin
     Meldung:=char(BestZug);
     // Meldung mu gesendet werden
     if IsServer then ServerSocket.Socket.Connections[0].SendText(Meldung)
     else ClientSocket.Socket.SendText(Meldung);
     Dran:=not Dran;
    end;
   Service.Enabled:=True;
   inc(ZugNummer);SchreibZugNummer(ZugNummer);
   SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
   if Schluss(B) or Remis(B) then
    Begin SpielEnde;Spielverlauf End
   else
    Begin
     if NetzSpiel then LabelStatus.Caption:=Spieler2+' zieht!'
     else LabelStatus.Caption:=Spieler1+' zieht!';
     WerZieht:=Mensch;
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirBewertung:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirBewertung,Zug,1);
         for L:=1 to ?? do
          if (VirBewertung[L].Wert=1) and (VirBewertung[L].Anzahl=4) then
           with SpielFeldAusgabe.Canvas do Draw(wo[Zug].X,wo[Zug].Y,Warn);
        End
      End
    End
  End;

 procedure TTTT3D.SpielFeldAusgabeMouseDown(Sender: TObject; //Menschzug
           Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var Ebene,Zeile,Spalte,K:Byte;
      Zug:SpielZug;
  Begin
   if not DarfSpielen then
    Begin
     MessageDlg('Du mut erst das Spiel starten!',mtError,[mbRetry],0);
     Exit
    End;
   if NetzSpiel then exit;
   if not Schluss(B) and not Remis(B) and (Shift=[ssleft])then
    Begin
     Zug:=70;
     for k:=1 to 64 do
      if (x>wo[k].x) and (x<wo[k].x+41) and (y>wo[k].y) and (y<wo[k].y+23) then
       Begin Zug:=K;Break End;
     if (Zug>0) and (Zug<65) and(F[Zug].Art=0) then
      Begin
       Ebene:=Zug div 16+1;if Zug mod 16=0 then dec(Ebene);
       Spalte:=Zug mod 4;Zeile:=(Zug-(Ebene-1)*16) div 4+1;
       if Spalte=0 then Begin Spalte:=4;dec(Zeile) End;
       LabelZug.Caption:='Dein Zug : E'+IntToStr(5-Ebene)+' S'+IntToStr(Spalte)
                                                     +' Z'+IntToStr(5-Zeile);
       inc(ZugNummer);SchreibZugNummer(ZugNummer);
       if ZweiSpielerModus then
        Begin
         if WerZieht=Computer then
          Begin
           MachZug(F,B,Zug,1);
           LabelStatus.Caption:=Spieler1+' zieht!';
           WerZieht:=Mensch;
          End
         else
          Begin
           MachZug(F,B,Zug,2);
           LabelStatus.Caption:=Spieler2+' zieht!';
           WerZieht:=Computer;
          End;
         inc(F[Zug].Art,10); // Markierung setzen
         SpielFeldAusgabe.Enabled:=False;
         SpielFeldAnzeige(F);Delay(1000);
         SpielFeldAusgabe.Enabled:=True;
         dec(F[Zug].Art,10); // Markierung lschen
         SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
         Delay(WarteZeit);
         if Schluss(B) or Remis(B) then
          Begin SpielEnde;Spielverlauf End;
        End
       else
        Begin
         MachZug(F,B,Zug,2);
         inc(F[Zug].Art,10); // Markierung setzen
         SpielFeldAusgabe.Enabled:=False;
         SpielFeldAnzeige(F);Delay(1000);
         SpielFeldAusgabe.Enabled:=True;
         dec(F[Zug].Art,10); // Markierung lschen
         SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
         Delay(WarteZeit);
         if Schluss(B) or Remis(B) then
          Begin SpielEnde;Spielverlauf End
         else Begin WerZieht:=Computer;ComputerZug End
        End
      End
    End
  End;

 procedure TTTT3D.SuchZug(var Zug:SpielZug;SF:SpielFeld;SB:Bewertung);
  var VirFeld:SpielFeld;
      VirBewertung:Bewertung;
      Nr,K,An:Byte;
      Grenze,MinMaxWert,GrenzWert:Integer;
      Liste,ZL:SpielZugListe;
      Zeigen:Boolean;
  Begin
   Grenze:=MaxInt;Nr:=0;Zeigen:=Anzeigen;
   if Anzeigen then Anzeigen:=False;
   GenZugListe(SF,Mensch,An,ZL);
   if SpielerName='Meister' then GrenzWert:=Max(3,Tiefe)
   else GrenzWert:=Min(3,Tiefe);
   for K:=1 to An do
    Begin
     VirFeld:=SF;VirBewertung:=SB;Zug:=ZL[K];
     MachZug(VirFeld,VirBewertung,Zug,2);
     SucheZug(Zug,MinMaxWert,VirBewertung,GrenzWert,VirFeld,Computer,MinInt,MaxInt);
     if MinMaxWert<=Grenze then
      Begin
       if MinMaxWert=Grenze then inc(Nr);
       if MinMaxWert<Grenze then Nr:=1;
       Liste[Nr]:=ZL[K];Grenze:=MinMaxWert;
      End;
    End;
   K:=Random(Nr)+1;Zug:=Liste[K];Anzeigen:=Zeigen
  End;
{****************************************************************************}
{*                         Spiel - Parameter festlegen                      *}
{****************************************************************************}
 procedure TTTT3D.Init;
  Begin
   F:=FAlt;
   FeldAusgabe;
   SpielFeldAnzeige(F);
   ZweiSpielerModus:=False;
   Zugvorschlag.Enabled:=True;
   Zugbewertung.Enabled:=True;
   Staerke.Enabled:=True;
   if MenschgegenMensch.Checked then ZweiSpielerModus:=True;
   LabelStatus.Caption:='';
   LabelTiefe.Caption:='';
   LabelZugNr.Caption:='';
   LabelZug.Caption:='';
   LabelEnde.Caption:='';
   ZugNummer:=0;SpielListe[ZugNummer]:=F;
   FillChar(B,SizeOf(B),0); // B=0 SETZEN
   Werte[ZugNummer]:=B;
  End;

 procedure TTTT3D.NameErmitteln(Name:String;var SpielerName:String);
  const Max=9;
        NameListe:Array[0..Max]of String=('Ahab','Brsel','Meister','Schrder',
                                          'Jacobs','Schneider','Nelson',
                                          'Columbus','Magellan','Nemo');
  var Zahl,ersterBuchstabe:String;
  Begin
   SpielerName:='';
   if ZweiSpielerModus then PasswordDlg.Caption:=Name+', gib deinen Namen ein!'
   else if NetzSpiel then PasswordDlg.Caption:=Name+', gib den Rechnernamen ein!'
   else PasswordDlg.Caption:='Wie heit Du, '+Name+'?';
   PasswordDlg.LabelPasswort.Caption:='Der Computer fordert Dich heraus!';
   PasswordDlg.Passwort.PasswordChar:=#0;
   PasswordDlg.Passwort.Text:=NameListe[random(3)];
   repeat
    PasswordDlg.ShowModal;
    SpielerName:=PasswordDlg.Passwort.Text;
    while Pos(' ',SpielerName)>0 do  // lscht alle Leerzeichen
     begin Delete(SpielerName,Pos(' ',SpielerName),1) end;
    while Pos('FIETE',AnsiUpperCase(SpielerName))>0 do  // lscht alle Fiete
     begin Delete(SpielerName,Pos('FIETE',AnsiUpperCase(SpielerName)),5) end;
    if Length(SpielerName)<3 then
     PasswordDlg.Passwort.Text:=NameListe[random(3)];
   until Length(SpielerName)>2;
   SpielerName:=AnsiLowerCase(SpielerName);
   ersterBuchstabe:=AnsiUpperCase(SpielerName[1]);
   SpielerName[1]:=ersterBuchstabe[1];
   if AnsiUpperCase(SpielerName)='MEISTER' then
    Begin
     PasswordDlg.Caption:='Paworteingabe';
     PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
     PasswordDlg.Passwort.PasswordChar:='?';
     PasswordDlg.Passwort.Text:='';
     PasswordDlg.ShowModal;
     Zahl:=PasswordDlg.Passwort.Text;
     if Zahl<>Geheim then SpielerName:='Betrger';
    End;
  End;
{****************************************************************************}
{*                         Men - Prozeduren                                *}
{****************************************************************************}
 procedure TTTT3D.StartClick(Sender: TObject);
  var P:PChar;
      Size:DWord;
  Begin
   if SoundAn then Sound('Welcomef.wav');
   Init;DarfSpielen:=True;
   LabelEnde.Caption:='';
   UpdateCaption;
   if ZweiSpielerModus then
    Begin
     NameErmitteln('Spieler1',SpielerName);
     Spieler1:=SpielerName;
     NameErmitteln('Spieler2',SpielerName);
     Spieler2:=SpielerName;
     Zugvorschlag.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
    End
   else
    if NetzSpiel then
     begin
      VerbindungVorhanden:=False;
      Connected:=False;
      // Computername ermitteln
      Size:=MAX_COMPUTERNAME_LENGTH+1;
      P:=StrAlloc(Size);
      Windows.GetComputername(P,Size);
      SpielerName:=P;
      Spieler1:=SpielerName;
      Spieler2:='Computergegner';
      StrDispose(P);
      ClientSocket.Host:=Spieler1;
      NetzwerkVerbindung.Enabled:=True;
     end
   else
    Begin
     NameErmitteln('Spieler',SpielerName);
     Spieler1:=SpielerName;
     Spieler2:='Computer';
     if Menschbeginnt.Checked then WerZieht:=Mensch
     else WerZieht:=Computer
    End;
   if not NetzSpiel then
    begin
     if WerZieht=Mensch then LabelStatus.Caption:=Spieler1+' zieht!'
     else LabelStatus.Caption:=Spieler2+' zieht!';
    end;
   LabelMensch.Caption:=Spieler1;
   LabelComputer.Caption:=Spieler2;
   LabelMS.Caption:=Spieler1+'sieg';
   LabelCS.Caption:=Spieler2+'sieg';
   if not NetzSpiel then
    if WerZieht=Computer then ComputerZug
  End;

 procedure TTTT3D.EndeClick(Sender: TObject);
  Begin close End;

  procedure TTTT3D.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  Begin
   if MessageDlg('Willst du das Spiel beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Das Spiel wird beendet!',mtWarning,[mbOk],0);
     if SoundAn then Sound('Goodbyef.wav');
     CanClose:=True
    End
   else CanClose:=False
  End;

 procedure TTTT3D.LevelWahl(Sender: TObject);
  Begin
   if Sender=N1Anfaenger then
    Begin Tiefe:=1;N1Anfaenger.Checked:=True End;
   if Sender=N2Geuebter  then
    Begin Tiefe:=2;N2Geuebter.Checked:=True End;
   if Sender=N3Erfahrener then
    Begin Tiefe:=3;N3Erfahrener.Checked:=True End;
   if Sender=N4Fortgeschrittener then
    Begin Tiefe:=4;N4Fortgeschrittener.Checked:=True End;
   if Sender=N5Koenner then
    Begin Tiefe:=5;N5Koenner.Checked:=True End;
   if Sender=N6Meister then
    Begin Tiefe:=6;N6Meister.Checked:=True End;
   if Sender=N7Grossmeister then
    Begin Tiefe:=7;N7Grossmeister.Checked:=True End;
   if Sender=N8Weltmeister then
    Begin Tiefe:=8;N8Weltmeister.Checked:=True End;
   if Sender=N9Genie then
    Begin Tiefe:=9;N9Genie.Checked:=True End;
   if Sender=N10Superhirn then
    Begin Tiefe:=10;N10Superhirn.Checked:=True End;
   if Sender=N11AlbertEinstein then
    Begin Tiefe:=11;N11AlbertEinstein.Checked:=True End;
   if Sender=N12Cray1 then
    Begin Tiefe:=12;N12Cray1.Checked:=True End;
   if Sender=N13CrayXMP then
    Begin Tiefe:=13;N13CrayXMP.Checked:=True End;
   if Sender=N14DeepBlue then
    Begin Tiefe:=14;N14DeepBlue.Checked:=True End;
   if Sender=N15PacificBlue then
    Begin Tiefe:=15;N15PacificBlue.Checked:=True End;
   if Sender=N16ASCIWhite then
    Begin Tiefe:=16;N16ASCIWhite.Checked:=True End;
   if Sender=N17HAL then
    Begin Tiefe:=17;N17HAL.Checked:=True End;
   LabelTiefe.Caption:=IntToStr(Tiefe);
  End;

 procedure TTTT3D.WerBeginnt(Sender: TObject);
  Begin
   if Sender=Menschbeginnt then
    Begin
     WerZieht:=Mensch;
     ZweiSpielerModus:=False;
     Menschbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugruecknahme.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
     Netzwerkverbindung.Enabled:=False;
     NetzSpiel:=False;
    End;
   if Sender=Computerbeginnt then
    Begin
     WerZieht:=Computer;
     ZweiSpielerModus:=False;
     Computerbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugruecknahme.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
     Netzwerkverbindung.Enabled:=False;
     NetzSpiel:=False;
    End;
   if Sender=MenschgegenMensch then
    Begin
     WerZieht:=Mensch;
     ZweiSpielerModus:=True;
     MenschgegenMensch.Checked:=True;
     LabelTiefe.Caption:='';
     Zugvorschlag.Enabled:=False;
     Zugruecknahme.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
     WarnHinweis.Enabled:=False;
     Netzwerkverbindung.Enabled:=False;
     NetzSpiel:=False;
    End;
   if Sender=NetzwerkSpiel then
    Begin
     NetzSpiel:=True;
     NetzwerkSpiel.Checked:=True;
     ZweiSpielerModus:=False;
     Zugvorschlag.Enabled:=False;
     Zugruecknahme.Enabled:=False;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
    End;
  End;

 procedure TTTT3D.ZugbewertungClick(Sender: TObject);
  Begin
   if MessageDlg('Soll die Bewertung angezeigt werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Die Bewertunganzeige ist aktiv!',mtInformation,[mbOk],0);
     Anzeigen:=True;Ausgabe.Visible:=True
    End
   else Begin Ausgabe.Visible:=False;Anzeigen:=False End;
   Zugbewertung.Checked:=Anzeigen;
  End;

 procedure TTTT3D.ZugvorschlagClick(Sender: TObject);
  var VirFeld:SpielFeld;
      VirBewertung:Bewertung;
      Zug:SpielZug;
      Ebene,Spalte,Zeile:Byte;
  Begin
   VirFeld:=F;VirBewertung:=B;Screen.Cursor:=crHourGlass;
   LabelStatus.Caption:='Ich suche fr Dich!';
   SuchZug(Zug,VirFeld,VirBewertung);Screen.Cursor:=crHandPoint;
   Ebene:=Zug div 16+1;if Zug mod 16=0 then dec(Ebene);
   Spalte:=Zug mod 4;Zeile:=(Zug-(Ebene-1)*16) div 4+1;
   if Spalte=0 then Begin Spalte:=4;dec(Zeile) End;
   ShowMessage('Mein Vorschlag'+#13+'setze jetzt auf E'+IntToStr(5-Ebene)
                +' S'+IntToStr(Spalte)+' Z'+IntToStr(5-Zeile));
   LabelStatus.Caption:='Dein Zug : ';
  End;

 procedure TTTT3D.ZugruecknahmeClick(Sender: TObject);
  var K,L,Anzahl:Byte;
      VirFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirBewertung:Bewertung;
  Begin
   if ZugNummer>1 then
    Begin
     LabelEnde.Caption:='';
     dec(ZugNummer,2);SchreibZugNummer(ZugNummer);
     F:=SpielListe[ZugNummer];B:=Werte[ZugNummer];
     SpielFeldAnzeige(F);
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirBewertung:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirBewertung,Zug,1);
         for L:=1 to ?? do
          if (VirBewertung[L].Wert=1) and (VirBewertung[L].Anzahl=4) then
           with SpielFeldAusgabe.Canvas do Draw(wo[Zug].X,wo[Zug].Y,Warn);
        End
      End;
     LabelStatus.Caption:='Dein Zug : ';
    End
  End;

 procedure TTTT3D.InfoClick(Sender: TObject);
  Begin InfoBox.ShowModal End;

 procedure TTTT3D.RegelnClick(Sender: TObject);
  Begin RegelnBox.ShowModal End;

 procedure TTTT3D.TonClick(Sender: TObject);
  Begin
   if MessageDlg('Soll der Sound aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Der Sound ist aktiv!',mtInformation,[mbOk],0);
     SoundAn:=True;
    End
   else SoundAn:=False;
   Ton.Checked:=SoundAn
  End;

 procedure TTTT3D.FormCreate(Sender: TObject);
 const ScreenHeightDev=??8;ScreenWidthDev=1024;
  var E,I,K,L:Byte;
      Zeile,Wer:String;
      x,y:Integer;
      Heute:TDateTime;
      Jahr,Monat,Tag:Word;
  Begin
   Heute:=Now;
   DecodeDate(Heute,Jahr,Monat,Tag);
   CopyRightName(Wer);
   if Wer<>'Fiete' then
    begin
     MessageDlg(' Du hast das  verletzt!!!!',mtError,[mbOk],0);
     Application.Terminate
    end;
   TTT3D.Caption:='3D Tic Tac Toe '+IntToStr(Jahr)+'/'+IntToStr(Jahr+1)+'   '+Wer;
   Leer:=TBitMap.Create;
   Leer.LoadFromFile('Leer.bmp');
   Leer.Transparent:=True;
   Rot:=TBitMap.Create;
   Rot.LoadFromFile('Rot.bmp');
   Rot.Transparent:=True;
   Gruen:=TBitMap.Create;
   Gruen.LoadFromFile('grn.bmp');
   Gruen.Transparent:=True;
   RotSieg:=TBitMap.Create;
   RotSieg.LoadFromFile('RotSieg.bmp');
   RotSieg.Transparent:=True;
   GruenSieg:=TBitMap.Create;
   GruenSieg.LoadFromFile('GrnSieg.bmp');
   GruenSieg.Transparent:=True;
   GruenGesetzt:=TBitMap.Create;
   GruenGesetzt.LoadFromFile('GrnGesetzt.bmp');
   GruenGesetzt.Transparent:=True;
   RotGesetzt:=TBitMap.Create;
   RotGesetzt.LoadFromFile('RotGesetzt.bmp');
   RotGesetzt.Transparent:=True;
   Warn:=TBitMap.Create;
   Warn.LoadFromFile('Warnung.bmp');
   Warn.Transparent:=True;
   Bild:=TBitMap.Create;
   Scaled:=True;x:=Screen.width;y:=screen.height;
   if (y<>ScreenHeightDev) or (x<>ScreenWidthDev) then
    Begin
     Height:=(ClientHeight*y div ScreenHeightDev)+Height-ClientHeight;
     Width:=(ClientWidth*x div ScreenWidthDev)+Height-ClientHeight;
     ScaleBy(x,ScreenwidthDev);
    End;
   Screen.Cursor:=crHandPoint;
   MaxX:=SpielFeldAusgabe.Width;MaxY:=SpielFeldAusgabe.Height;
   CopyRight;Randomize;
   Init;WerZieht:=Computer;Tiefe:=3;
   LabelTiefe.Caption:=IntToStr(Tiefe);
   Anzeigen:=False;//Bewertungsanzeige
   Warnung:=False;// Verlustanzeige
   Ausgabe.Visible:=False;
   DarfSpielen:=False;SoundAn:=False;

   // hier fehlt was!!!

   // Gewinnreihen in den vier Ebenen, 10 pro Ebene
   // 16 senkrechte Gewinnreihen
   // je 3 Raumdiagonalen aus den Ecken
   // 8 Diagonalen von den Seiten unten nach oben

   Ausgabe.Lines.Add('Gewinnreihen');
   for L:=1 to ?? do
    Begin
     Zeile:=IntToStr(L)+') ';
     for K:=1 to 3 do Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[K])+' - ';
     Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[4]);
     Ausgabe.Lines.Add(Zeile);
    End;
   for I:=1 to 64 do
    Begin
     F[I].Art:=0;F[I].Anzahl:=0;
     for L:=1 to ?? do
      for K:=1 to 4 do
       if Reihe[L].FeldNr[K]=I then
        Begin inc(F[I].Anzahl);F[I].wo[F[I].Anzahl]:=L End
    End;
   Ausgabe.Lines.Add('');
   Ausgabe.Lines.Add('Feldinhalte');
   for I:=1 to 64 do
    Begin
     Zeile:=IntToStr(I)+') ';
     for K:=1 to F[I].Anzahl-1 do Zeile:=Zeile+IntToStr(F[I].wo[K])+' - ';
     Zeile:=Zeile+IntToStr(F[I].wo[F[I].Anzahl]);
     Ausgabe.Lines.Add(Zeile);
    End;
   FAlt:=F;
   ServerSocket.Active:=True;
   Connected:=False;
   VerbindungVorhanden:=False;
   IsServer:=True;
   ShallMove:=False;
   UpdateCaption;
   Start.Enabled:=True;
   Netzwerkverbindung.Enabled:=False;
   NetzSpiel:=False;
   NetzWarteZeit:=3000;
  End;

 procedure TTTT3D.WarnHinweisClick(Sender: TObject);
  Begin
   if MessageDlg('Soll die Hinweiswarnung aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Der Hinweiswarnung ist aktiv!',mtInformation,[mbOk],0);
     Warnung:=True;
    End
   else Warnung:=False;
   WarnHinweis.Checked:=Warnung
  End;

 procedure TTTT3D.UpdateCaption;
  var scolor,smessage:string;
  begin
   if not Connected then
    begin
     scolor:='';
     if NetzSpiel then smessage:='warte auf Verbindung...'
     else smessage:=''
    end
   else
    begin
     scolor:=' ('+SpielerName+')';
     if ShallMove then smessage:='bitte setzen!'
     else smessage:='wartet auf Zug der Gegenseite...';
    end;
   Caption:=Format('3D Tic Tac Toe%s - %s', [scolor, smessage]);
  end;

 procedure TTTT3D.ClientSocketConnect(Sender: TObject;
                                      Socket: TCustomWinSocket);
  begin
   Spieler2:=Socket.RemoteHost;
   LabelComputer.Caption:=Spieler2;
   LabelCS.Caption:=Spieler2+'sieg';
   Connected:=True;
   Start.Enabled:=False;
   IsServer:=False;
   ShallMove:=False;
   UpdateCaption;
  end;

 procedure TTTT3D.ClientSocketDisconnect(Sender: TObject;
                                         Socket: TCustomWinSocket);
  begin Connected:=False end;

 procedure TTTT3D.ZugAuswertung(Meldung:String);
  var BestZug:SpielZug;
      Ebene,Zeile,Spalte,K,L,Anzahl:Byte;
      VirFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirBewertung:Bewertung;
  begin
   BestZug:=ord(Meldung[1]);
   if not(BestZug in[1..64]) then exit;
   Ebene:=BestZug div 16+1;if BestZug mod 16=0 then dec(Ebene);
   Spalte:=BestZug mod 4;Zeile:=(BestZug-(Ebene-1)*16) div 4+1;
   if Spalte=0 then Begin Spalte:=4;dec(Zeile) End;
   LabelZug.Caption:='Mein Zug : E'+IntToStr(5-Ebene)+' S'+IntToStr(Spalte)+
                     ' Z'+IntToStr(5-Zeile);
   MachZug(F,B,BestZug,2);
   inc(F[BestZug].Art,10); // gesetzte Spalte markieren
   SpielFeldAnzeige(F);
   dec(F[BestZug].Art,10); // Markierung lschen
   Service.Enabled:=True;
   inc(ZugNummer);SchreibZugNummer(ZugNummer);
   SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
   if Schluss(B) or Remis(B) then
    Begin SpielEnde;Spielverlauf End
   else
    Begin
     LabelStatus.Caption:=Spieler1+' zieht!';
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirBewertung:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirBewertung,Zug,2);
         for L:=1 to ?? do
          if (VirBewertung[L].Wert=1) and (VirBewertung[L].Anzahl=4) then
           with SpielFeldAusgabe.Canvas do Draw(wo[Zug].X,wo[Zug].Y,Warn);
        End
      End;
     ComputerZug
    End
  end;

 procedure TTTT3D.SocketRead(Sender: TObject;Socket: TCustomWinSocket);
   var Meldung:String;
  begin
   Meldung:=Socket.ReceiveText;
   if Length(Meldung)=1 then ZugAuswertung(Meldung)
    else
     begin
      MessageDlg('ProgrammFehler in SocketRead!'+#13+Meldung,mtError,[mbOk],0);
      Exit
     end;
   // Der folgende Ausdruck ist wahr, wenn beide
   // Boolean-Variablen den Wert True oder beide den Wert False haben
   ShallMove:=not (IsServer xor Dran);
   UpdateCaption;Delay(NetzWarteZeit);
  end;

 procedure TTTT3D.NetzwerkverbindungClick(Sender: TObject);
  begin
   if Connected then
    begin
     MessageDlg('Verbindung bereits aktiv!',mtError,[mbOk],0);
     exit
    end;
   Servername:='DS9'; // 'Laptop';
   if ClientSocket.Active then ClientSocket.Active:=False;
    if InputQuery('Verbindung mit Gegenspieler','PC-Name:',Servername) then
     if Length(Servername)>0 then
      with ClientSocket do
       begin
        Host:=Servername;
        Active:=True;
        Connected:=True;
      end;
  end;

 procedure TTTT3D.ServerSocketClientConnect(Sender: TObject;
                                            Socket: TCustomWinSocket);
  begin
   Spieler2:=Socket.RemoteHost;
   LabelComputer.Caption:=Spieler2;
   LabelCS.Caption:=Spieler2+'sieg';
   Connected:=True;
   Start.Enabled:=False;
   NetzwerkVerbindung.Enabled:=True;
   IsServer:=True;
   ShallMove:=True; //Server beginnt das Spiel
   ComputerZug;
   UpdateCaption;
  end;

 procedure TTTT3D.ServerSocketClientDisconnect(Sender: TObject;
                                               Socket: TCustomWinSocket);
  begin Connected:=False end;

 procedure TTTT3D.DisConnect;
  begin
   ClientSocket.Active:=False;
   ServerSocket.Active:=True;
   Connected:=False;
   VerbindungVorhanden:=False;
   Start.Enabled:=True;
   NetzwerkVerbindung.Enabled:=False;
   Dran:=False;
   IsServer:=True;
  end;

 procedure TTTT3D.AbbruchClick(Sender: TObject);
  begin
   if MessageDlg('Willst du wirklich aufgeben?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
     begin
      Hinweis('Spielabbruch');DisConnect;
     end;
  end;

End.

