unit Gobang;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, MPlayer, ComCtrls, Grids, ScktComp;
                                       // 1-5 Computer   ...  6-10 TSpieler
 const RWerte:Array[1..10]of Integer=(5,50,500,5000,50000,5,50,500,5000,50000);
       MinInt=-300000;MaxInt=300000;Teil=7;WarteZeit=200;
 type
      TInhalt=Record
               Art,Anzahl:Integer;
               WO:Array[1..??]of Integer // maximale Anzahl von Gewinnreihen durch 1 Feld
              End;
      TBewInhalt=Record Wert,Anzahl:Byte End;
      TNr=Record FeldNr:Array[1..5]of Integer End;
      TSpielFeld=Array[1..361]of TInhalt;
      TBewertung=Array[1..1020]of TBewInhalt;
      TSpielzug=Integer;
      TSpielzugListe=Array[1..360]of TSpielzug;
      TSpieler=(Computer,Mensch);

  TGomuku = class(TForm)
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Start: TMenuItem;
    Staerke: TMenuItem;
    N1Anfaenger: TMenuItem;
    N2Geuebter: TMenuItem;
    N3Erfahrener: TMenuItem;
    N4Fortgeschrittener: TMenuItem;
    N5Koenner: TMenuItem;
    N6Meister: TMenuItem;
    N7Grossmeister: TMenuItem;
    N8Weltmeister: TMenuItem;
    N9Genie: TMenuItem;
    N10Superhirn: TMenuItem;
    N11AlbertEinstein: TMenuItem;
    Einstellungen: TMenuItem;
    Menschbeginnt: TMenuItem;
    Computerbeginnt: TMenuItem;
    MenschgegenMensch: TMenuItem;
    Service: TMenuItem;
    Zugruecknahme: TMenuItem;
    Zugvorschlag: TMenuItem;
    Zugbewertung: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    Regeln: TMenuItem;
    FeldPanel: TPanel;
    Ende: TMenuItem;
    Status: TPanel;
    StatusText: TStaticText;
    TiefeText: TStaticText;
    Panel1: TPanel;
    LabelStatus: TLabel;
    Panel2: TPanel;
    LabelTiefe: TLabel;
    Panel3: TPanel;
    LabelZug: TLabel;
    ShapeComputer: TShape;
    ShapeMensch: TShape;
    LabelEnde: TLabel;
    ZugNrText: TStaticText;
    Panel4: TPanel;
    LabelZugNr: TLabel;
    LabelMensch: TLabel;
    LabelComputer: TLabel;
    MediaPlayer: TMediaPlayer;
    Ausgabe: TRichEdit;
    Ton: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    WarnHinweis: TMenuItem;
    SpielFeldAusgabe: TDrawGrid;
    Laenge: TMenuItem;
    N7x7: TMenuItem;
    N9x9: TMenuItem;
    N11x11: TMenuItem;
    N13x13: TMenuItem;
    N15x15: TMenuItem;
    N17x17: TMenuItem;
    N19x19: TMenuItem;
    Abbruch: TMenuItem;
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
    NetzwerkSpiel: TMenuItem;
    NetzwerkVerbindung: TMenuItem;
    procedure StartClick(Sender: TObject);
    procedure LevelWahl(Sender: TObject);
    procedure Wer_Beginnt(Sender: TObject);
    procedure EndeClick(Sender: TObject);
    procedure ZugbewertungClick(Sender: TObject);
    procedure ZugvorschlagClick(Sender: TObject);
    procedure ZugruecknahmeClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure Sound(Datei:String);
    procedure CopyRight;
    procedure SpielfeldAnzeige;
    procedure GenZugListe(F:TSpielFeld;Amzug:TSpieler;
                          var N:Integer;var ZL:TSpielzugListe);
    function Wert(var B:TBewertung):Integer;
    function Max(X,Y:Integer):Integer;
    function Min(X,Y:Integer):Integer;
    procedure MachZug(var F:TSpielFeld;var B:TBewertung;Zug:TSpielzug;Amzug:Byte);
    function Remis(var B:TBewertung):Boolean;
    function Schluss(var B:TBewertung):Boolean;
    procedure SucheBestZug(var BestZug:TSpielzug;var AlphaBeta:Integer;
           B:TBewertung;N:Byte;F:TSpielFeld;Amzug:TSpieler;Alpha,Beta:Integer);
    procedure SpielEnde;
    procedure SchreibZugNummer(Nr:Integer);
    procedure ComputerZug;
    procedure SucheZug(var Zug:TSpielzug;SF:TSpielFeld;SB:TBewertung);
    procedure GewinnReihen;
    procedure Init;
    procedure NameErmitteln(Name:String;var SpielerName:String);
    procedure TonClick(Sender: TObject);
    procedure SpielVerlauf;
    function TimeSekunden:Extended;
    procedure FormCreate(Sender: TObject);
    procedure WarnHinweisClick(Sender: TObject);
    procedure BrettWahl(Sender: TObject);
    procedure SpielFeldAusgabeDrawCell(Sender: TObject; Col, Row: Integer;
                                       Rect: TRect; State: TGridDrawState);
    procedure AbbruchClick(Sender: TObject);
    procedure SpielFeldAusgabeMouseDown(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
    procedure Delay(Zeit:DWord);// Pausenzeit in Millisekunden
    procedure Hinweis(T:String);
    procedure CopyRightName(var Name:String);
    procedure DisConnect;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure UpdateCaption;
    procedure NetzwerkVerbindungClick(Sender: TObject);
    procedure ClientSocketConnect(Sender: TObject;Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;Socket: TCustomWinSocket);
    procedure SocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject;
                                        Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
                                           Socket: TCustomWinSocket);
    procedure ZugAuswertung(Meldung:String);

  private
    { Private-Deklarationen }
     Reihe:Array[1..1020]of TNr;
     Farbe:Array[1..5]of TColor;
     F,FAlt:TSpielFeld;
     B:TBewertung;
     SpielListe:Array[0..181]of TSpielFeld;
     Werte:Array[0..181]of TBewertung;
     ZugWeite:Array[1..8]of Integer;
     WerZieht:TSpieler;
     Level,Tiefe:Byte;
     Count,NSqr,BAnzahl,NFeld,ZugNummer,NetzWarteZeit:Integer;
     Geheim,SpielerName,Spieler1,Spieler2,Meldung,Kopf:String;
     Warnung,SoundAn,DarfSpielen,Anzeigen,ZweiSpielerModus,NetzSpiel,
     Connected,VerbindungVorhanden,Dran,IsServer,ShallMove:Boolean;
  public
    { Public-Deklarationen }
  End;

var Gomuku: TGomuku;

implementation

uses Passwort, Info, Regeln;

{$R *.DFM}
{$R+,Q+}

 function TGomuku.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  Begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  End;

 procedure TGomuku.Delay(Zeit:DWord);// Pausenzeit in Millisekunden
  var AltZeit:DWord;
  Begin
   AltZeit:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-AltZeit>Zeit
  End;

 procedure TGomuku.Hinweis(T:String);
  Begin
   Application.MessageBox(PChar(T),'Hinweis',64); // String in PChar umwandeln
  End;
{****************************************************************************}
{*                         Geheimzahl berechnen                             *}
{****************************************************************************}
procedure TGomuku.CopyRight;
  var Name:String;
      K,LA:Byte;
  Begin
   RandSeed:=3062;Name:='D_';Geheim:='';LA:=223;
   for K:=1 to 6 do
    Geheim:=Geheim+char(32+(ord(Name[K])-Random(LA)+LA-32) mod LA);
  End;

 procedure TGomuku.CopyRightName(var Name:String);
  var I:Byte; Code:String;
  Begin
   RandSeed:=13;Code:='}֌An=';Name:='';
   for I:=1 to Length(Code) do
    Name:=Name+char((ord(Code[I])-random(128)) and 255);
  End;
{****************************************************************************}
{*                         nderungen des Spielfeldes                       *}
{****************************************************************************}
 procedure TGomuku.SpielfeldAnzeige;
  Begin SpielFeldAusgabe.RePaint End;
{****************************************************************************}
{*                         Spiel - Prozeduren                               *}
{****************************************************************************}
 procedure TGomuku.GenZugListe(F:TSpielFeld;Amzug:TSpieler;var N:Integer;
                               var ZL:TSpielzugListe);
  var K,L:TSpielzug;
      WO:Integer;
  Begin
   N:=0;
   for K:=1 to NSqr do

   // hier fehlt was!!!

  End;

 function TGomuku.Wert(var B:TBewertung):Integer;
  var K,SP,COM:Integer;
  Begin
   SP:=0;COM:=0;
    for K:=1 to BAnzahl do
     Begin
      if B[K].Wert=1 then COM:=COM+RWerte[B[K].Anzahl]
      else if B[K].Wert=2 then SP:=SP+RWerte[B[K].Anzahl+5]
     End;
   Wert:=COM-SP;inc(Count)
  End;

 function TGomuku.Max(X,Y:Integer):Integer;
  Begin if X<Y then Max:=Y else Max:=X End;

 function TGomuku.Min(X,Y:Integer):Integer;
  Begin if X<Y then Min:=X else Min:=Y End;

 procedure TGomuku.MachZug(var F:TSpielFeld;var B:TBewertung;Zug:TSpielzug;Amzug:Byte);
  var L:Byte;
  Begin
   F[Zug].Art:=Amzug;
   for L:=1 to F[Zug].Anzahl do
    with B[F[Zug].WO[L]] do
     Begin Wert:=Wert or Amzug;inc(Anzahl) End
  End;

 function TGomuku.Remis(var B:TBewertung):Boolean;
  var K:Integer;
  Begin
   Remis:=True;
   for K:=1 to BAnzahl do
    if B[K].Wert<3 then Begin Remis:=False;exit End
  End;

 function TGomuku.Schluss(var B:TBewertung):Boolean;
  var K:Integer;
  Begin
   for K:=1 to BAnzahl do
     Begin
      if B[K].Wert<3 then
       if B[K].Anzahl=5 then Begin Schluss:=True;exit End
     End;
   Schluss:=False
  End; 

 procedure TGomuku.SucheBestZug(var BestZug:TSpielzug;var AlphaBeta:Integer;
                     B:TBewertung;N:Byte;F:TSpielFeld;Amzug:TSpieler;Alpha,Beta:Integer);
  var VirFeld:TSpielFeld;
      Zug:TSpielzug;
      ZugListe:TSpielzugListe;
      VirB:TBewertung;
      M:Integer;
      I,Anzahl,Zeile,Spalte:Integer;
      AusZeile:String;
  Begin
   if (N=0) or Schluss(B) or Remis(B) then AlphaBeta:=Wert(B)
   else
    Begin
     GenZugListe(F,Amzug,Anzahl,ZugListe);
     if Amzug=Computer then
      Begin
       M:=Alpha;I:=0;
       While (I<Anzahl) and (M<Beta) do
        Begin
         VirFeld:=F;VirB:=B;inc(I);Zug:=ZugListe[I];
         MachZug(VirFeld,VirB,Zug,1);
         SucheBestZug(BestZug,AlphaBeta,VirB,N-1,VirFeld,Mensch,M,Beta);
         if (N=Tiefe) and Anzeigen then
          Begin
           Zeile:=Zug div NFeld+1;
           Spalte:=Zug mod NFeld;
           if Spalte=0 then Begin Spalte:=NFeld;dec(Zeile) End;
           AusZeile:='Wert von '+char(64+Spalte)+IntToStr(Zeile);
           AusZeile:=AusZeile+'='+IntToStr(AlphaBeta);
           Ausgabe.Lines.Add(AusZeile);
           AusZeile:=IntToStr(Count)+' analysierte Stellungen';
           Ausgabe.SelAttributes.Color:=clBlue;
           Ausgabe.Lines.Add(AusZeile);
           Ausgabe.SelAttributes.Color:=clBlack
          End;
         if M<AlphaBeta then
          Begin
           M:=AlphaBeta;
           if N=Tiefe then
            Begin
             BestZug:=Zug;
             if Anzeigen then
              Begin
               Zeile:=BestZug div NFeld+1;
               Spalte:=BestZug mod NFeld;
               if Spalte=0 then Begin Spalte:=NFeld;dec(Zeile) End;
               AusZeile:='bisher bester ComputerZug : '+char(64+Spalte)+IntToStr(Zeile);
               AusZeile:=AusZeile+'='+IntToStr(AlphaBeta);
               Ausgabe.SelAttributes.Color:=clRed;
               Ausgabe.Lines.Add(AusZeile);
               Ausgabe.SelAttributes.Color:=clBlack;
              End
            End
          End
        End
      End
     else
      Begin
       M:=Beta;I:=0;
       While (I<Anzahl) and (M>Alpha) do
        Begin
         VirFeld:=F;VirB:=B;inc(I);Zug:=ZugListe[I];
         MachZug(VirFeld,VirB,Zug,2); // Simulation des Gegners
         SucheBestZug(BestZug,AlphaBeta,VirB,N-1,VirFeld,Computer,Alpha,M);
         if M>AlphaBeta then M:=AlphaBeta
        End
      End;
     AlphaBeta:=M
    End
  End;

{****************************************************************************}
{*       Endabrechnung, Computer- und Menschzug, Utilities                  *}
{****************************************************************************}
 procedure TGomuku.Sound(Datei:String);
  Begin
   Screen.Cursor:=crHourglass;
   try
    MediaPlayer.DeviceType:=dtAutoSelect;
    MediaPlayer.FileName:=Datei;
    MediaPlayer.Open;
    MediaPlayer.wait:=True;
    MediaPlayer.Play;
    MediaPlayer.Close;
   except
    On EMCIDeviceError do
     MessageDlg('Die Datei '+Datei+' wurde NICHT gefunden!',mtError,[mbRetry],0)
    End;
   Screen.Cursor:=crHandPoint
  End;

 procedure TGomuku.SpielVerlauf;
  var K:Integer;
  Begin
   if ZugNummer>1 then
    Begin
     if MessageDlg('Soll ich den ganzen SpielVerlauf Zeigen?',
                        mtConfirmation,[mbYes,mbNo],0)=mrYes then
      Begin
       LabelStatus.Caption:='SpielVerlauf';
       LabelZug.Caption:='';DarfSpielen:=False;
       for K:=1 to ZugNummer do
        Begin
         SchreibZugNummer(K);
         F:=SpielListe[K];B:=Werte[K];
         SpielfeldAnzeige;
         if MessageDlgPos('Weiter?',mtConfirmation,[mbYes,mbNo],0,
                 Gomuku.Left+Status.Left,Gomuku.Top+Ausgabe.Top+40)=mrNo then
           Begin Laenge.Enabled:=True;exit End
        End;
       SpielEnde;Laenge.Enabled:=True;
      End
     else Begin Laenge.Enabled:=True;DarfSpielen:=False End
    End;
   End;

 procedure TGomuku.SpielEnde;
  var K,Sieg,SiegerReihe:Integer;
      Anzeige:String;
  Begin
   Sieg:=0;SiegerReihe:=0;
   for K:=1 to BAnzahl do
    if B[K].Wert=1 then
     Begin if B[K].Anzahl=5 then Begin SiegerReihe:=K;Sieg:=1 End End
    else
     if B[K].Wert=2 then
      Begin if B[K].Anzahl=5 then Begin SiegerReihe:=K;Sieg:=2 End End;
   if Sieg=1 then
    Begin
     LabelEnde.Font.Color:=clRed;
     if not ZweiSpielerModus and not NetzSpiel then
      Begin
       Anzeige:='SuperPC hat gewonnen!';
       if SoundAn then Sound('Computersieg.wav')
      End
     else Anzeige:=Spieler1+' gewinnt!';
     for K:=1 to 5 do
      F[Reihe[SiegerReihe].FeldNr[K]].Art:=3;
    End;
   if Sieg=2 then
    Begin
     LabelEnde.Font.Color:=clGreen;
     if not ZweiSpielerModus and not NetzSpiel then
      Begin
       Anzeige:='Du hast mich besiegt!';
       if SoundAn then Sound('Menschsieg.wav')
      End
     else Anzeige:=Spieler2+' gewinnt!';
     for K:=1 to 5 do
      F[Reihe[SiegerReihe].FeldNr[K]].Art:=4;
    End;
   if Remis(B) then Anzeige:='Remis!!!'
   else SpielfeldAnzeige;
   LabelEnde.Caption:=Anzeige;
   LabelStatus.Caption:='Das Spiel ist zu Ende';
   if NetzSpiel then
    Begin
     DisConnect;
     Caption:='Gobang  Verbindung beendet!';
    End
  End;

 procedure TGomuku.SchreibZugNummer(Nr:Integer);
  Begin LabelZugNr.Caption:=IntToStr(Nr) End;
{****************************************************************************}
{*                          Zugberechnungen                                 *}
{****************************************************************************}
 procedure TGomuku.ComputerZug;
  var AlphaBeta:Integer;
      BestZug:TSpielzug;
      Zeile,Spalte,K,L,Anzahl:Integer;
      VirFeld:TSpielFeld;
      Zug:TSpielzug;
      ZugListe:TSpielzugListe;
      VirB:TBewertung;
      TSek:Extended;
  Begin
   Ausgabe.Clear;
   Screen.Cursor:=crHourglass;Service.Enabled:=False;
   LabelStatus.Caption:='PC denkt nach!';
   Delay(500);Count:=0;BestZug:=400;
   if ZugNummer=0 then BestZug:=NFeld*(NFeld div 2)+NFeld div 2+1;
   for K:=1 to BAnzahl do
    Begin
     if (B[K].Wert=1) and (B[K].Anzahl=4) then
      Begin
       for L:=1 to 5 do
        if F[Reihe[K].FeldNr[L]].Art mod 5=0 then // wegen Markierung
         Begin BestZug:=Reihe[K].FeldNr[L];Break End
      End;
     if BestZug<400 then Break
    End;
   if BestZug=400 then
    Begin
     for K:=1 to BAnzahl do
      Begin
       if (B[K].Wert=2) and (B[K].Anzahl=4) then
        Begin
         for L:=1 to 5 do
          if F[Reihe[K].FeldNr[L]].Art=0 then
           Begin BestZug:=Reihe[K].FeldNr[L];Break End
        End;
       if BestZug<400 then Break
      End;
    End;
   if BestZug=400 then Level:=Tiefe else Level:=1;
   LabelTiefe.Caption:=IntToStr(Level);
   if (BestZug=400) and (ZugNummer>0) then
    Begin
     TSek:=TimeSekunden;
     SucheBestZug(BestZug,AlphaBeta,B,Tiefe,F,Computer,MinInt,MaxInt);
     TSek:=TimeSekunden-TSek;
     Ausgabe.SelAttributes.Color:=clGreen;
     Ausgabe.Lines.Add('Rechenzeit : '+Format('%0.2f',[TSek])+' Sek.');
     Ausgabe.SelAttributes.Color:=clBlack;
     if AlphaBeta>5000 then // mu an Bewertung angepat werden
      Begin
       LabelEnde.Font.Color:=clFuchsia;
       LabelEnde.Caption:='Du wirst verlieren!'
      End
     else
      if AlphaBeta<-5000 then
       Begin
        LabelEnde.Font.Color:=clBlue;
        LabelEnde.Caption:='Der PC hat keine Chance!'
       End
      else LabelEnde.Caption:='';
    End;
   Screen.Cursor:=crHandPoint;
   Zeile:=BestZug div NFeld+1;Spalte:=BestZug mod NFeld;
   if Spalte=0 then Begin Spalte:=NFeld;dec(Zeile) End;
   LabelZug.Caption:='Mein Zug : '+char(64+Spalte)+IntToStr(Zeile);
   MachZug(F,B,BestZug,1);
   SpielfeldAnzeige;
   if NetzSpiel then
    Begin
     Meldung:=char(BestZug);
     // Meldung mu gesendet werden
     if IsServer then ServerSocket.Socket.Connections[0].SendText(Meldung)
     else ClientSocket.Socket.SendText(Meldung);
     Dran:=not Dran;
    End;
   Service.Enabled:=True;
   inc(ZugNummer);SchreibZugNummer(ZugNummer);
   SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
   if Schluss(B) or Remis(B) then
    Begin SpielEnde;SpielVerlauf End
   else
    Begin
     LabelStatus.Caption:=Spieler2+' zieht!';
     WerZieht:=Mensch;
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirB:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirB,Zug,1);
         for L:=1 to BAnzahl do
          if (VirB[L].Wert=1) and (VirB[L].Anzahl=5) then F[Zug].Art:=5;
         SpielfeldAnzeige;
        End
      End;
     SpielFeldAusgabe.Enabled:=True;
    End
  End;

 procedure TGomuku.SpielFeldAusgabeMouseDown(Sender: TObject;  //Menschzug
                   Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var Zug:TSpielzug;
      Col,Row,Zeile,Spalte:Integer;
      Rect:TRect;
  Begin
   if not DarfSpielen then
    Begin
     MessageDlg('Du mut erst das Spiel starten!',mtError,[mbRetry],0);
     exit
    End;
   if NetzSpiel then exit;
   if (X>18) and (Y>18) and not Schluss(B) and not Remis(B) then
    Begin
     SpielFeldAusgabe.MouseToCell(X,Y,Col,Row);
     Zug:=Col+NFeld*(Row-1);
     SpielFeldAusgabe.Enabled:=False;
     if (Zug>0) and (Zug<=NSqr) then
      Begin
       if F[Zug].Art mod 5>0 then
        Begin
         LabelStatus.Caption:='Dies Feld ist besetzt!';
         Delay(500);
         if SoundAn then Sound('Fehler.wav');
         LabelStatus.Caption:=Spieler1+' zieht!';
         exit
        End;
       Zeile:=Zug div NFeld+1;Spalte:=Zug mod NFeld;
       if Spalte=0 then Begin Spalte:=NFeld;dec(Zeile) End;
       LabelZug.Caption:='Dein Zug : '+char(64+Spalte)+IntToStr(Zeile);
       inc(ZugNummer);SchreibZugNummer(ZugNummer);
       if ZweiSpielerModus then
        Begin
         if WerZieht=Computer then
          Begin
           MachZug(F,B,Zug,1);
           LabelStatus.Caption:=Spieler2+' zieht!';
           WerZieht:=Mensch;
          End
         else
          Begin
           MachZug(F,B,Zug,2);
           LabelStatus.Caption:=Spieler1+' zieht!';
           WerZieht:=Computer;
          End;
         with SpielFeldAusgabe do
          Begin
           Brush.Color:=Farbe[F[Col+NFeld*(Row-1)].Art];
           Rect:=CellRect(Col,Row);
           Canvas.Ellipse(Rect.Left+2,Rect.Top+2,Rect.Right-2,Rect.Bottom-2)
          End;
         SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
         Delay(WarteZeit);
         if Schluss(B) or Remis(B) then
          Begin SpielEnde;SpielVerlauf End;
         SpielFeldAusgabe.Enabled:=True;
        End
       else
        Begin
         MachZug(F,B,Zug,2);
         with SpielFeldAusgabe do
          Begin
           Brush.Color:=Farbe[F[Col+NFeld*(Row-1)].Art];
           Rect:=CellRect(Col,Row);
           Canvas.Ellipse(Rect.Left+2,Rect.Top+2,Rect.Right-2,Rect.Bottom-2)
          End;
         SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
         Delay(WarteZeit);
         if Schluss(B) or Remis(B) then
          Begin SpielEnde;SpielVerlauf End
         else Begin WerZieht:=Computer;ComputerZug End
        End
      End
     else SpielFeldAusgabe.Enabled:=True;
    End
  End;

 procedure TGomuku.SucheZug(var Zug:TSpielzug;SF:TSpielFeld;SB:TBewertung);
  var VirFeld:TSpielFeld;
      VirB:TBewertung;
      Nr,K,AN:Integer;
      Grenze,MinMaxWert,GrenzWert:Integer;
      Liste,ZL:TSpielzugListe;
      Zeigen:Boolean;
  Begin
   Grenze:=MaxInt;Nr:=0;Zeigen:=Anzeigen;
   if Anzeigen then Anzeigen:=False;
   GenZugListe(SF,Mensch,AN,ZL);
   if SpielerName='Meister' then GrenzWert:=Max(3,Tiefe)
   else GrenzWert:=Min(Tiefe,3);
   for K:=1 to AN do
    Begin
     VirFeld:=SF;VirB:=SB;Zug:=ZL[K];
     MachZug(VirFeld,VirB,Zug,2);
     SucheBestZug(Zug,MinMaxWert,VirB,GrenzWert,VirFeld,Computer,MinInt,MaxInt);
     if MinMaxWert<=Grenze then
      Begin
       if MinMaxWert=Grenze then inc(Nr);
       if MinMaxWert<Grenze then Nr:=1;
       Liste[Nr]:=ZL[K];Grenze:=MinMaxWert;
      End;
    End;
   K:=random(Nr)+1;Zug:=Liste[K];Anzeigen:=Zeigen
  End;
{****************************************************************************}
{*                         Spiel - Parameter festlegen                      *}
{****************************************************************************}
 procedure TGomuku.Init;
  Begin
   F:=FAlt;
   SpielFeldAnzeige;
   Zugvorschlag.Enabled:=True;
   Zugbewertung.Enabled:=True;
   Staerke.Enabled:=True;
   LabelStatus.Caption:='';
   LabelTiefe.Caption:='';
   LabelZugNr.Caption:='';
   LabelZug.Caption:='';
   LabelEnde.Caption:='';
   ZugNummer:=0;SpielListe[ZugNummer]:=F;
   FillChar(B,SizeOf(B),0); // B=0 setzen
   Werte[ZugNummer]:=B;
  End;

 procedure TGomuku.NameErmitteln(Name:String;var SpielerName:String);
  const Max=9;
        NameListe:Array[0..Max]of String=('Ahab','Brsel','Meister','Schrder',
                                          'Jacobs','Schneider','Nelson',
                                          'Columbus','Magellan','Nemo');
  var Zahl,ersterBuchstabe:String;
  Begin
   SpielerName:='';
   if ZweiSpielerModus then PasswordDlg.Caption:=Name+', dein Name!'
   else PasswordDlg.Caption:='Wie heit Du, '+Name+'?';
   if ZweiSpielerModus then PasswordDlg.LabelPasswort.Caption:='Dein Partner fordert Dich!'
   else PasswordDlg.LabelPasswort.Caption:='Der Computer fordert Dich!';
   PasswordDlg.Passwort.PasswordChar:=#0;
   PasswordDlg.Passwort.Text:=NameListe[random(3)];
   repeat
    PasswordDlg.ShowModal;
    SpielerName:=PasswordDlg.Passwort.Text;
    while Pos(' ',SpielerName)>0 do  // lscht alle Leerzeichen
     begin Delete(SpielerName,Pos(' ',SpielerName),1) end;
    while Pos('FIETE',AnsiUpperCase(SpielerName))>0 do  // lscht alle Fiete
     begin Delete(SpielerName,Pos('FIETE',AnsiUpperCase(SpielerName)),5) end;
    if Length(SpielerName)<3 then
     PasswordDlg.Passwort.Text:=NameListe[random(3)];
   until Length(SpielerName)>2;
   SpielerName:=AnsiLowerCase(SpielerName);
   ersterBuchstabe:=AnsiUpperCase(SpielerName[1]);
   SpielerName[1]:=ersterBuchstabe[1];
   if AnsiUpperCase(SpielerName)='MEISTER' then
    Begin
     PasswordDlg.Caption:='Paworteingabe';
     PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
     PasswordDlg.Passwort.PasswordChar:='?';
     PasswordDlg.Passwort.Text:='';
     PasswordDlg.ShowModal;
     Zahl:=PasswordDlg.Passwort.Text;
     if Zahl<>Geheim then SpielerName:='Betrger';
    End;
  End;
{****************************************************************************}
{*                         Men - Prozeduren                                *}
{****************************************************************************}
 procedure TGomuku.StartClick(Sender: TObject);
   var P:PChar;
      Size:DWord;
  Begin
   if SoundAn then Sound('Welcomef.wav');
   Init;DarfSpielen:=True;
   LabelEnde.Caption:='';
   UpdateCaption;
   if ZweiSpielerModus then
    Begin
     NameErmitteln('Spieler1',SpielerName);
     Spieler1:=SpielerName;
     NameErmitteln('Spieler2',SpielerName);
     Spieler2:=SpielerName;
     Zugvorschlag.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
     WerZieht:=Computer;
    End
   else
    if NetzSpiel then
     begin
      VerbindungVorhanden:=False;
      Connected:=False;
      // Computername ermitteln
      Size:=MAX_COMPUTERNAME_LENGTH+1;
      P:=StrAlloc(Size);
      Windows.GetComputername(P,Size);
      SpielerName:=P;
      Spieler1:=SpielerName;
      Spieler2:='PC-Gegner';
      StrDispose(P);
      ClientSocket.Host:=Spieler1;
      NetzwerkVerbindung.Enabled:=True;
     end
   else
    Begin
     Spieler1:='Computer';
     NameErmitteln('Spieler',SpielerName);
     Spieler2:=SpielerName;
     if Menschbeginnt.Checked then WerZieht:=Mensch
     else WerZieht:=Computer
    End;
   if not NetzSpiel then
    begin
     if WerZieht=Mensch then LabelStatus.Caption:=Spieler2+' zieht!'
     else LabelStatus.Caption:=Spieler1+' zieht!';
    end;
   LabelComputer.Caption:=Spieler1;
   LabelMensch.Caption:=Spieler2;
   SpielFeldAusgabe.Enabled:=False;
   if ZweiSpielerModus then SpielFeldAusgabe.Enabled:=True
   else
    begin
     if not NetzSpiel then
      if WerZieht=Computer then ComputerZug
      else SpielFeldAusgabe.Enabled:=True;
    end
  End;

 procedure TGomuku.EndeClick(Sender: TObject);
  Begin close End;

 procedure TGomuku.LevelWahl(Sender: TObject);
  Begin
   if Sender=N1Anfaenger then
    Begin Tiefe:=1;N1Anfaenger.Checked:=True End;
   if Sender=N2Geuebter  then
    Begin Tiefe:=2;N2Geuebter.Checked:=True End;
   if Sender=N3Erfahrener then
    Begin Tiefe:=3;N3Erfahrener.Checked:=True End;
   if Sender=N4Fortgeschrittener then
    Begin Tiefe:=4;N4Fortgeschrittener.Checked:=True End;
   if Sender=N5Koenner then
    Begin Tiefe:=5;N5Koenner.Checked:=True End;
   if Sender=N6Meister then
    Begin Tiefe:=6;N6Meister.Checked:=True End;
   if Sender=N7Grossmeister then
    Begin Tiefe:=7;N7Grossmeister.Checked:=True End;
   if Sender=N8Weltmeister then
    Begin Tiefe:=8;N8Weltmeister.Checked:=True End;
   if Sender=N9Genie then
    Begin Tiefe:=9;N9Genie.Checked:=True End;
   if Sender=N10Superhirn then
    Begin Tiefe:=10;N10Superhirn.Checked:=True End;
   if Sender=N11AlbertEinstein then
    Begin Tiefe:=11;N11AlbertEinstein.Checked:=True End;
   LabelTiefe.Caption:=IntToStr(Tiefe);
  End;

 procedure TGomuku.Wer_Beginnt(Sender: TObject);
  Begin
   if Sender=Menschbeginnt then
    Begin
     WerZieht:=Mensch;
     ZweiSpielerModus:=False;
     Menschbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugruecknahme.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
     Netzwerkverbindung.Enabled:=False;
     NetzSpiel:=False;
    End;
   if Sender=Computerbeginnt then
    Begin
     WerZieht:=Computer;
     ZweiSpielerModus:=False;
     Computerbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugruecknahme.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
     Netzwerkverbindung.Enabled:=False;
     NetzSpiel:=False;
    End;
   if Sender=MenschgegenMensch then
    Begin
     WerZieht:=Mensch;
     ZweiSpielerModus:=True;
     MenschgegenMensch.Checked:=True;
     LabelTiefe.Caption:='';
     Zugvorschlag.Enabled:=False;
     Zugruecknahme.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
     WarnHinweis.Enabled:=False;
     Netzwerkverbindung.Enabled:=False;
     NetzSpiel:=False;
    End;
   if Sender=NetzwerkSpiel then
    Begin
     NetzSpiel:=True;
     NetzwerkSpiel.Checked:=True;
     ZweiSpielerModus:=False;
     Zugvorschlag.Enabled:=False;
     Zugruecknahme.Enabled:=False;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
    End;
  End;

 procedure TGomuku.ZugbewertungClick(Sender: TObject);
  Begin
   if MessageDlg('Soll die TBewertung angezeigt werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     Gomuku.Width:=Ausgabe.Left+Ausgabe.Width+10;
     Gomuku.Position:=poScreenCenter;
     MessageDlg('Die Bewertunganzeige ist aktiv!',mtInformation,[mbOk],0);
     Anzeigen:=True;
     Ausgabe.Visible:=True
    End
   else
    Begin
     Ausgabe.Visible:=False;Anzeigen:=False;
     Gomuku.Width:=Ausgabe.Left;Gomuku.Position:=poScreenCenter;
    End;
   Zugbewertung.Checked:=Anzeigen;
  End;

 procedure TGomuku.ZugvorschlagClick(Sender: TObject);
  var VirFeld:TSpielFeld;
      VirB:TBewertung;
      Zug:TSpielzug;
      Zeile,Spalte:Integer;
  Begin
   VirFeld:=F;VirB:=B;Screen.Cursor:=crHourGlass;
   LabelStatus.Caption:='Ich suche fr Dich!';
   SucheZug(Zug,VirFeld,VirB);Screen.Cursor:=crHandPoint;
   Zeile:=Zug div NFeld+1;Spalte:=Zug mod NFeld;
   if Spalte=0 then Begin Spalte:=NFeld;dec(Zeile) End;
   ShowMessage('Mein Vorschlag :'+#13+'setze jetzt auf '+
                                 char(64+Spalte)+IntToStr(Zeile));
   LabelStatus.Caption:='Dein Zug : ';
  End;

 procedure TGomuku.ZugruecknahmeClick(Sender: TObject);
  var K,L,Anzahl:Integer;
      VirFeld:TSpielFeld;
      Zug:TSpielzug;
      ZugListe:TSpielzugListe;
      VirB:TBewertung;
  Begin
   if ZugNummer>1 then
    Begin
     Gomuku.LabelEnde.Caption:='';
     dec(ZugNummer,2);SchreibZugNummer(ZugNummer);
     F:=SpielListe[ZugNummer];B:=Werte[ZugNummer];
     SpielfeldAnzeige;
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirB:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirB,Zug,1);
         for L:=1 to BAnzahl do
          if (VirB[L].Wert=1) and (VirB[L].Anzahl=5) then F[Zug].Art:=5;
         SpielfeldAnzeige;
        End
      End;
     LabelStatus.Caption:='Dein Zug : ';
    End
  End;

 procedure TGomuku.InfoClick(Sender: TObject);
  Begin InfoBox.ShowModal End;

 procedure TGomuku.RegelnClick(Sender: TObject);
  Begin RegelnBox.ShowModal End;

 procedure TGomuku.TonClick(Sender: TObject);
  Begin
   if MessageDlg('Soll der Sound aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Der Sound ist aktiv!',mtInformation,[mbOk],0);
     SoundAn:=True;
    End
   else SoundAn:=False;
   Ton.Checked:=SoundAn;
  End;

 procedure TGomuku.GewinnReihen;
  var Zeile:String;
      I,K,L,Waagerecht,Diagonal:Integer;
  Begin
   Screen.Cursor:=crHourGlass;
   Waagerecht:=NFeld*(NFeld-4);Diagonal:=SQR(NFeld-4);
   // Konstanten werden festgelegt
   for K:=1 to 3 do
    Begin ZugWeite[K]:=NFeld+K-2;ZugWeite[K+3]:=-NFeld-K+2 End;
   ZugWeite[7]:=1;ZugWeite[8]:=-1;NSqr:=SQR(NFeld);
   BAnzahl:=2*(Waagerecht+Diagonal);
   // Bewertungreihen werden definiert

     // waagerechte Reihen 
     // senkrechte Reihen
     // diagonal steigende Reihen
     // diagonal fallende Reihen

   Ausgabe.Clear;
   Ausgabe.Lines.Add('Gewinnreihen');
   for L:=1 to BAnzahl do
    Begin
     Zeile:=IntToStr(L)+') ';
     for K:=1 to 4 do Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[K])+' - ';
     Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[5]);
     Ausgabe.Lines.Add(Zeile);
    End;
   for I:=1 to NSqr do
    Begin
     F[I].Art:=0;F[I].Anzahl:=0;
     for L:=1 to BAnzahl do
      for K:=1 to 5 do
       if Reihe[L].FeldNr[K]=I then
        Begin inc(F[I].Anzahl);F[I].WO[F[I].Anzahl]:=L End
    End;
   Ausgabe.Lines.Add('');
   Ausgabe.Lines.Add('Feldinhalte');
   for I:=1 to NSqr do
    Begin
     Zeile:=IntToStr(I)+') ';
     for K:=1 to F[I].Anzahl-1 do Zeile:=Zeile+IntToStr(F[I].WO[K])+' - ';
     Zeile:=Zeile+IntToStr(F[I].WO[F[I].Anzahl]);
     Ausgabe.Lines.Add(Zeile);
    End;
   Screen.Cursor:=crHandPoint;
   FAlt:=F;
  End;

 procedure TGomuku.FormCreate(Sender: TObject);
 const ScreenHeightDev=768;ScreenWidthDev=1024;
  var x,y:Integer;
      Wer:String;
      Heute:TDateTime;
      Jahr,Monat,Tag:Word;
  Begin
   Heute:=Now;
   DecodeDate(Heute,Jahr,Monat,Tag);
   CopyRightName(Wer);
   if Wer<>'Inf343' then
    begin
     MessageDlg(' Du hast das  verletzt!!!!',mtError,[mbOk],0);
     Application.Terminate
    end;
   Kopf:='Gobang '+IntToStr(Jahr)+'/'+IntToStr(Jahr+1)+'   '+Wer;
   Gomuku.Caption:=Kopf;
   Scaled:=True;x:=Screen.width;y:=screen.height;
   if (y<>ScreenHeightDev) or (x<>ScreenWidthDev) then
    Begin
     Height:=(ClientHeight*y div ScreenHeightDev)+Height-ClientHeight;
     Width:=(ClientWidth*x div ScreenWidthDev)+Height-ClientHeight;
     ScaleBy(x,ScreenwidthDev);
    End;
   Screen.Cursor:=crHandPoint;
   CopyRight;Randomize;
   Farbe[1]:=clRed;Farbe[2]:=clGreen;
   Farbe[3]:=clMaroon;Farbe[4]:=clLime;
   Farbe[5]:=clAqua;
   Init;WerZieht:=Computer;Tiefe:=3;NFeld:=11;GewinnReihen;
   with SpielFeldAusgabe do
    Begin
     Visible:=False;
     ColCount:=NFeld+1;RowCount:=NFeld+1;
     Height:=(NFeld+1)*19+4;Width:=Height;
     Left:=40+(18-NFeld)*10;TOP:=Left;
     Visible:=True;
    End;
   LabelTiefe.Caption:=IntToStr(Tiefe);
   Screen.Cursor:=crHandPoint;
   CopyRight;Randomize;
   Init;WerZieht:=Computer;Tiefe:=3;
   LabelTiefe.Caption:=IntToStr(Tiefe);
   Anzeigen:=True;//Bewertungsanzeige
   Warnung:=True;// Verlustanzeige
   Ausgabe.Visible:=Anzeigen;
   DarfSpielen:=False;SoundAn:=False;
   Ton.Checked:=False;
   ServerSocket.Active:=True;
   Connected:=False;
   VerbindungVorhanden:=False;
   IsServer:=True;
   ShallMove:=False;
   UpdateCaption;
   Start.Enabled:=True;
   Netzwerkverbindung.Enabled:=False;
   NetzSpiel:=False;
   NetzWarteZeit:=3000;
  End;

 procedure TGomuku.WarnHinweisClick(Sender: TObject);
  Begin
   if MessageDlg('Soll die Hinweiswarnung aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Der Hinweiswarnung ist aktiv!',mtInformation,[mbOk],0);
     Warnung:=True;
    End
   else Warnung:=False;
   WarnHinweis.Checked:=Warnung;
  End;

 procedure TGomuku.BrettWahl(Sender: TObject);
  Begin
   if Sender=N7x7 then Begin NFeld:=7;N7x7.Checked:=True End;
   if Sender=N9x9 then Begin NFeld:=9;N9x9.Checked:=True End;
   if Sender=N11x11 then Begin NFeld:=11;N11x11.Checked:=True End;
   if Sender=N13x13 then Begin NFeld:=13;N13x13.Checked:=True End;
   if Sender=N15x15 then Begin NFeld:=15;N15x15.Checked:=True End;
   if Sender=N17x17 then Begin NFeld:=17;N17x17.Checked:=True End;
   if Sender=N19x19 then Begin NFeld:=19;N19x19.Checked:=True End;
   GewinnReihen;SpielfeldAnzeige;
   with SpielFeldAusgabe do
    Begin
     Visible:=False;
     ColCount:=NFeld+1;RowCount:=NFeld+1;
     Height:=(NFeld+1)*19+4;Width:=Height;
     Left:=40+(18-NFeld)*10;TOP:=Left;
     Visible:=True;
    End;
  End;

 procedure TGomuku.SpielFeldAusgabeDrawCell(Sender: TObject; Col,
                        Row: Integer; Rect: TRect; State: TGridDrawState);
  const Ziffer=' 1 2 3 4 5 6 7 8 910111213141516171819';
  Begin
   with SpielFeldAusgabe.Canvas do
    Begin
     if (Col=0) or (Row=0) then
      Begin
       Brush.Color:=clnavy;
       Brush.Style:=bsSolid;
       FillRect(Rect);
       Brush.Style:=bsClear;
       Font.Color:=clYellow;
       Font.Style:=[fsBold];
       if Row=0 then
        if Col>0 then TextOut(Rect.Left+4,Rect.Top+3,char(Col+64));
       if Col=0 then
        if Row>0 then TextOut(Rect.Left+2,Rect.Top+3,Copy(Ziffer,2*Row-1,2))
      End
     else
      Begin
       Brush.Style:=bsSolid;
       if F[Col+NFeld*(Row-1)].Art=0 then
        Begin Brush.Color:=clOlive;FillRect(Rect) End
       else
        Begin
         Brush.Color:=Farbe[F[Col+NFeld*(Row-1)].Art];
         Ellipse(Rect.Left+2,Rect.Top+2,Rect.Right-2,Rect.Bottom-2)
        End
      End
    End;
  End;

 procedure TGomuku.AbbruchClick(Sender: TObject);
  Begin
   if MessageDlg('Willst du wirklich abbrechen?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     Hinweis('Spielabbruch');DisConnect;
    End
  End;

 procedure TGomuku.DisConnect;
  Begin
   ClientSocket.Active:=False;
   ServerSocket.Active:=True;
   Connected:=False;
   VerbindungVorhanden:=False;
   Start.Enabled:=True;
   NetzwerkVerbindung.Enabled:=False;
   Dran:=False;
   IsServer:=True;
  End;

 procedure TGomuku.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  Begin
   if MessageDlg('Willst du das Spiel beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Das Spiel wird beendet!',mtWarning,[mbOk],0);
     if SoundAn then Sound('Goodbyef.wav');
     CanClose:=True
    End
   else CanClose:=False
  End;

 procedure TGomuku.UpdateCaption;
  var scolor,smessage:string;
  begin
   if not Connected then
    begin
     scolor:='';
     if NetzSpiel then smessage:='warte auf Verbindung...'
     else smessage:=''
    end
   else
    begin
     scolor:=' ('+SpielerName+')';
     if ShallMove then smessage:='bitte setzen!'
     else smessage:='wartet auf Zug der Gegenseite...';
    end;
   Caption:=Format(Kopf+'  %s - %s', [scolor, smessage]);
  end;

 procedure TGomuku.NetzwerkVerbindungClick(Sender: TObject);
  var Servername:String;
  begin
   if Connected then
    begin
     MessageDlg('Verbindung bereits aktiv!',mtError,[mbOk],0);
     exit
    end;
   Servername:='Inf16a';
   if ClientSocket.Active then ClientSocket.Active:=False;
    if InputQuery('Verbindung mit Gegenspieler','Es beginnt (PC-Name):',Servername) then
     if Length(Servername)>0 then
      with ClientSocket do
       begin
        Host:=Servername;
        Active:=True;
        Connected:=True;
      end;
  end;

 procedure TGomuku.ClientSocketConnect(Sender: TObject;Socket: TCustomWinSocket);
  begin
   Spieler2:=Socket.RemoteHost;
   if pos('.',Spieler2)>0 then Spieler2:=copy(Spieler2,1,pos('.',Spieler2)-1);
   LabelMensch.Caption:=Spieler2;
   Connected:=True;
   Start.Enabled:=False;
   IsServer:=False;
   ShallMove:=False;
   UpdateCaption;
  end;

 procedure TGomuku.ZugAuswertung(Meldung:String);
  var BestZug:TSpielZug;
      Zeile,Spalte,K,L,Anzahl:Integer;
      VirFeld:TSpielFeld;
      Zug:TSpielZug;
      ZugListe:TSpielZugListe;
      VirBewertung:TBewertung;
  begin
   BestZug:=ord(Meldung[1]);
   Zeile:=BestZug div NFeld+1;Spalte:=BestZug mod NFeld;
   if Spalte=0 then Begin Spalte:=NFeld;dec(Zeile) End;
   LabelZug.Caption:='Dein Zug : '+char(64+Spalte)+IntToStr(Zeile);
   MachZug(F,B,BestZug,2);
   SpielfeldAnzeige;
   inc(ZugNummer);SchreibZugNummer(ZugNummer);
   SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
   if Schluss(B) or Remis(B) then
    Begin SpielEnde;SpielVerlauf End
   else
    Begin
     LabelStatus.Caption:=Spieler1+' zieht!';
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirBewertung:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirBewertung,Zug,1);
         for L:=1 to BAnzahl do
          if (VirBewertung[L].Wert=1) and (VirBewertung[L].Anzahl=5) then F[Zug].Art:=5;
         SpielfeldAnzeige;
        End
      End;
     ComputerZug
    End
  end;

 procedure TGomuku.ClientSocketDisconnect(Sender: TObject;
                                          Socket: TCustomWinSocket);
  begin Connected:=False end;

 procedure TGomuku.SocketRead(Sender: TObject;Socket: TCustomWinSocket);
  var Meldung:String;
  begin
   Meldung:=Socket.ReceiveText;
   if Length(Meldung)=1 then ZugAuswertung(Meldung)
    else
     begin
      MessageDlg('ProgrammFehler in SocketRead!'+#13+Meldung,mtError,[mbOk],0);
      exit
     end;
   // Der folgende Ausdruck ist wahr, wenn beide
   // Boolean-Variablen den Wert True oder beide den Wert False haben
   ShallMove:=not (IsServer xor Dran);
   UpdateCaption;Delay(NetzWarteZeit);
  end;

 procedure TGomuku.ServerSocketClientConnect(Sender: TObject;
                                             Socket: TCustomWinSocket);
  begin
   Spieler2:=Socket.RemoteHost;
   if pos('.',Spieler2)>0 then Spieler2:=copy(Spieler2,1,pos('.',Spieler2)-1);
   LabelMensch.Caption:=Spieler2;
   Connected:=True;
   Start.Enabled:=False;
   NetzwerkVerbindung.Enabled:=True;
   IsServer:=True;
   ShallMove:=True; //Server beginnt das Spiel
   ComputerZug;
   UpdateCaption;
  end;

 procedure TGomuku.ServerSocketClientDisconnect(Sender: TObject;
                                                Socket: TCustomWinSocket);
  begin Connected:=False end;

End.

