unit RegelnUnit5;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm5 = class(TForm)
    Memo1: TMemo;
    BottomImage: TImage;
    RightImage: TImage;
    LeftImage: TImage;
    TopImage: TImage;
    OK: TButton;
    Label5: TLabel;
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
    procedure ZeichneRand;
    procedure FormCreate(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKKeyPress(Sender: TObject; var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form5: TForm5;

implementation

uses InfoUnit4;

{$R *.dfm}

 procedure TForm5.FormCreate(Sender: TObject);
  begin
       SetWindowRgn(handle, CreateRoundRectRgn(0, 0, clientwidth, clientheight, 50, 50 ), true );
       ZeichneRand;
  end;

 procedure TForm5.ZeichneRand;
  var k:Integer;
      Farbe:TColor;
  begin
       TopImage.Width:=ClientWidth;
       TopImage.Top:=0;
       TopImage.Left:=0;
       BottomImage.Width:=ClientWidth;
       BottomImage.Top:=ClientHeight-26;
       BottomImage.Left:=0;
       for k:=0 to ClientWidth do
       begin
            Farbe:=RGB(Round(255*k/ClientWidth), Round(255*k/ClientWidth), 0);
            with TopImage.Canvas do
            begin
                 Pen.Color:=Farbe;
                 Pen.Width:=2;
                 Pen.Style:=psInsideFrame;
                 MoveTo(k,0);
                 LineTo(k,25);
            end;
            with BottomImage.Canvas do
            begin
                 Pen.Color:=Farbe;
                 Pen.Width:=2;
                 Pen.Style:=psInsideFrame;
                 MoveTo(ClientWidth-k,0);
                 LineTo(ClientWidth-k,25);
            end;
       end;
       LeftImage.Top:=25;
       LeftImage.Left:=0;
       LeftImage.Width:=3;
       LeftImage.Height:=ClientHeight-50;
       RightImage.Top:=25;
       RightImage.Left:=ClientWidth-4;
       RightImage.Width:=3;
       RightImage.Height:=ClientHeight-50;
       for k:=0 to LeftImage.Height do
       begin
            Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
            with LeftImage.Canvas do
            begin
                 Pen.Color:=Farbe;
                 Pen.Width:=5;
                 Pen.Style:=psInsideFrame;
                 MoveTo(0,k);
                 LineTo(2,k);
            end;
            Farbe:=RGB(Round(255*k/LeftImage.Height), Round(255*k/LeftImage.Height), 0);
            with RightImage.Canvas do
            begin
                 Pen.Color:=Farbe;
                 Pen.Width:=5;
                 Pen.Style:=psInsideFrame;
                 MoveTo(0,LeftImage.Height-k);
                 LineTo(2,LeftImage.Height-k);
            end;
       end;
  end;

 procedure TForm5.WMNCHitTest (var M: TWMNCHitTest);
  var Position:TPoint;
  begin
       inherited;
       if ((PtInRect(Rect(TopImage.Left,TopImage.Top,TopImage.Left+TopImage.Width,TopImage.Top+TopImage.Height), Point(M.Pos.X-Left,M.Pos.Y-Top)))
       or (PtInRect(Rect(BottomImage.Left,BottomImage.Top,BottomImage.Left+BottomImage.Width,BottomImage.Top+BottomImage.Height), Point(M.Pos.X-Left,M.Pos.Y-Top))))
       and (M.Result=htClient) then M.Result:=htCaption;
  end;

 procedure TForm5.OKClick(Sender: TObject);
  begin
       Form5.Hide;
  end;

 procedure TForm5.FormShow(Sender: TObject);
  begin
       Top:=(Screen.Height div 2) - (Height div 2);
       Left:=(Screen.Width div 2)- (Width div 2);
  end;

 procedure TForm5.OKKeyPress(Sender: TObject; var Key: Char);
  begin
       if key=#13 then OK.Click;
       if key=#27 then close;
  end;

end.
