unit Schiffeversenken; // letzte nderung 10.12.2000

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, MPlayer, ComCtrls, Grids;

 const RAHMEN=128;RAND=255;
       SCHIFFLISTE:ARRAY[1..10]OF BYTE=(4,3,3,2,2,2,1,1,1,1);
type
  BEREICH=ARRAY[0..11,0..11]OF BYTE;
  Spieler=(Computer,Mensch);
  TSchiffe = class(TForm)
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Start: TMenuItem;
    Staerke: TMenuItem;
    N1Anfaenger: TMenuItem;
    N2Geuebter: TMenuItem;
    N3Erfahrener: TMenuItem;
    N4Fortgeschrittener: TMenuItem;
    N5Koenner: TMenuItem;
    N6Meister: TMenuItem;
    N7Grossmeister: TMenuItem;
    N8Weltmeister: TMenuItem;
    N9Genie: TMenuItem;
    N10Superhirn: TMenuItem;
    N11AlbertEinstein: TMenuItem;
    Einstellungen: TMenuItem;
    Menschbeginnt: TMenuItem;
    Computerbeginnt: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    Regeln: TMenuItem;
    Ende: TMenuItem;
    LabelComputer: TLabel;
    N1: TMenuItem;
    N2: TMenuItem;
    ComputerFeldAusgabe: TDrawGrid;
    MenschFeldAusgabe: TDrawGrid;
    MediaPlayer: TMediaPlayer;
    LabelHinweis: TLabel;
    Service: TMenuItem;
    Ton: TMenuItem;
    LabelMensch: TLabel;
    LabelMenschHinweis: TLabel;
    Markierung: TMenuItem;
    Abbrechen: TMenuItem;
    procedure StartClick(Sender: TObject);
    procedure LevelWahl(Sender: TObject);
    procedure Wer_Beginnt(Sender: TObject);
    procedure EndeClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure Sound(Datei:String);
    PROCEDURE COPYRIGHT;
    PROCEDURE SPIELFELDANZEIGE;
    procedure Delay(Zeit:DWord);// Pausenzeit in Millisekunden
    PROCEDURE COMPUTERZUG;
    PROCEDURE INIT;
    PROCEDURE BLOCKIEREN(VAR F:BEREICH;X,Y,LAENGE,R:BYTE);
    PROCEDURE SCHIFFSETZEN(NR:BYTE;VAR FELD:BEREICH);
    procedure NameErmitteln(Name:String;Var SPIELERNAME:String);
    procedure Hinweis(T:PChar);
    procedure TonClick(Sender: TObject);
    function TimeSekunden:Extended;
    procedure FormCreate(Sender: TObject);
    procedure MenschFeldAusgabeDrawCell(Sender: TObject; Col, Row: Integer;
                                        Rect: TRect; State: TGridDrawState);
    procedure ComputerFeldAusgabeDrawCell(Sender: TObject; Col,Row: Integer;
                                          Rect: TRect; State: TGridDrawState);
    procedure MarkierungClick(Sender: TObject);
    procedure ComputerFeldAusgabeMouseDown(Sender: TObject;
                    Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure AbbrechenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Schiffe: TSchiffe;

implementation

uses Passwort, Info, Regeln, SchiffeSetzen, Moin;

{$R *.DFM}
{$R+,Q+}
 CONST WARTEZEIT=200;COMPUTERNAME='Admiral Fiete';
       WIEDERHOLMLD='>>>> Auf diese Koordinaten hast du schon geschossen ! <<<<';
       ERFOLGMLD='!!!!!! Spielende : Meine Flotte ist vernichtet!!!!!!';
       ABBRUCHMLD='!!!!!! Spielende : so waren die Schiffe verteilt!!!!!!';
       CERFOLGMLD   ='!!!! Spielende : Deine Flotte ist vernichtet.!!!!';
       CABBRUCHMLD  ='!!!! Spielende : Du hast aufgegeben, Feigling !!!!';
       WAAG:ARRAY[1..4]OF INTEGER=(-1,0,1,0);
       SENK:ARRAY[1..4]OF INTEGER=(0,1,0,-1);

 VAR MenschFeld,ComputerFeld,CFeld:Bereich;
     DRAN:SPIELER;
     GEHEIM,SPIELERNAME,SPIELER1:STRING;
     MarkierungAn,SoundAn,DarfSpielen:BOOLEAN;
     MTREFFER,TREFFERLISTE:ARRAY[1..10]OF BYTE;
     ABGESCHOSSEN:ARRAY[1..10]OF BOOLEAN;
     SCHIFFLAENGE,VERSENKT:BYTE;
     TR:ARRAY[1..4,1..2]OF BYTE;
     Stufe,TZ,VARIANTE,KSZ,MENSCHVERSENKT,RI:BYTE;
     GETROFFEN,SPIELENDE,Zeigen,CSieg,Abbruch:BOOLEAN;

 function TSchiffe.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;
{****************************************************************************}
{*                         GEHEIMZAHL BERECHNEN                             *}
{****************************************************************************}
 PROCEDURE TSchiffe.COPYRIGHT;
  VAR NAME:STRING;
      K,LA:BYTE;
  BEGIN
   RANDSEED:=3062;NAME:='D_';GEHEIM:='';LA:=223;
   FOR K:=1 TO 6 DO
    GEHEIM:=GEHEIM+CHAR(32+(ORD(NAME[K])-RANDOM(LA)+LA-32) MOD LA);
  END;
{****************************************************************************}
{*                         NDERUNGEN DES SPIELFELDES                       *}
{****************************************************************************}
 PROCEDURE TSchiffe.SPIELFELDANZEIGE;
  BEGIN ComputerFeldAusgabe.RePaint END;
{****************************************************************************}
{*       ENDABRECHNUNG, COMPUTER- UND MENSCHENZUG, UTILITIES                *}
{****************************************************************************}
 procedure TSchiffe.Sound(Datei:String);
  begin
   Screen.Cursor:=crHourglass;
   try
    MediaPlayer.DeviceType:=dtAutoSelect;
    MediaPlayer.FileName:=Datei;
    MediaPlayer.Open;
    MediaPlayer.wait:=true;
    MediaPlayer.Play;
    MediaPlayer.Close;
   except
    On EMCIDeviceError do
     MessageDlg('Die Datei '+Datei+' wurde NICHT gefunden!',mtError,[mbRetry],0)
    end;
   Screen.Cursor:=crHandPoint
  end;

 procedure TSchiffe.Delay(Zeit:DWord);// Pausenzeit in Millisekunden
  var AltZeit:DWord;
  begin
   AltZeit:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-AltZeit>Zeit
  end;

 procedure TSchiffe.Hinweis(T:PChar);
  begin
   Application.MessageBox(T,'Hinweis',64);
  end;
{****************************************************************************}
{*                          Zugberechnung fr den Computer                  *}
{****************************************************************************}
 PROCEDURE SCHUMMELN(VAR Z,S:BYTE);
  VAR ZEILE,SPALTE:BYTE;
  BEGIN
   FOR ZEILE:=1 TO 10 DO
    FOR SPALTE:=1 TO 10 DO
     IF (MENSCHFELD[ZEILE,SPALTE]>0) AND (MENSCHFELD[ZEILE,SPALTE]<11) THEN
      BEGIN
       Z:=ZEILE;S:=SPALTE;
       if Random(100)<50 then EXIT
      END;
  END;

 PROCEDURE TSchiffe.COMPUTERZUG;
  Var VORBEI:Boolean;
      I,J,INHALT,S,T,VERSCHIEBUNG,Z,X,Y,AN,WOHIN,K:BYTE;
      ANTWORT,TASTE:CHAR;
      Endung,Tip:String;
      TXT:STRING;
      OK,SORTIERT:BOOLEAN;
      R:ARRAY[1..4]OF BYTE;
  BEGIN
   REPEAT
    IF TZ=0 THEN
     BEGIN
      IF (VERSENKT>6) AND (RANDOM(100)<10*STUFE) THEN SCHUMMELN(Z,S) ELSE
      REPEAT
       IF KSZ<6 THEN
        BEGIN
         CASE VARIANTE OF
          0 : REPEAT
               Z:=RANDOM(10)+1;S:=RANDOM(10)+1
              UNTIL (ODD(Z) AND ODD(S)) OR (NOT ODD(Z) AND NOT ODD(S));
          1 : REPEAT
               Z:=RANDOM(10)+1;S:=RANDOM(10)+1
              UNTIL (ODD(Z) AND NOT ODD(S)) OR (NOT ODD(Z) AND ODD(S))
         END
        END
       ELSE BEGIN Z:=RANDOM(10)+1;S:=RANDOM(10)+1 END;
      UNTIL CFELD[Z,S]=0;
     END;
    IF TZ=1 THEN
     BEGIN
      X:=TR[1,1];Y:=TR[1,2];AN:=0;
      FOR K:=1 TO 4 DO
       IF CFELD[X+WAAG[K],Y+SENK[K]]=0 THEN
        BEGIN INC(AN);R[AN]:=K END;
      WOHIN:=RANDOM(AN)+1;Z:=X+WAAG[R[WOHIN]];S:=Y+SENK[R[WOHIN]]
     END;
    IF TZ>1 THEN
     BEGIN
      IF RI=0 THEN
       BEGIN
        Z:=TR[1,1];
        REPEAT
         VERSCHIEBUNG:=RANDOM(2);
         S:=TR[1+(TZ-1)*VERSCHIEBUNG,2]+2*VERSCHIEBUNG-1
        UNTIL CFELD[Z,S]=0
       END
      ELSE
       BEGIN
        S:=TR[1,2];
        REPEAT
         VERSCHIEBUNG:=RANDOM(2);
         Z:=TR[1+(TZ-1)*VERSCHIEBUNG,1]+2*VERSCHIEBUNG-1
        UNTIL CFELD[Z,S]=0
       END;
     END;
    INHALT:=MENSCHFELD[Z,S];
    IF INHALT=0 THEN Begin TASTE:='W';Tip:=' und nichts getroffen!' end
    ELSE IF MTREFFER[INHALT]+1<>SCHIFFLISTE[INHALT] THEN
          Begin TASTE:='T';Tip:=' und ein Schiff getroffen!' end
         ELSE Begin TASTE:='V';Tip:=' und ein Schiff versenkt!' end;
    LabelMenschHinweis.Caption:='auf '+CHAR(64+Z)+IntToStr(S)+
                                ' wurde geschossen.'+#13+Tip;
    Delay(500);
    IF TASTE='W' THEN
     Begin
      CFELD[Z,S]:=20;
      Inc(MENSCHFELD[Z,S],20);
      MenschFeldAusgabe.RePaint;
      if SoundAn then Sound('Wasser.wav');
     End;
    IF TASTE='V' THEN
     BEGIN
      INC(MTREFFER[MENSCHFELD[Z,S]]);
      IF NOT GETROFFEN THEN
       BEGIN
        CFELD[Z,S]:=100;BLOCKIEREN(CFELD,Z,S,1,0);
        MENSCHFELD[Z,S]:=40; // versenkt worden ist ein U-Boot
        FOR I:=1 TO 10 DO
         FOR J:=1 TO 10 DO
          IF CFELD[I,J]=Rahmen THEN MenschFELD[I,J]:=Rahmen;
        MenschFeldAusgabe.RePaint;
        if SoundAn then Sound('Versenkt.wav');
        K:=7;
        WHILE (K<11) AND ABGESCHOSSEN[K] DO INC(K);
        ABGESCHOSSEN[K]:=TRUE
       END
      ELSE
       BEGIN
        INC(KSZ);INC(TZ);TR[TZ,1]:=Z;TR[TZ,2]:=S;
        FOR K:=1 TO TZ DO
         Begin
          CFELD[TR[K,1],TR[K,2]]:=TZ+20;
          MenschFeld[TR[K,1],TR[K,2]]:=40;
         End;
        MenschFeldAusgabe.RePaint;
        K:=1;
        WHILE ((SCHIFFLISTE[K]<>TZ) OR ABGESCHOSSEN[K]) AND (K<7) DO INC(K);
        ABGESCHOSSEN[K]:=TRUE;
        CASE K OF
         1 : DEC(SCHIFFLAENGE);
         3 : IF ABGESCHOSSEN[1] THEN DEC(SCHIFFLAENGE);
         6 : IF ABGESCHOSSEN[1] AND ABGESCHOSSEN[3] THEN DEC(SCHIFFLAENGE)
        END;
        IF TR[1,1]=TR[2,1] THEN RI:=0 ELSE RI:=1;// waagerecht   senkrecht
        REPEAT
         SORTIERT:=TRUE;
         FOR K:=1 TO TZ-1 DO
          IF TR[K,2-RI]>TR[K+1,2-RI] THEN
           BEGIN
            T:=TR[K,2-RI];TR[K,2-RI]:=TR[K+1,2-RI];
            TR[K+1,2-RI]:=T;SORTIERT:=FALSE
           END
        UNTIL SORTIERT;
        BLOCKIEREN(CFELD,TR[1,1],TR[1,2],TZ,RI);
        FOR I:=1 TO 10 DO
         FOR J:=1 TO 10 DO
          IF CFELD[I,J]=Rahmen THEN MenschFELD[I,J]:=Rahmen;
        MenschFeldAusgabe.RePaint;
        if SoundAn then Sound('Versenkt.wav');
        GETROFFEN:=FALSE
       END;
      TZ:=0;INC(MENSCHVERSENKT);
      if MENSCHVERSENKT=9 then Endung:='.' else Endung:='e.';
      LabelMensch.Caption:=Spieler1+#13+'besitzt jetzt noch'+#13+
                                IntToStr(10-MENSCHVERSENKT)+' Schiff'+Endung;
      IF MENSCHVERSENKT=10 THEN
       BEGIN
        HINWEIS(CERFOLGMLD);SPIELENDE:=TRUE;CSieg:=True;
        if MessageDlg('Willst du Fietes SCHLAUEN Plan sehen?',
                   mtConfirmation,[mbYes,mbNo],0)=mrYes then
         BEGIN
          HINWEIS(ABBRUCHMLD);CSieg:=True;
          ComputerFeldAusgabe.RePaint;
          Delay(500);
         END
       END
     END;
    IF (TASTE='T') AND (TZ<SCHIFFLAENGE) THEN
     BEGIN
      INC(MTREFFER[MENSCHFELD[Z,S]]);Inc(MENSCHFELD[Z,S],20);
      MenschFeldAusgabe.RePaint;
      if SoundAn then Sound('Treffer.wav');
      IF NOT GETROFFEN THEN GETROFFEN:=TRUE;
      CFELD[Z,S]:=50;
      INC(TZ);TR[TZ,1]:=Z;TR[TZ,2]:=S;
      IF TZ>1 THEN IF TR[1,1]=TR[2,1] THEN RI:=0 ELSE RI:=1;
      REPEAT
       SORTIERT:=TRUE;
       FOR K:=1 TO TZ-1 DO
        IF TR[K,2-RI]>TR[K+1,2-RI] THEN
         BEGIN
          T:=TR[K,2-RI];TR[K,2-RI]:=TR[K+1,2-RI];
          TR[K+1,2-RI]:=T;SORTIERT:=FALSE
         END
      UNTIL SORTIERT
     END;
   UNTIL (TASTE='W') OR SPIELENDE;
   Dran:=Mensch
  END;
{****************************************************************************}
{*                          Schiff verstecken                               *}
{****************************************************************************}
 PROCEDURE TSchiffe.BLOCKIEREN(VAR F:BEREICH;X,Y,LAENGE,R:BYTE);
  VAR K:BYTE;
  BEGIN
   IF R=0 THEN
    BEGIN
     FOR K:=0 TO 2 DO F[X-1+K,Y-1]:=RAHMEN;
     FOR K:=0 TO 2 DO F[X-1+K,Y+LAENGE]:=RAHMEN;
     FOR K:=1 TO LAENGE DO F[X-1,Y-1+K]:=RAHMEN;
     FOR K:=1 TO LAENGE DO F[X+1,Y-1+K]:=RAHMEN
    END
   ELSE
    BEGIN
     FOR K:=0 TO 2 DO F[X-1,Y-1+K]:=RAHMEN;
     FOR K:=0 TO 2 DO F[X+LAENGE,Y-1+K]:=RAHMEN;
     FOR K:=1 TO LAENGE DO F[X-1+K,Y-1]:=RAHMEN;
     FOR K:=1 TO LAENGE DO F[X-1+K,Y+1]:=RAHMEN
    END
  END;

 PROCEDURE TSchiffe.SCHIFFSETZEN(NR:BYTE;VAR FELD:BEREICH);
  VAR AN,K,RI,X_BEREICH,Y_BEREICH,X_START,Y_START:BYTE;
      OK:BOOLEAN;
  BEGIN
   RI:=RANDOM(100) DIV 50;// 0=waagerecht  1=senkrecht
   AN:=0;
   IF Random(100)<50 then AN:=RANDOM(3); // Anzahl der Schiffe am Rand
   IF RI=0 THEN
    BEGIN Y_BEREICH:=11-SCHIFFLISTE[NR];X_BEREICH:=10 END
   ELSE BEGIN X_BEREICH:=11-SCHIFFLISTE[NR];Y_BEREICH:=10 END;
   REPEAT
    X_START:=RANDOM(X_BEREICH)+1;Y_START:=RANDOM(Y_BEREICH)+1;OK:=TRUE;
    IF NR<AN THEN
     IF RI=0 THEN X_START:=RANDOM(2)*9+1 ELSE Y_START:=RANDOM(2)*9+1;
    FOR K:=1 TO SCHIFFLISTE[NR] DO // passt das Schiff ins Feld?
     IF RI=0 THEN OK:=OK AND (FELD[X_START,Y_START+K-1]=0)
     ELSE OK:=OK AND (FELD[X_START+K-1,Y_START]=0);
    IF (NR=7) OR (NR=8) THEN
     OK:=OK AND ((ODD(X_START) AND ODD(Y_START)) OR
                 (NOT ODD(X_START) AND NOT ODD(Y_START)));
    IF (NR=9) OR (NR=10) THEN
     OK:=OK AND ((ODD(X_START) AND NOT ODD(Y_START)) OR
                 (NOT ODD(X_START) AND ODD(Y_START)))
   UNTIL OK;
   FOR K:=1 TO SCHIFFLISTE[NR] DO
    IF RI=0 THEN FELD[X_START,Y_START+K-1]:=NR
    ELSE FELD[X_START+K-1,Y_START]:=NR;
   BLOCKIEREN(FELD,X_START,Y_START,SCHIFFLISTE[NR],RI)
  END;
{****************************************************************************}
{*                         Spiel - Parameter festlegen                      *}
{****************************************************************************}
 PROCEDURE TSchiffe.INIT;
  VAR Z,S,Schiff:BYTE;
  BEGIN
   FOR Z:=0 TO 11 DO // Initialisierung fr den Menschen
    FOR S:=0 TO 11 DO
     IF (Z=0) OR (S=0) OR (Z=11) OR (S=11) THEN COMPUTERFELD[Z,S]:=RAND
     ELSE COMPUTERFELD[Z,S]:=0;
   FOR Z:=1 TO 10 DO TREFFERLISTE[Z]:=0;
   VERSENKT:=0;SPIELENDE:=FALSE;Zeigen:=False;CSieg:=False;Abbruch:=False;
   SCHIFFLAENGE:=3;RANDSEED:=TRUNC(TimeSekunden);GETROFFEN:=FALSE;
   FOR Z:=1 TO 10 DO ABGESCHOSSEN[Z]:=FALSE;
   FOR Z:=0 TO 11 DO // Initialisierung fr den Computer
    FOR S:=0 TO 11 DO
     IF (Z=0) OR (S=0) OR (Z=11) OR (S=11) THEN
      BEGIN MENSCHFELD[Z,S]:=RAND;CFELD[Z,S]:=RAND END
     ELSE BEGIN MENSCHFELD[Z,S]:=0;CFELD[Z,S]:=0 END;
   FOR Z:=1 TO 10 DO MTREFFER[Z]:=0;
   KSZ:=0;MENSCHVERSENKT:=0;VARIANTE:=RANDOM(2);
   FOR SCHIFF:=1 TO 10 DO SCHIFFSETZEN(SCHIFF,COMPUTERFELD);
   FOR Z:=1 TO 10 DO // Lschen der verbotenen Zonen um die Schiffe
    FOR S:=1 TO 10 DO
     IF COMPUTERFELD[Z,S]=RAHMEN THEN COMPUTERFELD[Z,S]:=0;
   SPIELFELDANZEIGE;
   Staerke.Enabled:=True;
  End;

 procedure TSchiffe.NameErmitteln(Name:String;Var SpielerName:String);
  const Max=3;
        NameListe:Array[0..Max]of String=('Ahab','Brsel','Meister','Schrder');
  var Zahl,ersterBuchstabe:String;
  Begin
   SpielerName:='';
   PasswordDlg.Caption:='Wie heit Du, '+Name+'?';
   PasswordDlg.LabelPasswort.Caption:='Admiral Fiete fordert Dich heraus!';
   PasswordDlg.Passwort.PasswordChar:=#0;
   PasswordDlg.Passwort.Text:=NameListe[random(Max)];
   repeat
    PasswordDlg.ShowModal;
    SpielerName:=PasswordDlg.Passwort.Text;
    while Pos(' ',SpielerName)>0 do  // lscht alle Leerzeichen
     begin Delete(SpielerName,Pos(' ',SpielerName),1) end;
    while Pos('ADMIRAL',AnsiUpperCase(SpielerName))>0 do  // lscht alle Admiral
     begin Delete(SpielerName,Pos('ADMIRAL',AnsiUpperCase(SpielerName)),7) end;
    while Pos('FIETE',AnsiUpperCase(SpielerName))>0 do  // lscht alle Fiete
     begin Delete(SpielerName,Pos('ADMIRAL',AnsiUpperCase(SpielerName)),5) end;
    if Length(SpielerName)<3 then
     PasswordDlg.Passwort.Text:=NameListe[random(Max)];
   until Length(SpielerName)>2;
   SpielerName:=AnsiLowerCase(SpielerName);
   ersterBuchstabe:=AnsiUpperCase(SpielerName[1]);
   SpielerName[1]:=ersterBuchstabe[1];
   if SpielerName='Meister' then
    Begin
     PasswordDlg.Caption:='Paworteingabe';
     PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
     PasswordDlg.Passwort.PasswordChar:='?';
     PasswordDlg.Passwort.Text:='';
     PasswordDlg.ShowModal;
     Zahl:=PasswordDlg.Passwort.Text;
     if Zahl<>Geheim then SpielerName:='Betrger';
    End;
  End;
{****************************************************************************}
{*                         Men - Prozeduren                                *}
{****************************************************************************}
 procedure TSchiffe.StartClick(Sender: TObject);
  var Z,S:Byte;
  begin
   if SoundAn then Sound('Welcomef.wav');
   Init;DarfSpielen:=True;TZ:=0;
   NameErmitteln('Captain',SPIELERNAME);
   SPIELER1:='Captain '+SPIELERNAME;
   LabelHinweis.Caption:=COMPUTERNAME+'s Flotte.';
   LabelMensch.Caption:=Spieler1+'s Flotte.';
{****************************************************************************}
{*                         Verstecken der Menschschiffe                     *}
{****************************************************************************}
   MenschSchiffe.ShowModal;
   MENSCHFELD:=MenschSchiffe.Feld;
   FOR Z:=1 TO 10 DO // Lschen der verbotenen Zonen um die Schiffe
    FOR S:=1 TO 10 DO
     IF MenschFeld[Z,S]=RAHMEN THEN MenschFeld[Z,S]:=0;
   MenschFeldAusgabe.RePaint;
{****************************************************************************}
   if Menschbeginnt.Checked then Dran:=Mensch
   else Dran:=Computer;
   if Stufe=3 then
    Schiffe.Caption:='Schiffe versenken  Meister Fiete          Level 3';
   if Dran=Computer then Computerzug
  end;

 procedure TSchiffe.EndeClick(Sender: TObject);
  begin
   if MessageDlg('Willst du das Spiel beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Das Spiel wird beendet!',mtWarning,[mbOk],0);
     if SoundAn then Sound('Goodbyef.wav');
     close
    end
  end;

 procedure TSchiffe.LevelWahl(Sender: TObject);
  begin
   if Sender=N1Anfaenger then
    Begin Stufe:=1;N1Anfaenger.Checked:=True End;
   if Sender=N2Geuebter  then
    Begin Stufe:=2;N2Geuebter.Checked:=True End;
   if Sender=N3Erfahrener then
    Begin Stufe:=3;N3Erfahrener.Checked:=True End;
   if Sender=N4Fortgeschrittener then
    Begin Stufe:=4;N4Fortgeschrittener.Checked:=True End;
   if Sender=N5Koenner then
    Begin Stufe:=5;N5Koenner.Checked:=True End;
   if Sender=N6Meister then
    Begin Stufe:=6;N6Meister.Checked:=True End;
   if Sender=N7Grossmeister then
    Begin Stufe:=7;N7Grossmeister.Checked:=True End;
   if Sender=N8Weltmeister then
    Begin Stufe:=8;N8Weltmeister.Checked:=True End;
   if Sender=N9Genie then
    Begin Stufe:=9;N9Genie.Checked:=True End;
   if Sender=N10Superhirn then
    Begin Stufe:=10;N10Superhirn.Checked:=True End;
   if Sender=N11AlbertEinstein then
    Begin Stufe:=11;N11AlbertEinstein.Checked:=True End;
   Schiffe.Caption:='Schiffe versenken  Meister Fiete          Level '
                    +IntToStr(Stufe);
  end;

 procedure TSchiffe.Wer_Beginnt(Sender: TObject);
  begin
   if Sender=Menschbeginnt then
    begin
     Dran:=Mensch;
     Menschbeginnt.Checked:=True;
    end;
   if Sender=Computerbeginnt then
    begin
     Dran:=Computer;
     Computerbeginnt.Checked:=True;
    end;
  end;

 procedure TSchiffe.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TSchiffe.RegelnClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

 procedure TSchiffe.TonClick(Sender: TObject);
  begin
   if MessageDlg('Soll der Sound aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Der Sound ist aktiv!',mtInformation,[mbOk],0);
     SoundAn:=True;Ton.Checked:=True;
    end
   else begin SoundAn:=False;Ton.Checked:=False end;
  end;

 procedure TSchiffe.MarkierungClick(Sender: TObject);
  begin
   if MessageDlg('Soll die Schiffsmarkierung aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Die Schiffsmarkierung ist aktiv!',mtInformation,[mbOk],0);
     MarkierungAn:=True;Markierung.Checked:=True;
    end
   else begin MarkierungAn:=False;Markierung.Checked:=False end;
   MenschFeldAusgabe.RePaint;
   ComputerFeldAusgabe.RePaint;
  end;

 procedure TSchiffe.FormCreate(Sender: TObject);
 const ScreenHeightDev=768;ScreenWidthDev=1024;
  VAR x,y:integer;
      Bild:TIntro;
  begin
   Scaled:=true;x:=Screen.width;y:=screen.height;
   if (y<>ScreenHeightDev) or (x<>ScreenWidthDev) then
    begin
     Height:=(ClientHeight*y div ScreenHeightDev)+Height-ClientHeight;
     Width:=(ClientWidth*x div ScreenWidthDev)+Height-ClientHeight;
     ScaleBy(x,ScreenwidthDev);
    end;
   Bild:=TIntro.Create(Schiffe);
   Bild.ShowModal;
   Bild.Free;
   Randomize;
   Screen.Cursor:=crHandPoint;COPYRIGHT;Stufe:=3;
   DarfSpielen:=False;SoundAn:=True;MarkierungAn:=True;
  end;

 procedure TSchiffe.MenschFeldAusgabeDrawCell(Sender: TObject; Col,
                        Row: Integer; Rect: TRect; State: TGridDrawState);
  const Ziffer=' 1 2 3 4 5 6 7 8 910';
  var Inhalt:Byte;
  begin
   with MenschFeldAusgabe.Canvas do
    begin
     if (Col=0) or (Row=0) then
      begin
       Brush.Color:=clWhite;
       Brush.Style:=bsSolid;
       FillRect(Rect);
       Brush.Style:=bsClear;
       Font.Color:=clBlack;
       Font.Style:=[fsBold];
       if Row=0 then
        if Col>0 then TextOut(Rect.Left+6,Rect.Top+6,Char(Col+64));
       if Col=0 then
        if Row>0 then TextOut(Rect.Left+4,Rect.Top+6,Copy(Ziffer,2*Row-1,2))
      end
     else
      begin
       Inhalt:=MenschFeld[Col,Row];
       Case Inhalt of
         0 : Begin
              Brush.Style:=bsSolid;Brush.Color:=clNavy; // Leer
              FillRect(Rect)
             End;
        1..10: Begin
                 Brush.Color:=clGray; // Schiffe
                 FillRect(Rect)
                End;
        20 : Begin
              Brush.Style:=bsSolid;
              Brush.Color:=clGreen; // Wasser
              FillRect(Rect);
              pen.width:=3;pen.color:=clWhite;
              moveto(Rect.Left+5,Rect.Top+5);
              lineTo(Rect.Right-5,Rect.Bottom-5);
              moveto(Rect.Left+5,Rect.Bottom-5);
              lineTo(Rect.Right-5,Rect.Top+5);
             End;
        Rahmen: Begin
                 Brush.Style:=bsSolid;
                 if MarkierungAn then  Brush.Color:=clGreen // Wasser
                 else Brush.Color:=clNavy; // Leer
                 FillRect(Rect);
                 if MarkierungAn then
                  begin
                   pen.width:=3;pen.color:=clWhite;
                   moveto(Rect.Left+5,Rect.Top+5);
                   lineTo(Rect.Right-5,Rect.Bottom-5);
                   moveto(Rect.Left+5,Rect.Bottom-5);
                   lineTo(Rect.Right-5,Rect.Top+5);
                  end
                End;
        21..30: Begin
                 Brush.Color:=clRed; // Treffer
                 FillRect(Rect)
                End;
        40 : Begin
              Brush.Style:=bsSolid;Brush.Color:=clBlack; // versenkt
              FillRect(Rect)
             End;
       End;
      end
    end;
  end;

 procedure TSchiffe.ComputerFeldAusgabeDrawCell(Sender: TObject; Col,
                    Row: Integer; Rect: TRect; State: TGridDrawState);
  const Ziffer=' 1 2 3 4 5 6 7 8 910';
  var Inhalt:Byte;
  begin
   with ComputerFeldAusgabe.Canvas do
    begin
     if (Col=0) or (Row=0) then
      begin
       Brush.Color:=clWhite;
       Brush.Style:=bsSolid;
       FillRect(Rect);
       Brush.Style:=bsClear;
       Font.Color:=clBlack;
       Font.Style:=[fsBold];
       if Row=0 then
        if Col>0 then TextOut(Rect.Left+6,Rect.Top+6,Char(Col+64));
       if Col=0 then
        if Row>0 then TextOut(Rect.Left+4,Rect.Top+6,Copy(Ziffer,2*Row-1,2))
      end
     else
      begin
       Inhalt:=ComputerFeld[Col,Row];
       Case Inhalt of
         0 : Begin
              Brush.Style:=bsSolid;Brush.Color:=clNavy; // Leer
              FillRect(Rect)
             End;
        1..10: Begin
                IF ((SPIELERNAME='Meister') and Zeigen) or Abbruch or CSieg THEN Brush.Color:=clGray // Schiffe
                ELSE Brush.Color:=clNavy; // Leer
                FillRect(Rect)
               End;
        20 : Begin
              Brush.Style:=bsSolid;
              Brush.Color:=clGreen; // Wasser
              FillRect(Rect);
              pen.width:=3;pen.color:=clWhite;
              moveto(Rect.Left+5,Rect.Top+5);
              lineTo(Rect.Right-5,Rect.Bottom-5);
              moveto(Rect.Left+5,Rect.Bottom-5);
              lineTo(Rect.Right-5,Rect.Top+5);
             End;
        Rahmen: Begin
                 Brush.Style:=bsSolid;
                 if MarkierungAn then  Brush.Color:=clGreen // Wasser
                 else Brush.Color:=clNavy; // Leer
                 FillRect(Rect);
                 if MarkierungAn then
                  begin
                   pen.width:=3;pen.color:=clWhite;
                   moveto(Rect.Left+5,Rect.Top+5);
                   lineTo(Rect.Right-5,Rect.Bottom-5);
                   moveto(Rect.Left+5,Rect.Bottom-5);
                   lineTo(Rect.Right-5,Rect.Top+5);
                  end
                End;
        21..30: Begin
                 Brush.Color:=clRed; // Treffer
                 FillRect(Rect)
                End;
        40 : Begin
              Brush.Style:=bsSolid;Brush.Color:=clBlack; // versenkt
              FillRect(Rect)
             End;
       End;
      end
    end;
  end;
{****************************************************************************}
{*                                 Menschzug                                *}
{****************************************************************************}
 procedure TSchiffe.ComputerFeldAusgabeMouseDown(Sender: TObject;
                      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var Z,S,Nr,I,J,K,L:Integer;
      Vorbei:Boolean;
      Endung:String;
  begin
   if Button=mbRight then   // Anzeige der Computerschiffe
    begin
     Zeigen:=True;
     ComputerFeldAusgabe.RePaint;
     Delay(500);Zeigen:=False;
     ComputerFeldAusgabe.RePaint;
    end
   else if Button=mbLeft then
    begin
     if not DarfSpielen then
      begin
       MessageDlg('Du mut erst das Spiel starten!',mtError,[mbRetry],0);
       Exit
      end;
     if SpielEnde then
      Begin
       Hinweis('Das Spiel ist schon zu Ende!');
       Exit;
      End;
     if Dran=Computer then
      Begin
       Hinweis('Du bist NICHT dran!');
       Exit;
      End;
     ComputerFeldAusgabe.MouseToCell(X,Y,Z,S);
     VORBEI:=False;
     LabelComputer.Caption:='Du schiet auf '+CHAR(64+Z)+IntToStr(S)+'.';
     IF COMPUTERFELD[Z,S]>10 THEN HINWEIS(WIEDERHOLMLD)
     Else
      BEGIN
       IF COMPUTERFELD[Z,S]=0 THEN
        BEGIN
         VORBEI:=TRUE;
         INC(COMPUTERFELD[Z,S],20);
         ComputerFeldAusgabe.Repaint;
         LabelComputer.Caption:=LabelComputer.Caption+#13+'und triffst nichts!';
         if SoundAn then Sound('Wasser.wav');
        END
       ELSE
        BEGIN
         NR:=COMPUTERFELD[Z,S];INC(TREFFERLISTE[NR]);
         IF TREFFERLISTE[NR]=SCHIFFLISTE[NR] THEN
          BEGIN
           INC(VERSENKT);
           if Versenkt=9 then Endung:='.' else Endung:='e.';
           if Versenkt<10 then
            LabelHinweis.Caption:=COMPUTERNAME+' besitzt jetzt noch'+
                                    #13+IntToStr(10-Versenkt)+' Schiff'+Endung
           else LabelHinweis.Caption:=COMPUTERNAME+' hat alle'
                                      +#13+'Schiffe verloren!';
           LabelComputer.Caption:=LabelComputer.Caption+#13+'und versenkst ein Schiff!';
           INC(COMPUTERFELD[Z,S],20);
           ComputerFeldAusgabe.Repaint;
           if SoundAn then Sound('Versenkt.wav');
           FOR I:=1 TO 10 DO
            FOR J:=1 TO 10 DO
             IF COMPUTERFELD[I,J]-20=NR THEN
              Begin
               COMPUTERFELD[I,J]:=40;
                For K:=-1 to 1 do
                 For L:=-1 to 1 do
                  IF COMPUTERFELD[I+K,J+L]=0 THEN COMPUTERFELD[I+K,J+L]:=Rahmen;
              End;
           ComputerFeldAusgabe.Repaint;
           IF VERSENKT=10 THEN
            BEGIN
             ComputerFeldAusgabe.Repaint;
             if SoundAn then Sound('Menschsieg.wav');
             HINWEIS(ERFOLGMLD);SPIELENDE:=TRUE;
            END;
          END
         ELSE
          BEGIN
           INC(COMPUTERFELD[Z,S],20);
           LabelComputer.Caption:=LabelComputer.Caption+#13+'und triffst ein Schiff!';
           ComputerFeldAusgabe.Repaint;
           if SoundAn then Sound('Treffer.wav');
          END;
        END;
       if Vorbei then Begin Dran:=Computer;Computerzug end
      END
    end
  end;

 procedure TSchiffe.AbbrechenClick(Sender: TObject);
  begin
   if MessageDlg('Willst du wirklich aufgeben?',
                   mtConfirmation,[mbYes,mbNo],0)=mrYes then
     BEGIN
      SPIELENDE:=TRUE;HINWEIS(CABBRUCHMLD);
      if MessageDlg('Willst du Fietes SCHLAUEN Plan sehen?',
                   mtConfirmation,[mbYes,mbNo],0)=mrYes then
       BEGIN
        HINWEIS(ABBRUCHMLD);Abbruch:=True;
        ComputerFeldAusgabe.RePaint;Delay(500);
       END
     END;
  end;

end.



