Unit Vier_Gewinnt;

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, MPlayer, ComCtrls;

                                     // 1-4 Computer   ...  5-8 Spieler
   Const RWerte:Array[1..8]of Integer=(3,3,3,3,5,5,5,5); // schlecht!!!
         MinInt=-30000;MaxInt=30000;Teil=7;WarteZeit=200;

Type
      Inhalt=Record
              Art,Hoehe,Anzahl:Integer;
              Wo:Array[1..??]of Integer
             End;
      BInhalt=Record Wert,Anzahl:Integer End;
      Nr=Record FeldNr:Array[1..4]of Integer End;
      SpielFeld=Array[1..42]of Inhalt;
      Bewertung=Array[1..??]of BInhalt;
      SpielZug=Integer;
      SpielZugListe=Array[1..??]of SpielZug;
      Spieler=(Computer,Mensch);

  TVG = Class(TForm)
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Start: TMenuItem;
    Staerke: TMenuItem;
    N1Anfaenger: TMenuItem;
    N2Geuebter: TMenuItem;
    N3Erfahrener: TMenuItem;
    N4Fortgeschrittener: TMenuItem;
    N5Koenner: TMenuItem;
    N6Meister: TMenuItem;
    N7Grossmeister: TMenuItem;
    N8Weltmeister: TMenuItem;
    N9Genie: TMenuItem;
    N10Superhirn: TMenuItem;
    N11AlbertEinstein: TMenuItem;
    Einstellungen: TMenuItem;
    Menschbeginnt: TMenuItem;
    Computerbeginnt: TMenuItem;
    MenschgegenMensch: TMenuItem;
    Service: TMenuItem;
    Zugruecknahme: TMenuItem;
    Zugvorschlag: TMenuItem;
    Zugbewertung: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    Regeln: TMenuItem;
    FeldPanel: TPanel;
    Ende: TMenuItem;
    Status: TPanel;
    StatusText: TStaticText;
    TiefeText: TStaticText;
    Panel1: TPanel;
    LabelStatus: TLabel;
    Panel2: TPanel;
    LabelTiefe: TLabel;
    Panel3: TPanel;
    LabelZug: TLabel;
    SpielFeldAusgabe: TPaintBox;
    ShapeComputer: TShape;
    ShapeMensch: TShape;
    LabelEnde: TLabel;
    ZugNrText: TStaticText;
    Panel4: TPanel;
    LabelZugNr: TLabel;
    LabelMensch: TLabel;
    LabelComputer: TLabel;
    MediaPlayer: TMediaPlayer;
    Ausgabe: TRichEdit;
    Ton: TMenuItem;
    Zoom: TMenuItem;
    Zoom100: TMenuItem;
    Zoom75: TMenuItem;
    Zoom90: TMenuItem;
    Zoom80: TMenuItem;
    Zoom70: TMenuItem;
    Zoom110: TMenuItem;
    Zoom120: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    WarnHinweis: TMenuItem;
    Procedure StartClick(Sender: TObject);
    Procedure LevelWahl(Sender: TObject);
    Procedure WerBeginnt(Sender: TObject);
    Procedure EndeClick(Sender: TObject);
    Procedure ZugbewertungClick(Sender: TObject);
    Procedure SpielFeldAusgabePaint(Sender: TObject);
    Procedure SpielFeldAusgabeMouseDown(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
    Procedure ZugvorschlagClick(Sender: TObject);
    Procedure ZugruecknahmeClick(Sender: TObject);
    Procedure InfoClick(Sender: TObject);
    Procedure RegelnClick(Sender: TObject);
    Procedure Sound(Datei:String);
    Procedure CopyRight;
    Procedure FeldAusgabe;
    Procedure SpielFeldAnzeige(SF:SpielFeld);
    Procedure GenZugListe(Var F:SpielFeld;AmZug:Spieler;Var N:Integer;
                          Var ZL:SpielZugListe);
    Function Wert(Var B:Bewertung):Integer;
    Function Max(X,Y:Integer):Integer;
    Function Min(X,Y:Integer):Integer;
    Procedure MachZug(Var F:SpielFeld;Var B:Bewertung;
                      Zug:SpielZug;AmZug:Integer);
    Function Remis(Var B:Bewertung):Boolean;
    Function Schluss(Var B:Bewertung):Boolean;
    Procedure AlphaBetaSuche(Var BestZug:SpielZug;Var AlphaBeta:Integer;
           B:Bewertung;N:Integer;F:SpielFeld;AmZug:Spieler;Alpha,Beta:Integer);
    Procedure Delay(Zeit:DWord);// Pausenzeit in Millisekunden
    Procedure SpielEnde;
    Procedure SchreibZugNummer(Nr:Integer);
    Procedure ComputerZug;
    Procedure SuchZug(Var Zug:SpielZug;SF:SpielFeld;SB:Bewertung);
    Procedure Init;
    Procedure NameErmitteln(Name:String;Var SpielerName:String);
    Procedure TonClick(Sender: TObject);
    Procedure ZoomWahl(Sender: TObject);
    Procedure SpielVerlauf;
    Function TimeSekunden:Extended;
    Procedure FormCreate(Sender: TObject);
    Procedure WarnHinweisClick(Sender: TObject);
  Private
    { Private-Deklarationen }
     Reihe:Array[1..??]of Nr;
     Farbe:Array[1..4]of TColor;
     F,FAlt:SpielFeld;
     B:Bewertung;
     SpielListe:Array[0..42]of SpielFeld;
     Werte:Array[0..42]of Bewertung;
     Dran:Spieler;
     Radius,Breite,Level,Tiefe,ZugNummer:Integer;
     Count,MaxX,MaxY,XFaktor:Integer;
     GEHEIM,SpielerName,Spieler1,Spieler2:String;
     Schrift:TColor;
     Warnung,SoundAn,DarfSpielen,Anzeigen,ZweiSpielerModus:Boolean;
  Public
    { Public-Deklarationen }
  End;

Var VG: TVG;

Implementation

Uses Passwort, Info, Regeln;

{$R *.DFM}
{$R+,Q+} // die Bereichsberprfung und die berlaufprfung ist aktiviert
         //         Arrays                   Wertebereich

 Function TVG.TimeSekunden:Extended;
  Var H, M, S, MS : Word;
  Begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  End;
{****************************************************************************}
{*                         Geheimzahl berechnen                             *}
{****************************************************************************}
 Procedure TVG.CopyRight;
  Var Name:String;
      K,LA:Integer;
  Begin
   RandSeed:=3062;Name:='D_';Geheim:='';LA:=223;
   For K:=1 To 6 Do
    Geheim:=Geheim+Char(32+(Ord(Name[K])-RANDOM(LA)+LA-32) Mod LA);
  End;
{****************************************************************************}
{*                         Ausgabe des Spielfeldes                          *}
{****************************************************************************}
 Procedure TVG.FeldAusgabe;
  Var K,L:Integer;
      X,Y:Integer;
      Rect:TRect;
  Begin
   SpielFeldAusgabe.Canvas.Brush.Color:=clSilver;
   Rect.Left:=0;Rect.Top:=0;Rect.Right:=MaxX;Rect.Bottom:=MaxY;
   SpielFeldAusgabe.Canvas.FillRect(Rect);// Feld lschen
   For K:=0 To 5 Do
    For L:=0 To 6 Do
     Begin
      X:=L*Breite;Y:=K*Breite;
      SpielFeldAusgabe.Canvas.Brush.Color:=Schrift;
      SpielFeldAusgabe.Canvas.Ellipse(X+4,Y+4,X+2*Radius,Y+2*Radius)
     End;
   SpielFeldAusgabe.Canvas.Brush.Color:=clSilver;
   SpielFeldAusgabe.Canvas.Font.Style:=[fsBold];
   For K:=0 To 6 Do
    Begin
     X:=K*Breite+Radius;Y:=MaxY-20;
     SpielFeldAusgabe.Canvas.TextOut(X,Y,Char(49+K));
    End;
  End;
{****************************************************************************}
{*                         nderungen des Spielfeldes                       *}
{****************************************************************************}
 Procedure TVG.SpielFeldAnzeige(SF:SpielFeld);
  Var K,L,Wo:Integer;
      X,Y:Integer;
  Begin
   For K:=0 To 5 Do
    For L:=0 To 6 Do
     Begin
      Wo:=(5-K)*7+L+1;X:=L*Breite;Y:=K*Breite;
      If SF[Wo].Art=1 Then SpielFeldAusgabe.Canvas.Brush.Color:=Farbe[1];
      If SF[Wo].Art=2 Then SpielFeldAusgabe.Canvas.Brush.Color:=Farbe[2];
      If SF[Wo].Art=3 Then SpielFeldAusgabe.Canvas.Brush.Color:=Farbe[3];
      If SF[Wo].Art=4 Then SpielFeldAusgabe.Canvas.Brush.Color:=Farbe[4];
      If SF[Wo].Art=0 Then SpielFeldAusgabe.Canvas.Brush.Color:=Schrift;
      SpielFeldAusgabe.Canvas.Ellipse(X+4,Y+4,X+2*Radius,Y+2*Radius)
     End;
  End;
{****************************************************************************}
{*                         Spiel - Prozeduren                               *}
{****************************************************************************}
 Procedure TVG.GenZugListe(Var F:SpielFeld;AmZug:Spieler;Var N:Integer;
                           Var ZL:SpielZugListe);
  Var K:Integer;
  Begin
   N:=0;

   // hier fehlt was!!!

  End;

 Function TVG.Wert(Var B:Bewertung):Integer;
  Var T:Integer;
      Sp,Com:Integer;
  Begin
   Sp:=0;Com:=0;
   For T:=1 To 69 Do
    If B[T].Wert=1 Then Com:=Com+RWerte[B[T].Anzahl]
    Else
     If B[T].Wert=2 Then Sp:=Sp+RWerte[B[T].Anzahl+4];
   Wert:=Com-Sp;Inc(Count)
  End;

 Function TVG.Max(X,Y:Integer):Integer;
  Begin If X<Y Then Max:=Y Else Max:=X End;

 Function TVG.Min(X,Y:Integer):Integer;
  Begin If X<Y Then Min:=X Else Min:=Y End;

 Procedure TVG.MachZug(Var F:SpielFeld;Var B:Bewertung;
                       Zug:SpielZug;AmZug:Integer);
  Var Feld,L:Integer;
  Begin
   Feld:=Zug+7*F[Zug].Hoehe;Inc(F[Zug].Hoehe); // erlutern!!!
   F[Feld].Art:=AmZug;
   For L:=1 To F[Feld].Anzahl Do
    With B[F[Feld].Wo[L]] Do
     Begin Wert:=Wert or AmZug;Inc(Anzahl) End
  End;

 Function TVG.Remis(Var B:Bewertung):Boolean;
  Var K:Integer;
  Begin
   Remis:=True;
   For K:=1 To 69 Do
    If B[K].Anzahl<3 Then Begin Remis:=False;Exit End
  End;

 Function TVG.Schluss(Var B:Bewertung):Boolean;
  Var K:Integer;
  Begin
   For K:=1 To 69 Do
    If B[K].Wert<3 Then
     If B[K].Anzahl=4 Then Begin Schluss:=True;Exit End;
   Schluss:=False
  End;

 Procedure TVG.AlphaBetaSuche(Var BestZug:SpielZug;Var AlphaBeta:Integer;
           B:Bewertung;N:Integer;F:SpielFeld;AmZug:Spieler;Alpha,Beta:Integer);
  Var VirtuelleFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirtuelleBewertung:Bewertung;
      M:Integer;
      I,Anzahl:Integer;
      AbZeile:String;
  Begin
   If (N=0) or Schluss(B) or Remis(B) Then AlphaBeta:=Wert(B)
   Else
    Begin
     GenZugListe(F,AmZug,Anzahl,ZugListe);
     If AmZug=Computer Then
      Begin
       M:=Alpha;I:=0;
       While (I<Anzahl) And (M<Beta) Do
        Begin
         VirtuelleFeld:=F;VirtuelleBewertung:=B;Inc(I);Zug:=ZugListe[I];
         MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,1);
         AlphaBetaSuche(BestZug,AlphaBeta,VirtuelleBewertung,N-1,
                        VirtuelleFeld,Mensch,M,Beta);
         If (N=Tiefe) And Anzeigen Then
          Begin
           AbZeile:='Wert von Zug : '+IntToStr(Zug);
           AbZeile:=AbZeile+'='+IntToStr(AlphaBeta);
           Ausgabe.Lines.Add(AbZeile);
           AbZeile:=IntToStr(Count)+' analysierte Stellungen';
           Ausgabe.SelAttributes.Color:=clBlue;
           Ausgabe.Lines.Add(AbZeile);
           Ausgabe.SelAttributes.Color:=clBlack
          End;
         If M<AlphaBeta Then
          Begin
           M:=AlphaBeta;
           If N=Tiefe Then
            Begin
             BestZug:=Zug;
             If Anzeigen Then
              Begin
               AbZeile:='bisher bester ComputerZug : '+IntToStr(BestZug);
               AbZeile:=AbZeile+'='+IntToStr(AlphaBeta);
               Ausgabe.SelAttributes.Color:=clRed;
               Ausgabe.Lines.Add(AbZeile);
               Ausgabe.SelAttributes.Color:=clBlack;
              End
            End
          End
        End
      End
     Else
      Begin
       M:=Beta;I:=0;
       While (I<Anzahl) And (M>Alpha) Do
        Begin
         VirtuelleFeld:=F;VirtuelleBewertung:=B;Inc(I);Zug:=ZugListe[I];
         MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,2);
         // Simulation des Gegners
         AlphaBetaSuche(BestZug,AlphaBeta,VirtuelleBewertung,N-1,
                        VirtuelleFeld,Computer,Alpha,M);
         If M>AlphaBeta Then M:=AlphaBeta
        End
      End;
     AlphaBeta:=M
    End
  End;

{****************************************************************************}
{*       Endabrechnung, Computer- und Menschzug, Utilities                  *}
{****************************************************************************}
 Procedure TVG.Sound(Datei:String);
  Begin
   Screen.Cursor:=crHourglass;
   try
    MediaPlayer.DeviceType:=dtWaveAudio;
    MediaPlayer.FileName:=Datei;
    MediaPlayer.Open;
    MediaPlayer.wait:=True;
    MediaPlayer.Play;
    MediaPlayer.Close;
   except
    On EMCIDeviceError Do
     MessageDlg('Die Datei '+Datei+' wurde NICHT gefunden!',mtError,[mbRetry],0)
    End;
   Screen.Cursor:=crHandPoint
  End;

 Procedure TVG.Delay(Zeit:DWord);// Pausenzeit in Millisekunden
  Var AltZeit:DWord;
  Begin
   AltZeit:=GetTickCount;
   Repeat Application.ProcessMessages Until GetTickCount-AltZeit>Zeit
  End;

 Procedure TVG.SpielVerlauf;
  Var K:Integer;
      Feld:SpielFeld;
  Begin
   If ZugNummer>1 Then
    Begin
     If MessageDlg('Soll ich den ganzen SpielVerlauf Zeigen?',
                        mtConfirmation,[mbYes,mbNo],0)=mrYes Then
      Begin
       LabelStatus.Caption:='SpielVerlauf';
       LabelZug.Caption:='';
       For K:=1 To ZugNummer Do
        Begin
         SchreibZugNummer(K);
         Feld:=SpielListe[K];
         SpielFeldAnzeige(Feld);
         If MessageDlgPos('Weiter?',mtConfirmation,[mbYes,mbNo],0,
          VG.Left+Status.Left,VG.Top+FeldPanel.Height Div 2)=mrNo Then Exit
        End
      End;
     SpielEnde
    End;
   End;

 Procedure TVG.SpielEnde;
  Var K,Sieg,SiegerReihe:Integer;
      Anzeige:String;
  Begin
   Sieg:=0;SiegerReihe:=0;
   For K:=1 To 69 Do
    If B[K].Wert=1 Then
     Begin If B[K].Anzahl=4 Then Begin SiegerReihe:=K;Sieg:=1 End End
    Else
     If B[K].Wert=2 Then
      Begin If B[K].Anzahl=4 Then Begin SiegerReihe:=K;Sieg:=2 End End;
   If Sieg=1 Then
    Begin
     LabelEnde.Font.Color:=clRed;
     If Not ZweiSpielerModus Then
      Begin
       Anzeige:='SuperPC hat gewonnen!';
       If SoundAn Then Sound('Computersieg.wav')
      End
     Else Anzeige:=Spieler2+' gewinnt!';
     For K:=1 To 4 Do
      F[Reihe[SiegerReihe].FeldNr[K]].Art:=3;
    End;
   If Sieg=2 Then
    Begin
     LabelEnde.Font.Color:=clGreen;
     If Not ZweiSpielerModus Then
      Begin
       Anzeige:='Du hast mich besiegt!';
       If SoundAn Then Sound('Menschsieg.wav')
      End
     Else Anzeige:=Spieler1+' gewinnt!';
     For K:=1 To 4 Do
      F[Reihe[SiegerReihe].FeldNr[K]].Art:=4;
    End;
   If Remis(B) Then Anzeige:='Remis!!!'
   Else SpielFeldAnzeige(F);
   LabelEnde.Caption:=Anzeige;
   LabelStatus.Caption:='Das Spiel ist zu Ende';
  End;

 Procedure TVG.SchreibZugNummer(Nr:Integer);
  Begin LabelZugNr.Caption:=IntToStr(Nr) End;
{****************************************************************************}
{*                          Zugberechnungen                                 *}
{****************************************************************************}
 Procedure TVG.ComputerZug;
  Var AlphaBeta:Integer;
      BestZug:SpielZug;
      K,L,Anzahl:Integer;
      KY,LX,X,Y:Integer;
      VirtuelleFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirtuelleBewertung:Bewertung;
  Begin
   Ausgabe.Clear;
     Screen.Cursor:=crHourglass;Service.Enabled:=False;
     LabelStatus.Caption:='PC denkt nach!';
     Delay(500);Count:=0;
     GenZugListe(F,Computer,Anzahl,ZugListe);BestZug:=8;
     For K:=1 To Anzahl Do
      Begin
       VirtuelleFeld:=F;VirtuelleBewertung:=B;Zug:=ZugListe[K];
       MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,1);
       For L:=1 To 69 Do
        If (VirtuelleBewertung[L].Wert=1) And
           (VirtuelleBewertung[L].Anzahl=4) Then BestZug:=Zug;
      End;
     If BestZug=8 Then
      Begin
       GenZugListe(F,Mensch,Anzahl,ZugListe);
       For K:=1 To Anzahl Do
        Begin
         VirtuelleFeld:=F;VirtuelleBewertung:=B;Zug:=ZugListe[K];
         MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,2);
         For L:=1 To 69 Do
          If (VirtuelleBewertung[L].Wert=2) And
             (VirtuelleBewertung[L].Anzahl=4) Then BestZug:=Zug;
        End
      End;
     If BestZug=8 Then Level:=Tiefe Else Level:=1;
     If (Tiefe>2) And (ZugNummer>29) Then Level:=9;
     If (Tiefe>3) And (ZugNummer>29) Then Level:=10;
     If (Tiefe>4) And (ZugNummer>29) Then Level:=11;
     LabelTiefe.Caption:=IntToStr(Level);
     AlphaBetaSuche(BestZug,AlphaBeta,B,Tiefe,F,Computer,MinInt,MaxInt);
     If AlphaBeta>1000 Then
      Begin
       LabelEnde.Font.Color:=clFuchsia;
       LabelEnde.Caption:='Du wirst verlieren!'
      End
     Else
      If AlphaBeta<-1000 Then
       Begin
        LabelEnde.Font.Color:=clBlue;
        LabelEnde.Caption:='Der PC hat keine Chance!'
       End
      Else LabelEnde.Caption:='';
     Screen.Cursor:=crHandPoint;
     LabelZug.Caption:='Mein Zug : '+Char(48+BestZug);
     MachZug(F,B,BestZug,1);
     SpielFeldAnzeige(F);
     Service.Enabled:=True;
     Inc(ZugNummer);SchreibZugNummer(ZugNummer);
     SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
     If Schluss(B) or Remis(B) Then
      Begin SpielEnde;SpielVerlauf End
     Else
      Begin
       LabelStatus.Caption:=Spieler1+' zieht!';
       Dran:=Mensch;
       If Warnung Then
        Begin
         GenZugListe(F,Computer,Anzahl,ZugListe);
         For K:=1 To Anzahl Do
          Begin
           VirtuelleFeld:=F;VirtuelleBewertung:=B;Zug:=ZugListe[K];
           MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,1);
           For L:=1 To 69 Do
            If (VirtuelleBewertung[L].Wert=1) And
               (VirtuelleBewertung[L].Anzahl=4) Then
             Begin
              KY:=6-VirtuelleFeld[Zug].Hoehe;LX:=Zug-1;
              X:=LX*Breite;Y:=KY*Breite;
              SpielFeldAusgabe.Canvas.Brush.Color:=clAqua;
              SpielFeldAusgabe.Canvas.Ellipse(X+4,Y+4,X+2*Radius,Y+2*Radius)
             End
          End
        End
      End
  End;

 Procedure TVG.SpielFeldAusgabeMouseDown(Sender: TObject;//Menschzug
           Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  Var Erlaubt:Boolean;
      NL,I:Integer;
      Zug:SpielZug;
      ZL:SpielZugListe;
  Begin
   If Not DarfSpielen Then
    Begin
     MessageDlg('Du mut erst das Spiel starten!',mtError,[mbRetry],0);
     Exit
    End;
   If Not Schluss(B) And Not Remis(B) Then
    Begin
     Zug:=x Div Breite+1;
     If (Shift=[ssleft]) And (Zug>0) And (Zug<8) And(F[Zug].Hoehe<=6) Then
      Begin
       ERLAUBT:=False;
       If ZweiSpielerModus Then GenZugListe(F,Dran,NL,ZL)
       Else GenZugListe(F,Mensch,NL,ZL);
       For I:=1 To NL Do
        If Zug=ZL[I] Then ERLAUBT:=True;
       If Not ERLAUBT Then
        Begin
         If SoundAn Then Sound('Fehler.wav');
         MessageDlg('    Die Spalte '+Char(48+Zug)+
                       #13+'ist NICHT zulssig!',mtError,[mbRetry],0)
        End
       Else
        Begin
         LabelZug.Caption:='Dein Zug : '+Char(48+Zug);
         Inc(ZugNummer);SchreibZugNummer(ZugNummer);
         If ZweiSpielerModus Then
          Begin
           If Dran=Computer Then
            Begin
             MachZug(F,B,Zug,1);
             LabelStatus.Caption:=Spieler1+' zieht!';
             Dran:=Mensch;
            End
           Else
            Begin
             MachZug(F,B,Zug,2);
             LabelStatus.Caption:=Spieler2+' zieht!';
             Dran:=Computer;
            End;
           SpielFeldAnzeige(F);
           SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
           DELAY(WarteZeit);
           If Schluss(B) or Remis(B) Then
            Begin SpielEnde;SpielVerlauf End;
          End
         Else
          Begin
           MachZug(F,B,Zug,2);
           SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
           SpielFeldAnzeige(F);
           DELAY(WarteZeit);
           If Schluss(B) or Remis(B) Then
            Begin SpielEnde;SpielVerlauf End
           Else Begin Dran:=Computer;ComputerZug End
          End
        End
      End
    End
  End;

 Procedure TVG.SuchZug(Var Zug:SpielZug;SF:SpielFeld;SB:Bewertung);
  Var VirtuelleFeld:SpielFeld;
      VirtuelleBewertung:Bewertung;
      Nr,K,AN:Integer;
      Grenze,MinMaxWert,GrenzWert:Integer;
      Liste,ZL:SpielZugListe;
      Zeigen:Boolean;
  Begin
   Grenze:=MaxInt;Nr:=0;Zeigen:=Anzeigen;
   If Anzeigen Then Anzeigen:=False;
   GenZugListe(SF,Mensch,AN,ZL);
   If SpielerName='Meister' Then GrenzWert:=Tiefe Else GrenzWert:=3;
   For K:=1 To AN Do
    Begin
     VirtuelleFeld:=SF;VirtuelleBewertung:=SB;Zug:=ZL[K];
     MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,2);
     AlphaBetaSuche(Zug,MinMaxWert,VirtuelleBewertung,GrenzWert,
                    VirtuelleFeld,Computer,MinInt,MaxInt);
     If MinMaxWert<=Grenze Then
      Begin
       If MinMaxWert=Grenze Then Inc(Nr);
       If MinMaxWert<Grenze Then Nr:=1;
       Liste[Nr]:=ZL[K];Grenze:=MinMaxWert;
      End;
    End;
   K:=Random(Nr)+1;Zug:=Liste[K];Anzeigen:=Zeigen
  End;
{****************************************************************************}
{*                         Spiel - Parameter festlegen                      *}
{****************************************************************************}
 Procedure TVG.Init;
  Begin
   F:=FAlt;
   FeldAusgabe;
   SpielFeldAnzeige(F);
   ZweiSpielerModus:=False;
   Zugvorschlag.Enabled:=True;
   Zugbewertung.Enabled:=True;
   Staerke.Enabled:=True;
   If MenschgegenMensch.Checked Then ZweiSpielerModus:=True;
   LabelStatus.Caption:='';
   LabelTiefe.Caption:='';
   LabelZugNr.Caption:='';
   LabelZug.Caption:='';
   LabelEnde.Caption:='';
   ZugNummer:=0;SpielListe[ZugNummer]:=F;
   FillChar(B,SizeOf(B),0); // B=0 setzen
   Werte[ZugNummer]:=B;
  End;

 Procedure TVG.NameErmitteln(Name:String;Var SpielerName:String);
  Var Code,K:Integer;
      Zahl:String;
  Begin
   SpielerName:='';
   If ZweiSpielerModus Then PasswordDlg.Caption:=Name+', gib deinen Namen ein!'
   Else PasswordDlg.Caption:='Wie heit Du, '+Name+'?';
   PasswordDlg.LabelPasswort.Caption:='Der Computer fordert Dich heraus!';
   PasswordDlg.Passwort.PasswordChar:=#0;
   PasswordDlg.Passwort.Text:='Brsel';
   Repeat
    PasswordDlg.ShowModal;
    SpielerName:=PasswordDlg.Passwort.Text;
    If Length(SpielerName)<3 Then PasswordDlg.Passwort.Text:='Ahab';
   Until Length(SpielerName)>2;
   Code:=Ord(SpielerName[1]);
   If (Code>96) And (Code<123) Then SpielerName[1]:=Char(Code-32);
   If SpielerName[1]='' Then SpielerName[1]:='A';
   If SpielerName[1]='' Then SpielerName[1]:='';
   If SpielerName[1]='' Then SpielerName[1]:='';
   For K:=2 To Length(SpielerName) Do
    Begin
     Code:=Ord(SpielerName[K]);
     If (Code>64) And (Code<91) Then SpielerName[K]:=Char(Code+32);
     If SpielerName[K]='' Then SpielerName[K]:='';
     If SpielerName[K]='' Then SpielerName[K]:='';
     If SpielerName[K]='' Then SpielerName[K]:='';
    End;
   If SpielerName='Meister' Then
    Begin
     PasswordDlg.Caption:='Paworteingabe';
     PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
     PasswordDlg.Passwort.PasswordChar:='?';
     PasswordDlg.Passwort.Text:='';
     PasswordDlg.ShowModal;
     Zahl:=PasswordDlg.Passwort.Text;
     If Zahl<>Geheim Then SpielerName:='Betrger';
    End;
  End;
{****************************************************************************}
{*                         Men - Prozeduren                                *}
{****************************************************************************}
 Procedure TVG.StartClick(Sender: TObject);
  Var ZL:SpielZugListe;
      NL:Integer;
  Begin
   If SoundAn Then Sound('Welcomef.wav');
   Init;DarfSpielen:=True;
   If ZweiSpielerModus Then
    Begin
     NameErmitteln('Spieler1',SpielerName);
     Spieler1:=SpielerName;
     NameErmitteln('Spieler2',SpielerName);
     Spieler2:=SpielerName;
     Zugvorschlag.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
    End
   Else
    Begin
     NameErmitteln('Spieler',SpielerName);
     Spieler1:=SpielerName;
     Spieler2:='Computer';
     If Menschbeginnt.Checked Then Dran:=Mensch
     Else Dran:=Computer
    End;
   If Dran=Mensch Then LabelStatus.Caption:=Spieler1+' zieht!'
   Else LabelStatus.Caption:=Spieler2+' zieht!';
   LabelMensch.Caption:=Spieler1;
   LabelComputer.Caption:=Spieler2;
   If Dran=Computer Then ComputerZug
   Else GenZugListe(F,Mensch,NL,ZL);
  End;

 Procedure TVG.EndeClick(Sender: TObject);
  Begin
   If MessageDlg('Willst du das Spiel beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes Then
    Begin
     MessageDlg('Das Spiel wird beendet!',mtWarning,[mbOk],0);
     If SoundAn Then Sound('Goodbyef.wav');
     close
    End
  End;

 Procedure TVG.LevelWahl(Sender: TObject);
  Begin
   If Sender=N1Anfaenger Then
    Begin Tiefe:=1;N1Anfaenger.Checked:=True End;
   If Sender=N2Geuebter  Then
    Begin Tiefe:=2;N2Geuebter.Checked:=True End;
   If Sender=N3Erfahrener Then
    Begin Tiefe:=3;N3Erfahrener.Checked:=True End;
   If Sender=N4Fortgeschrittener Then
    Begin Tiefe:=4;N4Fortgeschrittener.Checked:=True End;
   If Sender=N5Koenner Then
    Begin Tiefe:=5;N5Koenner.Checked:=True End;
   If Sender=N6Meister Then
    Begin Tiefe:=6;N6Meister.Checked:=True End;
   If Sender=N7Grossmeister Then
    Begin Tiefe:=7;N7Grossmeister.Checked:=True End;
   If Sender=N8Weltmeister Then
    Begin Tiefe:=8;N8Weltmeister.Checked:=True End;
   If Sender=N9Genie Then
    Begin Tiefe:=9;N9Genie.Checked:=True End;
   If Sender=N10Superhirn Then
    Begin Tiefe:=10;N10Superhirn.Checked:=True End;
   If Sender=N11AlbertEinstein Then
    Begin Tiefe:=11;N11AlbertEinstein.Checked:=True End;
   LabelTiefe.Caption:=IntToStr(Tiefe);
  End;

 Procedure TVG.WerBeginnt(Sender: TObject);
  Begin
   If Sender=Menschbeginnt Then
    Begin
     Dran:=Mensch;
     ZweiSpielerModus:=False;
     Menschbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugruecknahme.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
    End;
   If Sender=Computerbeginnt Then
    Begin
     Dran:=Computer;
     ZweiSpielerModus:=False;
     Computerbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugruecknahme.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
    End;
   If Sender=MenschgegenMensch Then
    Begin
     Dran:=Mensch;
     ZweiSpielerModus:=True;
     MenschgegenMensch.Checked:=True;
     LabelTiefe.Caption:='';
     Zugvorschlag.Enabled:=False;
     Zugruecknahme.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
     WarnHinweis.Enabled:=False;
    End;
  End;

 Procedure TVG.ZugbewertungClick(Sender: TObject);
  Begin
   If MessageDlg('Soll die Bewertung angezeigt werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes Then
    Begin
     VG.Width:=Ausgabe.Left+Ausgabe.Width+10;VG.Position:=poScreenCenter;
     MessageDlg('Die Bewertunganzeige ist aktiv!',mtInformation,[mbOk],0);
     Anzeigen:=True;
     Ausgabe.Visible:=True
    End
   Else
    Begin
     Ausgabe.Visible:=False;Anzeigen:=False;
     VG.Width:=Ausgabe.Left;VG.Position:=poScreenCenter;
    End
  End;

 Procedure TVG.SpielFeldAusgabePaint(Sender: TObject);
  Begin
   FeldAusgabe;
   SpielFeldAnzeige(F)
  End;

 Procedure TVG.ZugvorschlagClick(Sender: TObject);
  Var VirtuelleFeld:SpielFeld;
      VirtuelleBewertung:Bewertung;
      Zug:SpielZug;
  Begin
   VirtuelleFeld:=F;VirtuelleBewertung:=B;Screen.Cursor:=crHourGlass;
   LabelStatus.Caption:='Ich suche fr Dich!';
   SuchZug(Zug,VirtuelleFeld,VirtuelleBewertung);Screen.Cursor:=crHandPoint;
   ShowMessage('Mein Vorschlag :'+#13+'setze jetzt auf '+Char(48+Zug));
   LabelStatus.Caption:='Dein Zug : ';
  End;

 Procedure TVG.ZugruecknahmeClick(Sender: TObject);
  Begin
   If ZugNummer>1 Then
    Begin
     VG.LabelEnde.Caption:='';
     Dec(ZugNummer,2);SchreibZugNummer(ZugNummer);
     F:=SpielListe[ZugNummer];B:=Werte[ZugNummer];
     SpielFeldAnzeige(F);
     LabelStatus.Caption:='Dein Zug : ';
    End
  End;

 Procedure TVG.InfoClick(Sender: TObject);
  Begin InfoBox.ShowModal End;

 Procedure TVG.RegelnClick(Sender: TObject);
  Begin RegelnBox.ShowModal End;

 Procedure TVG.TonClick(Sender: TObject);
  Begin
   If MessageDlg('Soll der Sound aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes Then
    Begin
     MessageDlg('Der Sound ist aktiv!',mtInformation,[mbOk],0);
     SoundAn:=True;
    End
   Else SoundAn:=False;
  End;

 Procedure TVG.ZoomWahl(Sender: TObject);
  Begin
   If (Sender=Zoom120) And Not Zoom120.Checked Then
    Begin
     Zoom120.Checked:=True;
     ChangeScale(XFaktor,100);// Urzustand
     XFaktor:=83; ChangeScale(120,100);
    End;
   If (Sender=Zoom110) And Not Zoom110.Checked Then
    Begin
     Zoom110.Checked:=True;
     ChangeScale(XFaktor,100);// Urzustand
     XFaktor:=91; ChangeScale(110,100);
    End;
   If (Sender=Zoom100) And Not Zoom100.Checked Then
    Begin
     Zoom100.Checked:=True;
     ChangeScale(XFaktor,100);// Urzustand
     XFaktor:=100;
    End;
   If (Sender=Zoom90) And Not Zoom90.Checked Then
    Begin
     Zoom90.Checked:=True;
     ChangeScale(XFaktor,100);// Urzustand
     XFaktor:=111; ChangeScale(90,100);
    End;
   If (Sender=Zoom80) And Not Zoom80.Checked Then
    Begin
     Zoom80.Checked:=True;
     ChangeScale(XFaktor,100);// Urzustand
     XFaktor:=125; ChangeScale(80,100);
    End;
   If (Sender=Zoom75) And Not Zoom75.Checked Then
    Begin
     Zoom75.Checked:=True;
     ChangeScale(XFaktor,100);// Urzustand
     XFaktor:=133; ChangeScale(75,100);
    End;
   If (Sender=Zoom70) And Not Zoom70.Checked Then
    Begin
     Zoom70.Checked:=True;
     ChangeScale(XFaktor,100);// Urzustand
     XFaktor:=143; ChangeScale(70,100);
    End;
   MaxX:=SpielFeldAusgabe.Width;MaxY:=SpielFeldAusgabe.Height;
   Breite:=MAXY Div TEIL;Radius:=Breite Div 2;
  End;

 Procedure TVG.FormCreate(Sender: TObject);
 const ScreenHeightDev=768;ScreenWidthDev=1024;
  Var I,K,L:Integer;
      Zeile:String;
      x,y:Integer;
  Begin
   Scaled:=True;x:=Screen.width;y:=screen.height;
   If (y<>ScreenHeightDev) or (x<>ScreenWidthDev) Then
    Begin
     Height:=(ClientHeight*y Div ScreenHeightDev)+Height-ClientHeight;
     Width:=(ClientWidth*x Div ScreenWidthDev)+Height-ClientHeight;
     ScaleBy(x,ScreenwidthDev);
    End;
   VG.Width:=Ausgabe.Left;
   Screen.Cursor:=crHandPoint;XFaktor:=100;
   MaxX:=SpielFeldAusgabe.Width;MaxY:=SpielFeldAusgabe.Height;
   Breite:=MAXY Div TEIL;CopyRight;Randomize;
   FARBE[1]:=clRed;FARBE[2]:=clGreen;
   FARBE[3]:=clMaroon;FARBE[4]:=clLime;
   Radius:=Breite Div 2;
   Schrift:=clBlack;Init;Dran:=Computer;Tiefe:=3;
   LabelTiefe.Caption:=IntToStr(Tiefe);
   Anzeigen:=False;//Bewertungsanzeige
   Warnung:=False;// Verlustanzeige
   Ausgabe.Visible:=False;
   DarfSpielen:=False;SoundAn:=False;

   // hier fehlt was!!!
   { waagerechte Reihen }
   { senkrechte Reihen }
   { diagonal steigende Reihen }
   { diagonal fallende Reihen }

   Ausgabe.Lines.Add('Gewinnreihen');
   For L:=1 To 69 Do
    Begin
     Zeile:=IntToStr(L)+') ';
     For K:=1 To 3 Do Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[K])+' - ';
     Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[4]);
     Ausgabe.Lines.Add(Zeile);
    End;
   For I:=1 To 42 Do
    Begin
     F[I].Art:=0;F[I].Hoehe:=0;F[I].Anzahl:=0;
     For L:=1 To 69 Do
      For K:=1 To 4 Do
       If Reihe[L].FeldNr[K]=I Then
        Begin Inc(F[I].Anzahl);F[I].Wo[F[I].Anzahl]:=L End
    End;
   Ausgabe.Lines.Add('');
   Ausgabe.Lines.Add('Feldinhalte');
   For I:=1 To 42 Do
    Begin
     Zeile:=IntToStr(I)+') ';
     For K:=1 To F[I].Anzahl-1 Do Zeile:=Zeile+IntToStr(F[I].Wo[K])+' - ';
     Zeile:=Zeile+IntToStr(F[I].Wo[F[I].Anzahl]);
     Ausgabe.Lines.Add(Zeile);
    End;
   FAlt:=F;
  End;

 Procedure TVG.WarnHinweisClick(Sender: TObject);
  Begin
   If MessageDlg('Soll die Hinweiswarnung aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes Then
    Begin
     MessageDlg('Der Hinweiswarnung ist aktiv!',mtInformation,[mbOk],0);
     Warnung:=True;
    End
   Else Warnung:=False;
  End;

End.

