unit Optionen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin;

type
  TOptions = class(TForm)
    Label1: TLabel;
    M11: TSpinEdit;
    M12: TSpinEdit;
    M21: TSpinEdit;
    M22: TSpinEdit;
    Label2: TLabel;
    ButtonOk: TButton;
    Determinante: TEdit;
    procedure ButtonOkClick(Sender: TObject);
    procedure MChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Options: TOptions;

implementation

uses Poincare;

{$R *.dfm}

 procedure TOptions.ButtonOkClick(Sender: TObject);
  begin
   Fractal.Matrix[1,1]:=M11.Value;Fractal.Matrix[1,2]:=M12.Value;
   Fractal.Matrix[2,1]:=M21.Value;Fractal.Matrix[2,2]:=M22.Value;
   close;
  end;

 procedure TOptions.MChange(Sender: TObject);
  begin
   Determinante.Text:=IntToStr(M11.Value*M22.Value-M21.Value*M12.Value);
   if Abs(StrToInt(Determinante.Text))=1 then
    Label2.Caption:='flchentreue'+#13+'Verzerrung'
   else Label2.Caption:='keine'+#13+'flchentreue'+#13+'Verzerrung'; 
  end;

end.
