unit TTT3D2000;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, MPlayer, ComCtrls;
                                    // Computer - Mensch
 const RWerte:Array[1..6]of Integer=(5,40,800,10,80,2000);
       MinInt=-300000;MaxInt=300000;WarteZeit=200;
       Gut:Array[1..27]of Byte=(14, 1, 3, 7, 9,19,21,25,27,5,23,10,12,16,
                                18,11,13,15,17,2,4,6,8,20,22,24,26);
 type
      Inhalt=Record
              Art,Anzahl:Byte;       // Spielstein, Anzahl der Gewinnreihen
              Gewinnreihe:Array[1..13]of Byte // GewinnreihenNummern
             End;
      BInhalt=Record Wert,Anzahl:Byte End;
      Nr=Record FeldNr:Array[1..3]of Byte End;
      SpielFeld=Record Brett:Array[1..27]of Inhalt;Mitte:Boolean End;
      Bewertung=Array[1..49]of BInhalt;
      SpielZug=Byte;
      SpielZugListe=Array[1..27]of SpielZug;
      Spieler=(Computer,Mensch); // 1 - Computer        2 - Mensch

  TTTT3D = class(TForm)
    MainMenu: TMainMenu;
    Spiel: TMenuItem;
    Start: TMenuItem;
    Staerke: TMenuItem;
    N1Anfaenger: TMenuItem;
    N2Geuebter: TMenuItem;
    N3Erfahrener: TMenuItem;
    N4Fortgeschrittener: TMenuItem;
    N5Koenner: TMenuItem;
    N6Meister: TMenuItem;
    N7Grossmeister: TMenuItem;
    N8Weltmeister: TMenuItem;
    N9Genie: TMenuItem;
    N10Superhirn: TMenuItem;
    N11AlbertEinstein: TMenuItem;
    Einstellungen: TMenuItem;
    Menschbeginnt: TMenuItem;
    Computerbeginnt: TMenuItem;
    MenschgegenMensch: TMenuItem;
    Service: TMenuItem;
    Zugruecknahme: TMenuItem;
    Zugvorschlag: TMenuItem;
    Zugbewertung: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    Regeln: TMenuItem;
    FeldPanel: TPanel;
    Ende: TMenuItem;
    Status: TPanel;
    StatusText: TStaticText;
    TiefeText: TStaticText;
    Panel1: TPanel;
    LabelStatus: TLabel;
    Panel2: TPanel;
    LabelTiefe: TLabel;
    Panel3: TPanel;
    LabelZug: TLabel;
    LabelEnde: TLabel;
    ZugNrText: TStaticText;
    Panel4: TPanel;
    LabelZugNr: TLabel;
    LabelMensch: TLabel;
    LabelComputer: TLabel;
    MediaPlayer: TMediaPlayer;
    Ausgabe: TRichEdit;
    Ton: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    WarnHinweis: TMenuItem;
    SpielFeldAusgabe: TImage;
    ComputerStein: TImage;
    MenschStein: TImage;
    LabelCS: TLabel;
    LabelMS: TLabel;
    LabelW: TLabel;
    CSStein: TImage;
    MSStein: TImage;
    WStein: TImage;
    procedure StartClick(Sender: TObject);
    procedure LevelWahl(Sender: TObject);
    procedure WerBeginnt(Sender: TObject);
    procedure EndeClick(Sender: TObject);
    procedure ZugbewertungClick(Sender: TObject);
    procedure SpielFeldAusgabeMouseDown(Sender: TObject; Button: TMouseButton;
                                        Shift: TShiftState; X, Y: Integer);
    procedure ZugvorschlagClick(Sender: TObject);
    procedure ZugruecknahmeClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
    procedure Sound(Datei:String);
    procedure Copyright;
    procedure FeldAusgabe;
    procedure Delay(Zeit:DWord);// Pausenzeit in Millisekunden
    procedure SpielFeldAnzeige(SF:SpielFeld);
    procedure GenZugListe(var F:SpielFeld;Amzug:Spieler;var N:Byte;
                          var ZL:SpielZugListe);
    function Wert(Mitte:Boolean;B:Bewertung):Integer;
    function Max(X,Y:Integer):Integer;
    function Min(X,Y:Integer):Integer;
    procedure MachZug(var F:SpielFeld;var B:Bewertung;Zug:SpielZug;Amzug:Byte);
    function BrettVoll(var F:SpielFeld):Boolean;
    procedure SucheZug(var BestZug:SpielZug;var AlphaBeta:Integer;
                     B:Bewertung;N:Byte;F:SpielFeld;Amzug:Spieler;Alpha,Beta:Integer);
    procedure SpielEnde;
    procedure SchreibZugNummer(Nr:Integer);
    procedure ComputerZug;
    procedure SucheVorschlag(var Zug:SpielZug;SF:SpielFeld;SB:Bewertung);
    procedure Init;
    procedure NameErmitteln(Name:String;var SpielerName:String);
    procedure TonClick(Sender: TObject);
    procedure SpielVerlauf;
    function TimeSekunden:Extended;
    procedure FormCreate(Sender: TObject);
    procedure WarnHinweisClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
     Reihe:Array[1..49]of Nr;
     Koordinate:Array[1..27]of TPoint;
     F,FAlt:SpielFeld;
     B:Bewertung;
     SpielListe:Array[0..27]of SpielFeld;
     Werte:Array[0..27]of Bewertung;
     Dran:Spieler;
     Tiefe,ZugNummer:Byte;
     Count,MaxX,MaxY,XFaktor:Integer;
     Geheim,SpielerName,Spieler1,Spieler2:String;
     Warnung,SoundAn,DarfSpielen,Anzeigen,ZweiSpielerModus:Boolean;
     GruenGesetzt,RotGesetzt,Rot,Gruen,Leer,Bild,GruenSieg,RotSieg,Warn:TBitMap;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  End;

var TTT3D: TTTT3D;

implementation

uses Passwort, Info, Regeln;

{$R *.DFM}
{$R+,Q+} // die Bereichsberprfung und die berlaufprfung ist aktiviert
         //         Arrays                   Wertebereich

 function TTTT3D.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  Begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  End;

 procedure TTTT3D.Delay(Zeit:DWord);// Pausenzeit in Millisekunden
  var AltZeit:DWord;
  begin
   AltZeit:=GetTickCount;
   repeat Application.ProcessMessages until GetTickCount-AltZeit>Zeit
  end; 
{****************************************************************************}
{*                         Geheimzahl berechnen                             *}
{****************************************************************************}
 procedure TTTT3D.Copyright;
  var Name:String;
      K,LA:Byte;
  Begin
   RandSeed:=3062;Name:='D_';Geheim:='';LA:=223;
   for K:=1 to 6 do
    Geheim:=Geheim+Char(32+(ord(Name[K])-Random(LA)+LA-32) mod LA);
  End;
{****************************************************************************}
{*                         Ausgabe des Spielfeldes                          *}
{****************************************************************************}
 procedure TTTT3D.FeldAusgabe;
  var E,Z,S:Byte;
      XStart,XAnfang,DY,DX,EDX,Y,YAnfang:Integer;
      Rect:TRect;
  Begin
   SpielFeldAusgabe.Canvas.Brush.Color:=clYellow;
   Rect.Left:=0;Rect.Top:=0;Rect.Right:=MaxX;Rect.Bottom:=MaxY;
   SpielFeldAusgabe.Canvas.FillRect(Rect);// Feld lschen
   DX:=15;DY:=26;EDX:=44;XAnfang:=22;YAnfang:=MaxY-40;
   for E:=0 to 2 do
    for Z:=0 to 2 do
     Begin
      XStart:=XAnfang+Z*DX;Y:=YAnfang-Z*DY-E*114;
      for S:=0 to 2 do
       Begin
        Koordinate[3*Z+S+1+9*E].X:=XStart+S*EDX;
        Koordinate[3*Z+S+1+9*E].Y:=Y
       End;
     End;
  End;
{****************************************************************************}
{*                         nderungen des Spielfeldes                       *}
{****************************************************************************}
 procedure TTTT3D.SpielFeldAnzeige(SF:SpielFeld);
  var K:Byte;
  Begin
   with SpielFeldAusgabe.Canvas do
    Begin
     for K:=1 to 27 do
      Begin
       if SF.Brett[K].Art=1 then Bild:=Rot; // Computer
       if SF.Brett[K].Art=2 then Bild:=Gruen; // Mensch
       if SF.Brett[K].Art=3 then Bild:=RotSieg; // Computersieg
       if SF.Brett[K].Art=4 then Bild:=GruenSieg; // Menschsieg
       if SF.Brett[K].Art=11 then Bild:=RotGesetzt; // ComputerMarkierung
       if SF.Brett[K].Art=12 then Bild:=GruenGesetzt; // MenschMarkierung
       if SF.Brett[K].Art=0 then Bild:=Leer; // Leer
       Draw(Koordinate[K].X,Koordinate[K].Y,Bild);
      End;
    End
  End;
{****************************************************************************}
{*                         Spiel - Prozeduren                               *}
{****************************************************************************}
 procedure TTTT3D.GenZugListe(var F:SpielFeld;Amzug:Spieler;var N:Byte;
                              var ZL:SpielZugListe);
  var K,JA:Byte;
  Begin
   N:=0;if F.Mitte then JA:=1 else JA:=0;
   for K:=2-JA to 27 do
    if F.BRETT[Gut[K]].Art=0 then Begin inc(N);ZL[N]:=Gut[K] End
  End;

 function TTTT3D.Wert(Mitte:Boolean;B:Bewertung):Integer;
  var T:Byte;
      Sp,Com:Integer;
      Werte:Array[1..6]of Integer;
  Begin
   Sp:=0;Com:=0;Move(RWerte,Werte,SizeOf(RWerte));
   if not Mitte then
    Begin
     Werte[1]:=800;Werte[2]:=20000;Werte[3]:=10; // Computer
     Werte[4]:=500;Werte[5]:=10000;Werte[6]:=5;  // Mensch
    End;
   for T:=1 to 49 do
    if B[T].Wert=1 then Com:=Com+Werte[B[T].Anzahl]
    else
     if B[T].Wert=2 then Sp:=Sp+Werte[B[T].Anzahl+3];
   Wert:=Com-Sp;inc(Count)
  End;

 function TTTT3D.Max(X,Y:Integer):Integer;
  Begin if X<Y then Max:=Y else Max:=X End;

 function TTTT3D.Min(X,Y:Integer):Integer;
  Begin if X<Y then Min:=X else Min:=Y End;

 procedure TTTT3D.MachZug(var F:SpielFeld;var B:Bewertung;Zug:SpielZug;Amzug:Byte);
  var L,T:Byte;
  Begin
   with F do
    Begin
     Brett[Zug].Art:=Amzug;
     for L:=1 to Brett[Zug].Anzahl do
      with B[Brett[Zug].Gewinnreihe[L]] do
       Begin Wert:=Wert or Amzug;inc(Anzahl) End
    End;
   for T:=1 to 49 do
    if (B[T].Anzahl=3) and ((B[T].Wert=1) or (B[T].Wert=2)) then F.Mitte:=True;
  End;

 function TTTT3D.BrettVoll(var F:SpielFeld):Boolean;
  var K:Byte;
  Begin
   BrettVoll:=False;
   for K:=1 to 27 do
    if F.Brett[K].Art=0 then Exit;
   BrettVoll:=True
  End;

 procedure TTTT3D.SucheZug(var BestZug:SpielZug;var AlphaBeta:Integer;
               B:Bewertung;N:Byte;F:SpielFeld;Amzug:Spieler;Alpha,Beta:Integer);
  var VirFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirB:Bewertung;
      M:Integer;
      Ebene,Spalte,Zeile,I,Anzahl:Byte;
      AbZeile:String;
  Begin
   if (N=0) or BrettVoll(F) then AlphaBeta:=Wert(F.Mitte,B)
   else
    Begin
     GenZugListe(F,Amzug,Anzahl,ZugListe);
     if Amzug=Computer then
      Begin
       M:=Alpha;I:=0;
       while (I<Anzahl) and (M<Beta) do
        Begin
         VirFeld:=F;VirB:=B;inc(I);Zug:=ZugListe[I];
         MachZug(VirFeld,VirB,Zug,1);
         SucheZug(BestZug,AlphaBeta,VirB,N-1,VirFeld,Mensch,M,Beta);
         if (N=Tiefe) and Anzeigen then
          Begin
           Ebene:=Zug div 9+1;if Zug mod 9=0 then dec(Ebene);
           Spalte:=Zug mod 3;Zeile:=(Zug-(Ebene-1)*9) div 3+1;
           if Spalte=0 then Begin Spalte:=3;dec(Zeile) End;
           AbZeile:='Wert von E'+IntToStr(4-Ebene)+' S'+IntToStr(Spalte)+' Z'
                    +IntToStr(4-Zeile);
           AbZeile:=AbZeile+'='+IntToStr(AlphaBeta);
           Ausgabe.Lines.Add(AbZeile);
           AbZeile:=IntToStr(Count)+' analysierte Stellungen';
           Ausgabe.SelAttributes.Color:=clBlue;
           Ausgabe.Lines.Add(AbZeile);
           Ausgabe.SelAttributes.Color:=clBlack
          End;
         if M<AlphaBeta then
          Begin
           M:=AlphaBeta;
           if N=Tiefe then
            Begin
             BestZug:=Zug;
             if Anzeigen then
              Begin
               Ebene:=BestZug div 9+1;if BestZug mod 9=0 then dec(Ebene);
               Spalte:=BestZug mod 3;Zeile:=(BestZug-(Ebene-1)*9) div 3+1;
               if Spalte=0 then Begin Spalte:=3;dec(Zeile) End;
               AbZeile:='bisher bester ComputerZug :E'+IntToStr(4-Ebene)+' S'
                        +IntToStr(Spalte)+' Z'+IntToStr(4-Zeile);
               AbZeile:=AbZeile+'='+IntToStr(AlphaBeta);
               Ausgabe.SelAttributes.Color:=clRed;
               Ausgabe.Lines.Add(AbZeile);
               Ausgabe.SelAttributes.Color:=clBlack;
              End
            End
          End
        End
      End
     else
      Begin
       M:=Beta;I:=0;
       while (I<Anzahl) and (M>Alpha) do
        Begin
         VirFeld:=F;VirB:=B;inc(I);Zug:=ZugListe[I];
         MachZug(VirFeld,VirB,Zug,2); // Simulation des Gegners
         SucheZug(BestZug,AlphaBeta,VirB,N-1,VirFeld,Computer,Alpha,M);
         if M>AlphaBeta then M:=AlphaBeta
        End
      End;
     AlphaBeta:=M
    End
  End;

{****************************************************************************}
{*       Endabrechnung, Computer- und Menschzug, Utilities                  *}
{****************************************************************************}
 procedure TTTT3D.Sound(Datei:String);
  Begin
   Screen.Cursor:=crHourglass;
   try
    MediaPlayer.DeviceType:=dtAutoSelect; //dtWaveAudio;
    MediaPlayer.FileName:=Datei;
    MediaPlayer.Open;
    MediaPlayer.wait:=True;
    MediaPlayer.Play;
    MediaPlayer.Close;
   except
    on EMCIDeviceError do
     MessageDlg('Die Datei '+Datei+' wurde NICHT gefunden!',mtError,[mbRetry],0)
    End;
   Screen.Cursor:=crHandPoint
  End;

 procedure TTTT3D.SpielVerlauf;
  var K:Byte;
      Feld:SpielFeld;
  Begin
   if ZugNummer>1 then
    Begin
     if MessageDlg('Soll ich den ganzen SpielVerlauf Zeigen?',
                    mtConfirmation,[mbYes,mbNo],0)=mrYes then
      Begin
       LabelStatus.Caption:='SpielVerlauf';
       LabelZug.Caption:='';
       for K:=1 to ZugNummer do
        Begin
         SchreibZugNummer(K);
         Feld:=SpielListe[K];
         SpielFeldAnzeige(Feld);
         if MessageDlgPos('Weiter?',mtConfirmation,[mbYes,mbNo],0,
          TTT3D.Left+Status.Left,TTT3D.Top+FeldPanel.Height div 2)=mrNo then Exit
        End;
       SpielEnde
      End;
    End;
   End;

 procedure TTTT3D.SpielEnde;
  const Warte=2000;
  var K,L,ComputerSiege,MenschSiege:Byte;
      Anzeige:String;
      Remis:Boolean;
  Begin
   ComputerSiege:=0;MenschSiege:=0;
   for K:=1 to 49 do
    if B[K].Wert=1 then
     Begin
      if B[K].Anzahl=3 then
       Begin
        for L:=1 to 3 do
         F.Brett[Reihe[K].FeldNr[L]].Art:=3; // ComputerMhle Anzeigen
        SpielFeldAnzeige(F);Delay(Warte);
        for L:=1 to 3 do
         F.Brett[Reihe[K].FeldNr[L]].Art:=1; // ComputerMhle lschen
        SpielFeldAnzeige(F);
        inc(ComputerSiege);
        MessageDlgPos('Spielstand (C : M) '+IntToStr(ComputerSiege)+' : '
                      +IntToStr(MenschSiege),mtInformation,[mbOk],0,TTT3D.Left+
                      Ausgabe.Left,TTT3D.Top+Ausgabe.Top+20);
       End
     End
    else
     if B[K].Wert=2 then
      Begin
      if B[K].Anzahl=3 then
       Begin
        for L:=1 to 3 do
         F.Brett[Reihe[K].FeldNr[L]].Art:=4; // MenschMhle Anzeigen
        SpielFeldAnzeige(F);Delay(Warte);
        for L:=1 to 3 do
         F.Brett[Reihe[K].FeldNr[L]].Art:=2; // MenschMhle lschen
        SpielFeldAnzeige(F);
        inc(MenschSiege);
        MessageDlgPos('Spielstand (C : M) '+IntToStr(ComputerSiege)+' : '+
                      IntToStr(MenschSiege),mtInformation,[mbOk],0,TTT3D.Left+
                      Ausgabe.Left,TTT3D.Top+Ausgabe.Top+20);
       End
     End;
   Remis:=False;
   if ComputerSiege>MenschSiege then
    Begin
     LabelEnde.Font.Color:=clRed;
     if not ZweiSpielerModus then
      Begin
       Anzeige:='SuperPC hat '+IntToStr(ComputerSiege)+' zu '+
                 IntToStr(MenschSiege)+' gewonnen!';
       if SoundAn then Sound('Computersieg.wav')
      End
     else
      Anzeige:=Spieler2+' gewinnt '+IntToStr(ComputerSiege)+' zu '+
               IntToStr(MenschSiege);
    End
   else if ComputerSiege<MenschSiege then
         Begin
          LabelEnde.Font.Color:=clGreen;
          if not ZweiSpielerModus then
           Begin
            Anzeige:='Du hast mich '+IntToStr(MenschSiege)+' zu '+
                     IntToStr(ComputerSiege)+' besiegt!';
            if SoundAn then Sound('Menschsieg.wav')
           End
          else
           Anzeige:=Spieler1+' gewinnt '+IntToStr(MenschSiege)+' zu '+
                    IntToStr(ComputerSiege);
         End
        else Remis:=True;
   if Remis then
    Anzeige:='Remis '+IntToStr(ComputerSiege)+' : '+IntToStr(MenschSiege);
   LabelEnde.Caption:=Anzeige;
   LabelStatus.Caption:='Das Spiel ist zu Ende';
  End;

 procedure TTTT3D.SchreibZugNummer(Nr:Integer);
  Begin LabelZugNr.Caption:=IntToStr(Nr) End;
{****************************************************************************}
{*                          Zugberechnungen                                 *}
{****************************************************************************}
 procedure TTTT3D.ComputerZug;
  var AlphaBeta:Integer;
      BestZug:SpielZug;
      Ebene,Zeile,Spalte,K,L,Anzahl:Byte;
      VirFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirB:Bewertung;
      TSek:Extended;
  Begin
   Ausgabe.Clear;
   Screen.Cursor:=crHourglass;Service.Enabled:=False;
   LabelStatus.Caption:='PC denkt nach!';
   Delay(500);Count:=0;BestZug:=70;
   if ZugNummer=0 then BestZug:=Gut[Random(8)+2];
   LabelTiefe.Caption:=IntToStr(Tiefe);
   // falls der Gegner als erster eine Reihe aufbaut, wird die Mitte besetzt
   if F.Mitte and (F.Brett[14].Art=0) then BestZug:=14;
   TSek:=TimeSekunden;
   if BestZug=70 then
    SucheZug(BestZug,AlphaBeta,B,Tiefe,F,Computer,MinInt,MaxInt);
   TSek:=TimeSekunden-TSek;
   Ausgabe.SelAttributes.Color:=clGreen;
   Ausgabe.Lines.Add('Rechenzeit : '+Format('%0.2f',[TSek])+' Sek.');
   Ausgabe.SelAttributes.Color:=clBlack;
   if AlphaBeta>500 then
    Begin
     LabelEnde.Font.Color:=clFuchsia;
     LabelEnde.Caption:='Du wirst verlieren!'
    End
   else
    if AlphaBeta<-500 then
     Begin
      LabelEnde.Font.Color:=clBlue;
      LabelEnde.Caption:='Der PC hat keine Chance!'
     End
    else LabelEnde.Caption:='';
   Screen.Cursor:=crHandPoint;
   Ebene:=BestZug div 9+1;if BestZug mod 9=0 then dec(Ebene);
   Spalte:=BestZug mod 3;Zeile:=(BestZug-(Ebene-1)*9) div 3+1;
   if Spalte=0 then Begin Spalte:=3;dec(Zeile) End;
   LabelZug.Caption:='Mein Zug : E'+IntToStr(4-Ebene)+' S'+IntToStr(Spalte)
                      +' Z'+IntToStr(4-Zeile);
   MachZug(F,B,BestZug,1);
   inc(F.Brett[BestZug].Art,10); // gesetzten Zug markieren
   SpielFeldAnzeige(F);Delay(1000);
   dec(F.Brett[BestZug].Art,10); // Markierung lschen
   Service.Enabled:=True;
   inc(ZugNummer);SchreibZugNummer(ZugNummer);
   SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
   if BrettVoll(F) then
    Begin SpielEnde;SpielVerlauf End
   else
    Begin
     LabelStatus.Caption:=Spieler1+' zieht!';
     Dran:=Mensch;
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirB:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirB,Zug,1);
         for L:=1 to 49 do
          if (VirB[L].Wert=1) and (VirB[L].Anzahl=3) then
           with SpielFeldAusgabe.Canvas do
            Draw(Koordinate[Zug].X,Koordinate[Zug].Y,Warn);
        End
      End
    End
  End;

 procedure TTTT3D.SpielFeldAusgabeMouseDown(Sender: TObject;//Menschzug
           Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var Ebene,Zeile,Spalte,K:Byte;
      Zug:SpielZug;
  Begin
   if not DarfSpielen then
    Begin
     MessageDlg('Du mut erst das Spiel starten!',mtError,[mbRetry],0);
     Exit
    End;
   if not BrettVoll(F) and (Shift=[ssleft])then
    Begin
     Zug:=70;
     for k:=1 to 27 do
      if (x>Koordinate[k].x) and (x<Koordinate[k].x+41) and
         (y>Koordinate[k].y) and (y<Koordinate[k].y+23) then
       Begin Zug:=K;Break End;
     if (Zug>0) and (Zug<28) and(F.Brett[Zug].Art=0) then
      Begin
       if (Zug=14) and not F.Mitte then
        Begin
         MessageDlg('Es gibt noch keine Mhle!',mtError,[mbOk],0);
         Exit
        End;
       Ebene:=Zug div 9+1;if Zug mod 9=0 then dec(Ebene);
       Spalte:=Zug mod 3;Zeile:=(Zug-(Ebene-1)*9) div 3+1;
       if Spalte=0 then Begin Spalte:=3;dec(Zeile) End;
       LabelZug.Caption:='Dein Zug : E'+IntToStr(4-Ebene)+' S'+IntToStr(Spalte)
                         +' Z'+IntToStr(4-Zeile);
       inc(ZugNummer);SchreibZugNummer(ZugNummer);
       SpielListe[ZugNummer]:=F;Werte[ZugNummer]:=B;
       if ZweiSpielerModus then
        Begin
         if Dran=Computer then
          Begin
           MachZug(F,B,Zug,1);
           LabelStatus.Caption:=Spieler1+' zieht!';
           Dran:=Mensch;
          End
         else
          Begin
           MachZug(F,B,Zug,2);
           LabelStatus.Caption:=Spieler2+' zieht!';
           Dran:=Computer;
          End;
         inc(F.Brett[Zug].Art,10); // gesetzten Zug markieren
         SpielFeldAnzeige(F);Delay(1000);
         dec(F.Brett[Zug].Art,10); // Markierung lschen
         Delay(WarteZeit);
         if BrettVoll(F) then
          Begin SpielEnde;SpielVerlauf End;
        End
       else
        Begin
         MachZug(F,B,Zug,2);
         inc(F.Brett[Zug].Art,10); // gesetzten Zug markieren
         SpielFeldAnzeige(F);Delay(1000);
         dec(F.Brett[Zug].Art,10); // Markierung lschen
         Delay(WarteZeit);
         if BrettVoll(F) then
          Begin SpielEnde;SpielVerlauf End
         else Begin Dran:=Computer;ComputerZug End
        End
      End
    End
  End;

 procedure TTTT3D.SucheVorschlag(var Zug:SpielZug;SF:SpielFeld;SB:Bewertung);
  var VirFeld:SpielFeld;
      VirB:Bewertung;
      Nr,K,AN:Byte;
      Grenze,MinMaxWert,GrenzWert:Integer;
      Liste,ZL:SpielZugListe;
      Zeigen:Boolean;
  Begin
   Grenze:=MaxInt;Nr:=0;Zeigen:=Anzeigen;
   if Anzeigen then Anzeigen:=False;
   GenZugListe(SF,Mensch,AN,ZL);
   if SpielerName='Meister' then GrenzWert:=Max(3,Tiefe)
   else GrenzWert:=Min(3,Tiefe);
   for K:=1 to AN do
    Begin
     VirFeld:=SF;VirB:=SB;Zug:=ZL[K];
     MachZug(VirFeld,VirB,Zug,2);
     SucheZug(Zug,MinMaxWert,VirB,GrenzWert,VirFeld,Computer,MinInt,MaxInt);
     if MinMaxWert<=Grenze then
      Begin
       if MinMaxWert=Grenze then inc(Nr);
       if MinMaxWert<Grenze then Nr:=1;
       Liste[Nr]:=ZL[K];Grenze:=MinMaxWert;
      End;
    End;
   K:=Random(Nr)+1;Zug:=Liste[K];Anzeigen:=Zeigen
  End;
{****************************************************************************}
{*                         Spiel - Parameter festlegen                      *}
{****************************************************************************}
 procedure TTTT3D.Init;
  Begin
   F:=FAlt;
   FeldAusgabe;
   SpielFeldAnzeige(F);
   ZweiSpielerModus:=False;
   Zugvorschlag.Enabled:=True;
   Zugbewertung.Enabled:=True;
   Staerke.Enabled:=True;
   if MenschgegenMensch.Checked then ZweiSpielerModus:=True;
   LabelStatus.Caption:='';
   LabelTiefe.Caption:='';
   LabelZugNr.Caption:='';
   LabelZug.Caption:='';
   LabelEnde.Caption:='';
   ZugNummer:=0;SpielListe[ZugNummer]:=F;
   FILLCHAR(B,SIZEOF(B),0); // B=0 SETZEN
   Werte[ZugNummer]:=B;
  End;

 procedure TTTT3D.NameErmitteln(Name:String;var SpielerName:String);
  const NameListe:Array[0..3]of String=('Ahab','Brsel','Meister','Schrder');
  var Zahl,ersterBuchstabe:String;
  Begin
  SpielerName:='';
   if ZweiSpielerModus then PasswordDlg.Caption:=Name+', gib deinen Namen ein!'
   else PasswordDlg.Caption:='Wie heit Du, '+Name+'?';
   PasswordDlg.LabelPasswort.Caption:='Der Computer fordert Dich heraus!';
   PasswordDlg.Passwort.PasswordChar:=#0;
   PasswordDlg.Passwort.Text:=NameListe[random(3)];
   repeat
    PasswordDlg.ShowModal;
    SpielerName:=PasswordDlg.Passwort.Text;
    if Length(SpielerName)<3 then
     PasswordDlg.Passwort.Text:=NameListe[random(3)];
   until Length(SpielerName)>2;
   SpielerName:=AnsiLowerCase(SpielerName);
   ersterBuchstabe:=AnsiUpperCase(SpielerName[1]);
   SpielerName[1]:=ersterBuchstabe[1];
   if SpielerName='Meister' then
    Begin
     PasswordDlg.Caption:='Paworteingabe';
     PasswordDlg.LabelPasswort.Caption:='Gib deine Codezahl ein!';
     PasswordDlg.Passwort.PasswordChar:='?';
     PasswordDlg.Passwort.Text:='';
     PasswordDlg.ShowModal;
     Zahl:=PasswordDlg.Passwort.Text;
     if Zahl<>Geheim then SpielerName:='Betrger';
    End;
  End;
{****************************************************************************}
{*                         Men - Prozeduren                                *}
{****************************************************************************}
 procedure TTTT3D.StartClick(Sender: TObject);
  Begin
   if SoundAn then Sound('Welcomef.wav');
   Init;DarfSpielen:=True;
   if ZweiSpielerModus then
    Begin
     NameErmitteln('Spieler1',SpielerName);
     Spieler1:=SpielerName;
     NameErmitteln('Spieler2',SpielerName);
     Spieler2:=SpielerName;
     Zugvorschlag.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
    End
   else
    Begin
     NameErmitteln('Spieler',SpielerName);
     Spieler1:=SpielerName;
     Spieler2:='Computer';
     if Menschbeginnt.Checked then Dran:=Mensch
     else Dran:=Computer
    End;
   if Dran=Mensch then LabelStatus.Caption:=Spieler1+' zieht!'
   else LabelStatus.Caption:=Spieler2+' zieht!';
   LabelMensch.Caption:=Spieler1;
   LabelComputer.Caption:=Spieler2;
   if Dran=Computer then ComputerZug
  End;

 procedure TTTT3D.EndeClick(Sender: TObject);
  Begin close End;

 procedure TTTT3D.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  Begin
   if MessageDlg('Willst du das Spiel beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Das Spiel wird beendet!',mtWarning,[mbOk],0);
     if SoundAn then Sound('Goodbyef.wav');
     CanClose:=True
    End
   else CanClose:=False
  End; 

 procedure TTTT3D.LevelWahl(Sender: TObject);
  Begin
   if Sender=N1Anfaenger then
    Begin Tiefe:=1;N1Anfaenger.Checked:=True End;
   if Sender=N2Geuebter  then
    Begin Tiefe:=2;N2Geuebter.Checked:=True End;
   if Sender=N3Erfahrener then
    Begin Tiefe:=3;N3Erfahrener.Checked:=True End;
   if Sender=N4Fortgeschrittener then
    Begin Tiefe:=4;N4Fortgeschrittener.Checked:=True End;
   if Sender=N5Koenner then
    Begin Tiefe:=5;N5Koenner.Checked:=True End;
   if Sender=N6Meister then
    Begin Tiefe:=6;N6Meister.Checked:=True End;
   if Sender=N7Grossmeister then
    Begin Tiefe:=7;N7Grossmeister.Checked:=True End;
   if Sender=N8Weltmeister then
    Begin Tiefe:=8;N8Weltmeister.Checked:=True End;
   if Sender=N9Genie then
    Begin Tiefe:=9;N9Genie.Checked:=True End;
   if Sender=N10Superhirn then
    Begin Tiefe:=10;N10Superhirn.Checked:=True End;
   if Sender=N11AlbertEinstein then
    Begin Tiefe:=11;N11AlbertEinstein.Checked:=True End;
    // neue Level einfgen!!!
   LabelTiefe.Caption:=IntToStr(Tiefe);
  End;

 procedure TTTT3D.WerBeginnt(Sender: TObject);
  Begin
   if Sender=Menschbeginnt then
    Begin
     Dran:=Mensch;
     ZweiSpielerModus:=False;
     Menschbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
    End;
   if Sender=Computerbeginnt then
    Begin
     Dran:=Computer;
     ZweiSpielerModus:=False;
     Computerbeginnt.Checked:=True;
     Zugvorschlag.Enabled:=True;
     Zugbewertung.Enabled:=True;
     Staerke.Enabled:=True;
     WarnHinweis.Enabled:=True;
    End;
   if Sender=MenschgegenMensch then
    Begin
     Dran:=Mensch;
     ZweiSpielerModus:=True;
     MenschgegenMensch.Checked:=True;
     LabelTiefe.Caption:='';
     Zugvorschlag.Enabled:=False;
     Zugruecknahme.Enabled:=False;
     Zugbewertung.Enabled:=False;
     Staerke.Enabled:=False;
     WarnHinweis.Enabled:=False;
    End;
  End;

 procedure TTTT3D.ZugbewertungClick(Sender: TObject);
  Begin
   if MessageDlg('Soll die Bewertung angezeigt werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Die Bewertunganzeige ist aktiv!',mtInformation,[mbOk],0);
     Anzeigen:=True;Ausgabe.Visible:=True
    End
   else Begin Ausgabe.Visible:=False;Anzeigen:=False End
  End;

 procedure TTTT3D.ZugvorschlagClick(Sender: TObject);
  var VirFeld:SpielFeld;
      VirB:Bewertung;
      Zug:SpielZug;
      Ebene,Spalte,Zeile:Byte;
  Begin
   VirFeld:=F;VirB:=B;Screen.Cursor:=crHourGlass;
   LabelStatus.Caption:='Ich suche fr Dich!';
   SucheVorschlag(Zug,VirFeld,VirB);Screen.Cursor:=crHandPoint;
   Ebene:=Zug div 9+1;if Zug mod 9=0 then dec(Ebene);
   Spalte:=Zug mod 3;Zeile:=(Zug-(Ebene-1)*9) div 3+1;
   if Spalte=0 then Begin Spalte:=3;dec(Zeile) End;
   ShowMessage('Mein Vorschlag'+#13+'setze jetzt auf E'+IntToStr(4-Ebene)
                +' S'+IntToStr(Spalte)+' Z'+IntToStr(4-Zeile));
   LabelStatus.Caption:='Dein Zug : ';
  End;

 procedure TTTT3D.ZugruecknahmeClick(Sender: TObject);
  var K,L,Anzahl:Byte;
      VirFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirB:Bewertung;
  Begin
   if ZugNummer>1 then
    Begin
     TTT3D.LabelEnde.Caption:='';
     dec(ZugNummer,2);SchreibZugNummer(ZugNummer);
     F:=SpielListe[ZugNummer];B:=Werte[ZugNummer];
     SpielFeldAnzeige(F);
     if Warnung then
      Begin
       GenZugListe(F,Computer,Anzahl,ZugListe);
       for K:=1 to Anzahl do
        Begin
         VirFeld:=F;VirB:=B;Zug:=ZugListe[K];
         MachZug(VirFeld,VirB,Zug,1);
         for L:=1 to 49 do
          if (VirB[L].Wert=1) and (VirB[L].Anzahl=3) then
           with SpielFeldAusgabe.Canvas do Draw(Koordinate[Zug].X,Koordinate[Zug].Y,Warn);
        End
      End;
     LabelStatus.Caption:='Dein Zug : ';
    End
  End;

 procedure TTTT3D.InfoClick(Sender: TObject);
  Begin InfoBox.ShowModal End;

 procedure TTTT3D.RegelnClick(Sender: TObject);
  Begin RegelnBox.ShowModal End;

 procedure TTTT3D.TonClick(Sender: TObject);
  Begin
   if MessageDlg('Soll der Sound aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Der Sound ist aktiv!',mtInformation,[mbOk],0);
     SoundAn:=True;
    End
   else SoundAn:=False;
  End;

 procedure TTTT3D.FormCreate(Sender: TObject);
 const ScreenHeightDev=768;ScreenWidthDev=1024;
  var E,I,K,L:Byte;
      Zeile:String;
      x,y:Integer;
  Begin
   Leer:=TBitMap.Create;
   Leer.LoadFromFile('Leer.bmp');
   Leer.Transparent:=True;
   Rot:=TBitMap.Create;
   Rot.LoadFromFile('rot.bmp');
   Rot.Transparent:=True;
   Gruen:=TBitMap.Create;
   Gruen.LoadFromFile('grn.bmp');
   Gruen.Transparent:=True;
   RotSieg:=TBitMap.Create;
   RotSieg.LoadFromFile('RotSieg.bmp');
   RotSieg.Transparent:=True;
   GruenSieg:=TBitMap.Create;
   GruenSieg.LoadFromFile('GrnSieg.bmp');
   GruenSieg.Transparent:=True;
   GruenGesetzt:=TBitMap.Create;
   GruenGesetzt.LoadFromFile('GrnGesetzt.bmp');
   GruenGesetzt.Transparent:=True;
   RotGesetzt:=TBitMap.Create;
   RotGesetzt.LoadFromFile('RotGesetzt.bmp');
   RotGesetzt.Transparent:=True;
   Warn:=TBitMap.Create;
   Warn.LoadFromFile('Warnung.bmp');
   Warn.Transparent:=True;
   Bild:=TBitMap.Create;
   Scaled:=True;x:=Screen.width;y:=screen.height;
   if (y<>ScreenHeightDev) or (x<>ScreenWidthDev) then
    Begin
     Height:=(ClientHeight*y div ScreenHeightDev)+Height-ClientHeight;
     Width:=(ClientWidth*x div ScreenWidthDev)+Height-ClientHeight;
     ScaleBy(x,ScreenwidthDev);
    End;
   Screen.Cursor:=crHandPoint;XFaktor:=100;
   MaxX:=SpielFeldAusgabe.Width;MaxY:=SpielFeldAusgabe.Height;
   Copyright;
   Init;Dran:=Computer;Tiefe:=3;
   LabelTiefe.Caption:=IntToStr(Tiefe);
   Anzeigen:=False;//Bewertungsanzeige
   Warnung:=False;// Verlustanzeige
   Ausgabe.Visible:=False;
   DarfSpielen:=False;SoundAn:=False;
   for E:=0 to 2 do { Gewinnreihen in den drei Ebenen, 8 pro Ebene }
    for K:=1 to 3 do
     Begin
      for L:=1 to 3 do Reihe[L+8*E].FeldNr[K]:=(L-1)*3+K+9*E;
      for L:=4 to 6 do Reihe[L+8*E].FeldNr[K]:=K*3+L-6+9*E;
      Reihe[7+8*E].FeldNr[K]:=1+4*(K-1)+9*E;
      Reihe[8+8*E].FeldNr[K]:=7-2*(K-1)+9*E;
     End;
   for L:=1 to 9 do { 9 senkrechte Gewinnreihen }
    for K:=1 to 3 do Reihe[24+L].FeldNr[K]:=L+9*(K-1);
   for L:=0 to 2 do  { je 3 Raumdiagonalen aus den Ecken }
    for K:=1 to 3 do
     Begin
      Reihe[34+L].FeldNr[K]:=1+(K-1)*(10+(5*L-L*L)div 2);
      Reihe[37+L].FeldNr[K]:=3+(K-1)*(8-L*L+4*L);
      Reihe[40+L].FeldNr[K]:=7+(K-1)*(6+L*L);
      Reihe[43+L].FeldNr[K]:=9+(K-1)*(5+(L*L+L)div 2);
     End;
    for K:=1 to 3 do { 4 Diagonalen von den Seiten unten nach oben }
     Begin
      Reihe[46].FeldNr[K]:=2+12*(K-1);
      Reihe[47].FeldNr[K]:=4+10*(K-1);
      Reihe[48].FeldNr[K]:=6+8*(K-1);
      Reihe[49].FeldNr[K]:=8+6*(K-1)
     End;
   Ausgabe.Lines.Add('Gewinnreihen');
   for L:=1 to 49 do
    Begin
     Zeile:=IntToStr(L)+') ';
     for K:=1 to 2 do Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[K])+' - ';
     Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[3]);
     Ausgabe.Lines.Add(Zeile);
    End;
   for I:=1 to 27 do
    with F do
    Begin
     Brett[I].Art:=0;Brett[I].Anzahl:=0;
     for L:=1 to 49 do
      for K:=1 to 3 do
       if Reihe[L].FeldNr[K]=I then
        Begin inc(Brett[I].Anzahl);Brett[I].Gewinnreihe[Brett[I].Anzahl]:=L End
    End;
   Ausgabe.Lines.Add('');
   Ausgabe.Lines.Add('Feldinhalte');
   for I:=1 to 27 do
    Begin
     Zeile:=IntToStr(I)+') ';
     for K:=1 to F.Brett[I].Anzahl-1 do
      Zeile:=Zeile+IntToStr(F.Brett[I].Gewinnreihe[K])+' - ';
     Zeile:=Zeile+IntToStr(F.Brett[I].Gewinnreihe[F.Brett[I].Anzahl]);
     Ausgabe.Lines.Add(Zeile);
    End;
   FAlt:=F;
  End;

 procedure TTTT3D.WarnHinweisClick(Sender: TObject);
  Begin
   if MessageDlg('Soll die Hinweiswarnung aktiviert werden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    Begin
     MessageDlg('Der Hinweiswarnung ist aktiv!',mtInformation,[mbOk],0);
     Warnung:=True;
    End
   else Warnung:=False;
  End;

End.

